{"imports":["@endo/marshal","@agoric/store","./mathHelpers/natMathHelpers.js","./mathHelpers/setMathHelpers.js","./mathHelpers/copySetMathHelpers.js","./mathHelpers/copyBagMathHelpers.js"],"exports":["AmountMath","AssetKind","assertAssetKind","assertValueGetHelpers","getAssetKind"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let passStyleOf,assertRemotable,assertRecord,M,matches,natMathHelpers,setMathHelpers,copySetMathHelpers,copyBagMathHelpers;$h‍_imports([[\"@endo/marshal\", [[\"passStyleOf\", [$h‍_a => (passStyleOf = $h‍_a)]],[\"assertRemotable\", [$h‍_a => (assertRemotable = $h‍_a)]],[\"assertRecord\", [$h‍_a => (assertRecord = $h‍_a)]]]],[\"@agoric/store\", [[\"M\", [$h‍_a => (M = $h‍_a)]],[\"matches\", [$h‍_a => (matches = $h‍_a)]]]],[\"./mathHelpers/natMathHelpers.js\", [[\"natMathHelpers\", [$h‍_a => (natMathHelpers = $h‍_a)]]]],[\"./mathHelpers/setMathHelpers.js\", [[\"setMathHelpers\", [$h‍_a => (setMathHelpers = $h‍_a)]]]],[\"./mathHelpers/copySetMathHelpers.js\", [[\"copySetMathHelpers\", [$h‍_a => (copySetMathHelpers = $h‍_a)]]]],[\"./mathHelpers/copyBagMathHelpers.js\", [[\"copyBagMathHelpers\", [$h‍_a => (copyBagMathHelpers = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\nconst{quote:q,Fail}=assert;\n\n/**\n * Constants for the kinds of assets we support.\n *\n * @type {{ NAT: 'nat', SET: 'set', COPY_SET: 'copySet', COPY_BAG: 'copyBag' }}\n */\nconst AssetKind=harden({\nNAT:'nat',\nSET:'set',\nCOPY_SET:'copySet',\nCOPY_BAG:'copyBag'});$h‍_once.AssetKind(AssetKind);\n\nconst assetKindNames=harden(Object.values(AssetKind).sort());\n\n/**\n * @param {AssetKind} allegedAK\n */\nconst assertAssetKind=(allegedAK)=>{\nassetKindNames.includes(allegedAK)||\nFail `The assetKind ${allegedAK} must be one of ${q(assetKindNames)}`;\n };$h‍_once.assertAssetKind(assertAssetKind);\nharden(assertAssetKind);\n\n/**\n * Amounts describe digital assets. From an amount, you can learn the\n * brand of digital asset as well as \"how much\" or \"how many\". Amounts\n * have two parts: a brand (loosely speaking, the type of digital\n * asset) and the value (the answer to \"how much\"). For example, in\n * the phrase \"5 bucks\", \"bucks\" takes the role of the brand and the\n * value is 5. Amounts can describe fungible and non-fungible digital\n * assets. Amounts are pass-by-copy and can be made by and sent to\n * anyone.\n *\n * The issuer is the authoritative source of the amount in payments\n * and purses. The issuer must be able to do things such as add\n * digital assets to a purse and withdraw digital assets from a purse.\n * To do so, it must know how to add and subtract digital assets.\n * Rather than hard-coding a particular solution, we chose to\n * parameterize the issuer with a collection of polymorphic functions,\n * which we call `AmountMath`. These math functions include concepts\n * like addition, subtraction, and greater than or equal to.\n *\n * We also want to make sure there is no confusion as to what kind of\n * asset we are using. Thus, AmountMath includes checks of the\n * `brand`, the unique identifier for the type of digital asset. If\n * the wrong brand is used in AmountMath, an error is thrown and the\n * operation does not succeed.\n *\n * AmountMath uses mathHelpers to do most of the work, but then adds\n * the brand to the result. The function `value` gets the value from\n * the amount by removing the brand (amount -> value), and the\n * function `make` adds the brand to produce an amount (value ->\n * amount). The function `coerce` takes an amount and checks it,\n * returning an amount (amount -> amount).\n *\n * Each issuer of digital assets has an associated brand in a\n * one-to-one mapping. In untrusted contexts, such as in analyzing\n * payments and amounts, we can get the brand and find the issuer\n * which matches the brand. The issuer and the brand mutually validate\n * each other.\n */\n\nconst helpers={\nnat:natMathHelpers,\nset:setMathHelpers,\ncopySet:copySetMathHelpers,\ncopyBag:copyBagMathHelpers};\n\n\n/**\n * @template {AmountValue} V\n * @type {(value: V) => AssetKindForValue<V>}\n */\nconst assertValueGetAssetKind=(value)=>{\nconst passStyle=passStyleOf(value);\nif(passStyle==='bigint'){\n/* @ts-expect-error cast*/\nreturn'nat';\n }\nif(passStyle==='copyArray'){\n/* @ts-expect-error cast*/\nreturn'set';\n }\nif(matches(value,M.set())){\n/* @ts-expect-error cast*/\nreturn'copySet';\n }\nif(matches(value,M.bag())){\n/* @ts-expect-error cast*/\nreturn'copyBag';\n }\n/* TODO This isn't quite the right error message, in case valuePassStyle*/\n/* is 'tagged'. We would need to distinguish what kind of tagged*/\n/* object it is.*/\n/* Also, this kind of manual listing is a maintenance hazard we*/\n/* (TODO) will encounter when we extend the math helpers further.*/\nthrow Fail `value ${value} must be a bigint, copySet, copyBag, or an array, not ${q(\npassStyle)\n }`;\n };\n\n/**\n * Asserts that value is a valid AmountMath and returns the appropriate helpers.\n *\n * Made available only for testing, but it is harmless for other uses.\n *\n * @template {AmountValue} V\n * @param {V} value\n * @returns {MathHelpers<V>}\n */\nconst        assertValueGetHelpers=(value)=>\n/* @ts-expect-error cast*/\nhelpers[assertValueGetAssetKind(value)];\n\n/** @type {(allegedBrand: Brand, brand?: Brand) => void} */$h‍_once.assertValueGetHelpers(assertValueGetHelpers);\nconst optionalBrandCheck=(allegedBrand,brand)=>{\nif(brand!==undefined){\nassertRemotable(brand,'brand');\nallegedBrand===brand||\nFail `amount's brand ${q(allegedBrand)} did not match expected brand ${q(\nbrand)\n }`;\n }\n };\n\n/**\n * @template {AssetKind} K\n * @param {Amount<K>} leftAmount\n * @param {Amount<K>} rightAmount\n * @param {Brand<K> | undefined} brand\n * @returns {MathHelpers<*>}\n */\nconst checkLRAndGetHelpers=(leftAmount,rightAmount,brand=undefined)=>{\nassertRecord(leftAmount,'leftAmount');\nassertRecord(rightAmount,'rightAmount');\nconst{value:leftValue,brand:leftBrand}=leftAmount;\nconst{value:rightValue,brand:rightBrand}=rightAmount;\nassertRemotable(leftBrand,'leftBrand');\nassertRemotable(rightBrand,'rightBrand');\noptionalBrandCheck(leftBrand,brand);\noptionalBrandCheck(rightBrand,brand);\nleftBrand===rightBrand||\nFail `Brands in left ${q(leftBrand)} and right ${q(\nrightBrand)\n } should match but do not`;\nconst leftHelpers=assertValueGetHelpers(leftValue);\nconst rightHelpers=assertValueGetHelpers(rightValue);\nleftHelpers===rightHelpers||\nFail `The left ${leftAmount} and right amount ${rightAmount} had different assetKinds`;\nreturn leftHelpers;\n };\n\n/**\n * @template {AssetKind} K\n * @param {MathHelpers<AssetValueForKind<K>>} h\n * @param {Amount<K>} leftAmount\n * @param {Amount<K>} rightAmount\n * @returns {[K, K]}\n */\nconst coerceLR=(h,leftAmount,rightAmount)=>{\n/* @ts-expect-error could be arbitrary subtype*/\nreturn[h.doCoerce(leftAmount.value),h.doCoerce(rightAmount.value)];\n };\n\n/**\n * Returns true if the leftAmount is greater than or equal to the\n * rightAmount. The notion of \"greater than or equal to\" depends\n * on the kind of amount, as defined by the MathHelpers. For example,\n * whether rectangle A is greater than rectangle B depends on whether rectangle\n * A includes rectangle B as defined by the logic in MathHelpers.\n *\n * @template {AssetKind} K\n * @param {Amount<K>} leftAmount\n * @param {Amount<K>} rightAmount\n * @param {Brand<K>} [brand]\n * @returns {boolean}\n */\nconst isGTE=(leftAmount,rightAmount,brand=undefined)=>{\nconst h=checkLRAndGetHelpers(leftAmount,rightAmount,brand);\nreturn h.doIsGTE(...coerceLR(h,leftAmount,rightAmount));\n };\n\n/**\n * Logic for manipulating amounts.\n *\n * Amounts are the canonical description of tradable goods. They are manipulated\n * by issuers and mints, and represent the goods and currency carried by purses\n * and\n * payments. They can be used to represent things like currency, stock, and the\n * abstract right to participate in a particular exchange.\n */\nconst AmountMath={\n/**\n * Make an amount from a value by adding the brand.\n *\n * @template {AssetKind} K\n * @param {Brand<K>} brand\n * @param {AssetValueForKind<K>} allegedValue\n * @returns {Amount<K>}\n */\n/* allegedValue has a conditional expression for type widening, to prevent V being bound to a a literal like 1n*/\nmake:(brand,allegedValue)=>{\nassertRemotable(brand,'brand');\nconst h=assertValueGetHelpers(allegedValue);\nconst value=h.doCoerce(allegedValue);\nreturn harden({brand,value});\n },\n/**\n * Make sure this amount is valid enough, and return a corresponding\n * valid amount if so.\n *\n * @template {AssetKind} K\n * @param {Brand<K>} brand\n * @param {Amount<K>} allegedAmount\n * @returns {Amount<K>}\n */\ncoerce:(brand,allegedAmount)=>{\nassertRemotable(brand,'brand');\nassertRecord(allegedAmount,'amount');\nconst{brand:allegedBrand,value:allegedValue}=allegedAmount;\nbrand===allegedBrand||\nFail `The brand in the allegedAmount ${allegedAmount} in 'coerce' didn't match the specified brand ${brand}.`;\n/* Will throw on inappropriate value*/\nreturn AmountMath.make(brand,allegedValue);\n },\n/**\n * Extract and return the value.\n *\n * @template {AssetKind} K\n * @param {Brand<K>} brand\n * @param {Amount<K>} amount\n * @returns {AssetValueForKind<K>}\n */\ngetValue:(brand,amount)=>AmountMath.coerce(brand,amount).value,\n/**\n * Return the amount representing an empty amount. This is the\n * identity element for MathHelpers.add and MatHelpers.subtract.\n *\n * @type {{\n *   (brand: Brand): Amount<'nat'>;\n *   <K extends AssetKind>(brand: Brand, assetKind: K): Amount<K>;\n * }}\n */\nmakeEmpty:(brand,assetKind=/** @type {const} */'nat')=>{\nassertRemotable(brand,'brand');\nassertAssetKind(assetKind);\nconst value=helpers[assetKind].doMakeEmpty();\nreturn harden({brand,value});\n },\n/**\n * Return the amount representing an empty amount, using another\n * amount as the template for the brand and assetKind.\n *\n * @template {AssetKind} K\n * @param {Amount<K>} amount\n * @returns {Amount<K>}\n */\nmakeEmptyFromAmount:(amount)=>{\nassertRecord(amount,'amount');\nconst{brand,value}=amount;\n/* @ts-expect-error cast*/\nconst assetKind=assertValueGetAssetKind(value);\n/* @ts-expect-error cast (ignore b/c erroring in CI but not my IDE)*/\nreturn AmountMath.makeEmpty(brand,assetKind);\n },\n/**\n * Return true if the Amount is empty. Otherwise false.\n *\n * @param {Amount} amount\n * @param {Brand} [brand]\n * @returns {boolean}\n */\nisEmpty:(amount,brand=undefined)=>{\nassertRecord(amount,'amount');\nconst{brand:allegedBrand,value}=amount;\nassertRemotable(allegedBrand,'brand');\noptionalBrandCheck(allegedBrand,brand);\nconst h=assertValueGetHelpers(value);\nreturn h.doIsEmpty(h.doCoerce(value));\n },\nisGTE,\n/**\n * Returns true if the leftAmount equals the rightAmount. We assume\n * that if isGTE is true in both directions, isEqual is also true\n *\n * @template {AssetKind} K\n * @param {Amount<K>} leftAmount\n * @param {Amount<K>} rightAmount\n * @param {Brand<K>} [brand]\n * @returns {boolean}\n */\nisEqual:(leftAmount,rightAmount,brand=undefined)=>{\nconst h=checkLRAndGetHelpers(leftAmount,rightAmount,brand);\nreturn h.doIsEqual(...coerceLR(h,leftAmount,rightAmount));\n },\n/**\n * Returns a new amount that is the union of both leftAmount and rightAmount.\n *\n * For fungible amount this means adding the values. For other kinds of\n * amount, it usually means including all of the elements from both\n * left and right.\n *\n * @template {AssetKind} K\n * @param {Amount<K>} leftAmount\n * @param {Amount<K>} rightAmount\n * @param {Brand<K>} [brand]\n * @returns {Amount<K>}\n */\nadd:(leftAmount,rightAmount,brand=undefined)=>{\nconst h=checkLRAndGetHelpers(leftAmount,rightAmount,brand);\nconst value=h.doAdd(...coerceLR(h,leftAmount,rightAmount));\nreturn harden({brand:leftAmount.brand,value});\n },\n/**\n * Returns a new amount that is the leftAmount minus the rightAmount\n * (i.e. everything in the leftAmount that is not in the\n * rightAmount). If leftAmount doesn't include rightAmount\n * (subtraction results in a negative), throw  an error. Because the\n * left amount must include the right amount, this is NOT equivalent\n * to set subtraction.\n *\n * @template {AssetKind} K\n * @param {Amount<K>} leftAmount\n * @param {Amount<K>} rightAmount\n * @param {Brand<K>} [brand]\n * @returns {Amount<K>}\n */\nsubtract:(leftAmount,rightAmount,brand=undefined)=>{\nconst h=checkLRAndGetHelpers(leftAmount,rightAmount,brand);\nconst value=h.doSubtract(...coerceLR(h,leftAmount,rightAmount));\nreturn harden({brand:leftAmount.brand,value});\n },\n/**\n * Returns the min value between x and y using isGTE\n *\n * @template {AssetKind} K\n * @param {Amount<K>} x\n * @param {Amount<K>} y\n * @param {Brand<K>} [brand]\n * @returns {Amount<K>}\n */\nmin:(x,y,brand=undefined)=>\n/* eslint-disable-next-line no-nested-ternary*/\nisGTE(x,y,brand)?\ny:\nisGTE(y,x,brand)?\nx:\nFail `${x} and ${y} are incomparable`,\n/**\n * Returns the max value between x and y using isGTE\n *\n * @template {AssetKind} K\n * @param {Amount<K>} x\n * @param {Amount<K>} y\n * @param {Brand<K>} [brand]\n * @returns {Amount<K>}\n */\nmax:(x,y,brand=undefined)=>\n/* eslint-disable-next-line no-nested-ternary*/\nisGTE(x,y,brand)?\nx:\nisGTE(y,x)?\ny:\nFail `${x} and ${y} are incomparable`};$h‍_once.AmountMath(AmountMath);\n\nharden(AmountMath);\n\n/**\n * @param {Amount} amount\n */\nconst getAssetKind=(amount)=>{\nassertRecord(amount,'amount');\nconst{value}=amount;\n/* @ts-expect-error cast (ignore b/c erroring in CI but not my IDE)*/\nreturn assertValueGetAssetKind(value);\n };$h‍_once.getAssetKind(getAssetKind);\nharden(getAssetKind);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"AssetKind":["AssetKind"],"assertAssetKind":["assertAssetKind"],"AmountMath":["AmountMath"],"getAssetKind":["getAssetKind"],"assertValueGetHelpers":["assertValueGetHelpers"]},"__needsImportMeta__":false}