{"imports":["@agoric/assert","@agoric/store","@agoric/vat-data","./amountMath.js","./displayInfo.js","./paymentLedger.js","./types-ambient.js"],"exports":["hasIssuer","makeDurableIssuerKit","makeIssuerKit","prepareIssuerKit"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let assert,assertPattern,makeScalarBigMapStore,AssetKind,assertAssetKind,coerceDisplayInfo,preparePaymentLedger;$h‍_imports([[\"@agoric/assert\", [[\"assert\", [$h‍_a => (assert = $h‍_a)]]]],[\"@agoric/store\", [[\"assertPattern\", [$h‍_a => (assertPattern = $h‍_a)]]]],[\"@agoric/vat-data\", [[\"makeScalarBigMapStore\", [$h‍_a => (makeScalarBigMapStore = $h‍_a)]]]],[\"./amountMath.js\", [[\"AssetKind\", [$h‍_a => (AssetKind = $h‍_a)]],[\"assertAssetKind\", [$h‍_a => (assertAssetKind = $h‍_a)]]]],[\"./displayInfo.js\", [[\"coerceDisplayInfo\", [$h‍_a => (coerceDisplayInfo = $h‍_a)]]]],[\"./paymentLedger.js\", [[\"preparePaymentLedger\", [$h‍_a => (preparePaymentLedger = $h‍_a)]]]],[\"./types-ambient.js\", []]]);   \n\n\n\n\n\n\n\n\n\n\n\n/** @typedef {Ximport('@agoric/vat-data').Baggage} Baggage */\n\n/**\n * @template {AssetKind} K\n * @typedef {object} IssuerRecord\n * @property {string} name\n * @property {K} assetKind\n * @property {AdditionalDisplayInfo} displayInfo\n * @property {Pattern} elementShape\n */\n\n/**\n * @template {AssetKind} K\n * @param {IssuerRecord<K>} issuerRecord\n * @param {Baggage} issuerBaggage\n * @param {ShutdownWithFailure} [optShutdownWithFailure] If this issuer fails\n * in the middle of an atomic action (which btw should never happen), it\n * potentially leaves its ledger in a corrupted state. If this function was\n * provided, then the failed atomic action will call it, so that some\n * larger unit of computation, like the enclosing vat, can be shutdown\n * before anything else is corrupted by that corrupted state.\n * See https://github.com/Agoric/agoric-sdk/issues/3434\n * @returns {IssuerKit<K>}\n */\nconst setupIssuerKit=(\n{name,assetKind,displayInfo,elementShape},\nissuerBaggage,\noptShutdownWithFailure=undefined)=>\n{\nassert.typeof(name,'string');\nassertAssetKind(assetKind);\n\n/* Add assetKind to displayInfo, or override if present*/\nconst cleanDisplayInfo=coerceDisplayInfo(displayInfo,assetKind);\nif(optShutdownWithFailure!==undefined){\nassert.typeof(optShutdownWithFailure,'function');\n }\n\nif(elementShape!==undefined){\nassertPattern(elementShape);\n }\n\n/* Attenuate the powerful authority to mint and change balances*/\n/** @type {PaymentLedger<K>} */\n/* @ts-expect-error could be instantiated with different subtype of AssetKind*/\nconst{issuer,mint,brand,mintRecoveryPurse}=preparePaymentLedger(\nissuerBaggage,\nname,\nassetKind,\ncleanDisplayInfo,\nelementShape,\noptShutdownWithFailure);\n\n\nreturn harden({\nbrand,\nissuer,\nmint,\nmintRecoveryPurse,\ndisplayInfo:cleanDisplayInfo});\n\n };\nharden(setupIssuerKit);\n\n/** The key at which the issuer record is stored. */\nconst INSTANCE_KEY='issuer';\n\n/**\n * @template {AssetKind} K\n * @param {Baggage} issuerBaggage\n * @param {ShutdownWithFailure} [optShutdownWithFailure] If this issuer fails\n * in the middle of an atomic action (which btw should never happen), it\n * potentially leaves its ledger in a corrupted state. If this function was\n * provided, then the failed atomic action will call it, so that some\n * larger unit of computation, like the enclosing vat, can be shutdown\n * before anything else is corrupted by that corrupted state.\n * See https://github.com/Agoric/agoric-sdk/issues/3434\n * @returns {IssuerKit<K>}\n */\nconst        prepareIssuerKit=(\nissuerBaggage,\noptShutdownWithFailure=undefined)=>\n{\nconst issuerRecord=issuerBaggage.get(INSTANCE_KEY);\nreturn setupIssuerKit(issuerRecord,issuerBaggage,optShutdownWithFailure);\n };$h‍_once.prepareIssuerKit(prepareIssuerKit);\nharden(prepareIssuerKit);\n\n/**\n * Does baggage already have an issuer from prepareIssuerKit()?\n * That is: does it have the relevant keys defined?\n *\n * @param {Baggage} baggage\n */\nconst        hasIssuer=(baggage)=>baggage.has(INSTANCE_KEY);\n\n/**\n * @typedef {Partial<{elementShape: Pattern}>} IssuerOptionsRecord\n */\n\n/**\n * @template {AssetKind} K\n * The name becomes part of the brand in asset descriptions.\n * The name is useful for debugging and double-checking\n * assumptions, but should not be trusted wrt any external namespace.\n * For example, anyone could create a new issuer kit with name 'BTC', but\n * it is not bitcoin or even related. It is only the name according\n * to that issuer and brand.\n *\n * The assetKind will be used to import a specific mathHelpers\n * from the mathHelpers library. For example, natMathHelpers, the\n * default, is used for basic fungible tokens.\n *\n *  `displayInfo` gives information to the UI on how to display the amount.\n *\n * @param {Baggage} issuerBaggage\n * @param {string} name\n * @param {K} [assetKind=AssetKind.NAT]\n * @param {AdditionalDisplayInfo} [displayInfo={}]\n * @param {ShutdownWithFailure} [optShutdownWithFailure] If this issuer fails\n * in the middle of an atomic action (which btw should never happen), it\n * potentially leaves its ledger in a corrupted state. If this function was\n * provided, then the failed atomic action will call it, so that some\n * larger unit of computation, like the enclosing vat, can be shutdown\n * before anything else is corrupted by that corrupted state.\n * See https://github.com/Agoric/agoric-sdk/issues/3434\n * @param {IssuerOptionsRecord} [options]\n * @returns {IssuerKit<K>}\n */$h‍_once.hasIssuer(hasIssuer);\nconst        makeDurableIssuerKit=(\nissuerBaggage,\nname,\n/* @ts-expect-error K could be instantiated with a different subtype of AssetKind*/\nassetKind=AssetKind.NAT,\ndisplayInfo=harden({}),\noptShutdownWithFailure=undefined,\n{elementShape=undefined}={})=>\n{\nconst issuerData=harden({name,assetKind,displayInfo,elementShape});\nissuerBaggage.init(INSTANCE_KEY,issuerData);\nreturn setupIssuerKit(issuerData,issuerBaggage,optShutdownWithFailure);\n };$h‍_once.makeDurableIssuerKit(makeDurableIssuerKit);\nharden(makeDurableIssuerKit);\n\n/**\n * @template {AssetKind} [K='nat']\n * The name becomes part of the brand in asset descriptions.\n * The name is useful for debugging and double-checking\n * assumptions, but should not be trusted wrt any external namespace.\n * For example, anyone could create a new issuer kit with name 'BTC', but\n * it is not bitcoin or even related. It is only the name according\n * to that issuer and brand.\n *\n * The assetKind will be used to import a specific mathHelpers\n * from the mathHelpers library. For example, natMathHelpers, the\n * default, is used for basic fungible tokens.\n *\n *  `displayInfo` gives information to the UI on how to display the amount.\n *\n * @param {string} name\n * @param {K} [assetKind='nat']\n * @param {AdditionalDisplayInfo} [displayInfo={}]\n * @param {ShutdownWithFailure} [optShutdownWithFailure] If this issuer fails\n * in the middle of an atomic action (which btw should never happen), it\n * potentially leaves its ledger in a corrupted state. If this function was\n * provided, then the failed atomic action will call it, so that some\n * larger unit of computation, like the enclosing vat, can be shutdown\n * before anything else is corrupted by that corrupted state.\n * See https://github.com/Agoric/agoric-sdk/issues/3434\n * @param {IssuerOptionsRecord} [options]\n * @returns {IssuerKit<K>}\n */\nconst        makeIssuerKit=(\nname,\n/* @ts-expect-error K could be instantiated with a different subtype of AssetKind*/\nassetKind=AssetKind.NAT,\ndisplayInfo=harden({}),\noptShutdownWithFailure=undefined,\n{elementShape=undefined}={})=>\n\nmakeDurableIssuerKit(\nmakeScalarBigMapStore('dropped issuer kit',{durable:true}),\nname,\nassetKind,\ndisplayInfo,\noptShutdownWithFailure,\n{elementShape});$h‍_once.makeIssuerKit(makeIssuerKit);\n\nharden(makeIssuerKit);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"prepareIssuerKit":["prepareIssuerKit"],"hasIssuer":["hasIssuer"],"makeDurableIssuerKit":["makeDurableIssuerKit"],"makeIssuerKit":["makeIssuerKit"]},"__needsImportMeta__":false}