{"imports":["@endo/promise-kit","@agoric/store","@agoric/vat-data","./amountMath.js","./payment.js","./purse.js","@agoric/store/exported.js","./typeGuards.js"],"exports":["preparePaymentLedger"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let isPromise,mustMatch,M,keyEQ,provideDurableWeakMapStore,prepareExo,provide,AmountMath,preparePaymentKind,preparePurseKind,BrandI,makeIssuerInterfaces;$h‍_imports([[\"@endo/promise-kit\", [[\"isPromise\", [$h‍_a => (isPromise = $h‍_a)]]]],[\"@agoric/store\", [[\"mustMatch\", [$h‍_a => (mustMatch = $h‍_a)]],[\"M\", [$h‍_a => (M = $h‍_a)]],[\"keyEQ\", [$h‍_a => (keyEQ = $h‍_a)]]]],[\"@agoric/vat-data\", [[\"provideDurableWeakMapStore\", [$h‍_a => (provideDurableWeakMapStore = $h‍_a)]],[\"prepareExo\", [$h‍_a => (prepareExo = $h‍_a)]],[\"provide\", [$h‍_a => (provide = $h‍_a)]]]],[\"./amountMath.js\", [[\"AmountMath\", [$h‍_a => (AmountMath = $h‍_a)]]]],[\"./payment.js\", [[\"preparePaymentKind\", [$h‍_a => (preparePaymentKind = $h‍_a)]]]],[\"./purse.js\", [[\"preparePurseKind\", [$h‍_a => (preparePurseKind = $h‍_a)]]]],[\"@agoric/store/exported.js\", []],[\"./typeGuards.js\", [[\"BrandI\", [$h‍_a => (BrandI = $h‍_a)]],[\"makeIssuerInterfaces\", [$h‍_a => (makeIssuerInterfaces = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n/** @typedef {Ximport('@agoric/vat-data').Baggage} Baggage */\n\nconst{details:X,quote:q,Fail}=assert;\n\n/**\n * @param {Brand} brand\n * @param {AssetKind} assetKind\n * @param {Pattern} elementShape\n */\nconst amountShapeFromElementShape=(brand,assetKind,elementShape)=>{\nlet valueShape;\nswitch(assetKind){\ncase'nat':{\nvalueShape=M.nat();\nelementShape===undefined||\nFail `Fungible assets cannot have an elementShape: ${q(elementShape)}`;\nbreak;\n }\ncase'set':{\nif(elementShape===undefined){\nvalueShape=M.arrayOf(M.key());\n }else{\nvalueShape=M.arrayOf(M.and(M.key(),elementShape));\n }\nbreak;\n }\ncase'copySet':{\nif(elementShape===undefined){\nvalueShape=M.set();\n }else{\nvalueShape=M.setOf(elementShape);\n }\nbreak;\n }\ncase'copyBag':{\nif(elementShape===undefined){\nvalueShape=M.bag();\n }else{\nvalueShape=M.bagOf(elementShape);\n }\nbreak;\n }\ndefault:{\nFail `unexpected asset kind ${q(assetKind)}`;\n }}\n\n\nconst amountShape=harden({\nbrand,/* matches only this exact brand*/\nvalue:valueShape});\n\nreturn amountShape;\n };\n\n/**\n * Make the paymentLedger, the source of truth for the balances of\n * payments. All minting and transfer authority originates here.\n *\n * @template {AssetKind} K\n * @param {Baggage} issuerBaggage\n * @param {string} name\n * @param {K} assetKind\n * @param {DisplayInfo<K>} displayInfo\n * @param {Pattern} elementShape\n * @param {ShutdownWithFailure} [optShutdownWithFailure]\n * @returns {PaymentLedger<K>}\n */\nconst        preparePaymentLedger=(\nissuerBaggage,\nname,\nassetKind,\ndisplayInfo,\nelementShape,\noptShutdownWithFailure=undefined)=>\n{\n/** @type {Brand<K>} */\n/* @ts-expect-error XXX callWhen*/\nconst brand=prepareExo(issuerBaggage, `${name} brand`,BrandI,{\nisMyIssuer(allegedIssuer){\n/* BrandI delays calling this method until `allegedIssuer` is a Remotable*/\nreturn allegedIssuer===issuer;\n },\ngetAllegedName(){\nreturn name;\n },\n/* Give information to UI on how to display the amount.*/\ngetDisplayInfo(){\nreturn displayInfo;\n },\ngetAmountShape(){\nreturn amountShape;\n }});\n\n\nconst amountShape=amountShapeFromElementShape(\nbrand,\nassetKind,\nelementShape);\n\n\nconst{IssuerI,MintI,PaymentI,PurseIKit}=makeIssuerInterfaces(\nbrand,\nassetKind,\namountShape);\n\n\nconst makePayment=preparePaymentKind(issuerBaggage,name,brand,PaymentI);\n\n/** @type {ShutdownWithFailure} */\nconst shutdownLedgerWithFailure=(reason)=>{\n/* TODO This should also destroy ledger state.*/\n/* See https://github.com/Agoric/agoric-sdk/issues/3434*/\nif(optShutdownWithFailure!==undefined){\ntry{\noptShutdownWithFailure(reason);\n }catch(errInShutdown){\nassert.note(errInShutdown,X `Caused by: ${reason}`);\nthrow errInShutdown;\n }\n }\nthrow reason;\n };\n\n/** @type {WeakMapStore<Payment, Amount>} */\nconst paymentLedger=provideDurableWeakMapStore(\nissuerBaggage,\n'paymentLedger',\n{valueShape:amountShape});\n\n\n/**\n * A withdrawn live payment is associated with the recovery set of\n * the purse it was withdrawn from. Let's call these \"recoverable\"\n * payments. All recoverable payments are live, but not all live\n * payments are recoverable. We do the bookkeeping for payment recovery\n * with this weakmap from recoverable payments to the recovery set they are\n * in.\n * A bunch of interesting invariants here:\n *    * Every payment that is a key in the outer `paymentRecoverySets`\n *      weakMap is also in the recovery set indexed by that payment.\n *    * Implied by the above but worth stating: the payment is only\n *      in at most one recovery set.\n *    * A recovery set only contains such payments.\n *    * Every purse is associated with exactly one recovery set unique to\n *      it.\n *    * A purse's recovery set only contains payments withdrawn from\n *      that purse and not yet consumed.\n *\n * @type {WeakMapStore<Payment, SetStore<Payment>>}\n */\nconst paymentRecoverySets=provideDurableWeakMapStore(\nissuerBaggage,\n'paymentRecoverySets');\n\n\n/**\n * To maintain the invariants listed in the `paymentRecoverySets` comment,\n * `initPayment` should contain the only\n * call to `paymentLedger.init`.\n *\n * @param {Payment} payment\n * @param {Amount} amount\n * @param {SetStore<Payment>} [optRecoverySet]\n */\nconst initPayment=(payment,amount,optRecoverySet=undefined)=>{\nif(optRecoverySet!==undefined){\noptRecoverySet.add(payment);\npaymentRecoverySets.init(payment,optRecoverySet);\n }\npaymentLedger.init(payment,amount);\n };\n\n/**\n * To maintain the invariants listed in the `paymentRecoverySets` comment,\n * `deletePayment` should contain the only\n * call to `paymentLedger.delete`.\n *\n * @param {Payment} payment\n */\nconst deletePayment=(payment)=>{\npaymentLedger.delete(payment);\nif(paymentRecoverySets.has(payment)){\nconst recoverySet=paymentRecoverySets.get(payment);\npaymentRecoverySets.delete(payment);\nrecoverySet.delete(payment);\n }\n };\n\n/** @type {(left: Amount, right: Amount) => Amount } */\nconst add=(left,right)=>AmountMath.add(left,right,brand);\n/** @type {(left: Amount, right: Amount) => Amount } */\nconst subtract=(left,right)=>AmountMath.subtract(left,right,brand);\n/** @type {(allegedAmount: Amount) => Amount} */\nconst coerce=(allegedAmount)=>AmountMath.coerce(brand,allegedAmount);\n/** @type {(left: Amount, right: Amount) => boolean } */\n\n/**\n * Methods like deposit() have an optional second parameter\n * `optAmountShape`\n * which, if present, is supposed to match the balance of the\n * payment. This helper function does that check.\n *\n * Note: `optAmountShape` is user-supplied with no previous validation.\n *\n * @param {Amount} paymentBalance\n * @param {Pattern} [optAmountShape]\n * @returns {void}\n */\nconst assertAmountConsistent=(paymentBalance,optAmountShape)=>{\nif(optAmountShape!==undefined){\nmustMatch(paymentBalance,optAmountShape,'amount');\n }\n };\n\n/**\n * @param {Payment} payment\n * @returns {void}\n */\nconst assertLivePayment=(payment)=>{\npaymentLedger.has(payment)||\nFail `${payment} was not a live payment for brand ${q(\nbrand)\n }. It could be a used-up payment, a payment for another brand, or it might not be a payment at all.`;\n };\n\n/**\n * Used by the purse code to implement purse.deposit\n *\n * @param {Amount} currentBalance - the current balance of the purse\n * before a deposit\n * @param {(newPurseBalance: Amount) => void} updatePurseBalance -\n * commit the purse balance\n * @param {Payment} srcPayment\n * @param {Pattern} [optAmountShape]\n * @returns {Amount}\n */\nconst depositInternal=(\ncurrentBalance,\nupdatePurseBalance,\nsrcPayment,\noptAmountShape=undefined)=>\n{\n!isPromise(srcPayment)||\nassert.fail(\n `deposit does not accept promises as first argument. Instead of passing the promise (deposit(paymentPromise)), consider unwrapping the promise first: E.when(paymentPromise, (actualPayment => deposit(actualPayment))`,\nTypeError);\n\nassertLivePayment(srcPayment);\nconst srcPaymentBalance=paymentLedger.get(srcPayment);\nassertAmountConsistent(srcPaymentBalance,optAmountShape);\nconst newPurseBalance=add(srcPaymentBalance,currentBalance);\ntry{\n/* COMMIT POINT*/\n/* Move the assets in `srcPayment` into this purse, using up the*/\n/* source payment, such that total assets are conserved.*/\ndeletePayment(srcPayment);\nupdatePurseBalance(newPurseBalance);\n }catch(err){\nshutdownLedgerWithFailure(err);\nthrow err;\n }\nreturn srcPaymentBalance;\n };\n\n/**\n * Used by the purse code to implement purse.withdraw\n *\n * @param {Amount} currentBalance - the current balance of the purse\n * before a withdrawal\n * @param {(newPurseBalance: Amount) => void} updatePurseBalance -\n * commit the purse balance\n * @param {Amount} amount - the amount to be withdrawn\n * @param {SetStore<Payment>} recoverySet\n * @returns {Payment}\n */\nconst withdrawInternal=(\ncurrentBalance,\nupdatePurseBalance,\namount,\nrecoverySet)=>\n{\namount=coerce(amount);\nAmountMath.isGTE(currentBalance,amount)||\nFail `Withdrawal of ${amount} failed because the purse only contained ${currentBalance}`;\nconst newPurseBalance=subtract(currentBalance,amount);\n\nconst payment=makePayment();\ntry{\n/* COMMIT POINT Move the withdrawn assets from this purse into*/\n/* payment. Total assets must remain conserved.*/\nupdatePurseBalance(newPurseBalance);\ninitPayment(payment,amount,recoverySet);\n }catch(err){\nshutdownLedgerWithFailure(err);\nthrow err;\n }\nreturn payment;\n };\n\nconst makeEmptyPurse=preparePurseKind(\nissuerBaggage,\nname,\nassetKind,\nbrand,\nPurseIKit,\nharden({\ndepositInternal,\nwithdrawInternal}));\n\n\n\n/** @type {Issuer<K>} */\n/* @ts-expect-error cast due to callWhen discrepancy*/\nconst issuer=prepareExo(issuerBaggage, `${name} issuer`,IssuerI,{\ngetBrand(){\nreturn brand;\n },\ngetAllegedName(){\nreturn name;\n },\ngetAssetKind(){\nreturn assetKind;\n },\ngetDisplayInfo(){\nreturn displayInfo;\n },\nmakeEmptyPurse(){\nreturn makeEmptyPurse();\n },\n/** @param {Payment} payment awaited by callWhen */\nisLive(payment){\n/* IssuerI delays calling this method until `payment` is a Remotable*/\nreturn paymentLedger.has(payment);\n },\n/** @param {Payment} payment awaited by callWhen */\ngetAmountOf(payment){\n/* IssuerI delays calling this method until `payment` is a Remotable*/\nassertLivePayment(payment);\nreturn paymentLedger.get(payment);\n },\n/**\n * @param {Payment} payment awaited by callWhen\n * @param {Pattern} optAmountShape\n */\nburn(payment,optAmountShape=undefined){\n/* IssuerI delays calling this method until `payment` is a Remotable*/\nassertLivePayment(payment);\nconst paymentBalance=paymentLedger.get(payment);\nassertAmountConsistent(paymentBalance,optAmountShape);\ntry{\n/* COMMIT POINT.*/\ndeletePayment(payment);\n }catch(err){\nshutdownLedgerWithFailure(err);\nthrow err;\n }\nreturn paymentBalance;\n }});\n\n\n/**\n * Provides for the recovery of newly minted but not-yet-deposited payments.\n *\n * Because the `mintRecoveryPurse` is placed in baggage, even if the\n * caller of `makeIssuerKit` drops it on the floor, it can still be\n * recovered in an emergency upgrade.\n *\n * @type {Purse<K>}\n */\nconst mintRecoveryPurse=provide(issuerBaggage,'mintRecoveryPurse',()=>\nmakeEmptyPurse());\n\n\n/** @type {Mint<K>} */\nconst mint=prepareExo(issuerBaggage, `${name} mint`,MintI,{\ngetIssuer(){\nreturn issuer;\n },\nmintPayment(newAmount){\n/* @ts-expect-error checked cast*/\nnewAmount=coerce(newAmount);\nmustMatch(newAmount,amountShape,'minted amount');\n/* `rawPayment` is not associated with any recovery set, and*/\n/* so must not escape.*/\nconst rawPayment=makePayment();\ninitPayment(rawPayment,newAmount,undefined);\n\nconst mintRecoveryPurseBefore=mintRecoveryPurse.getCurrentAmount();\nmintRecoveryPurse.deposit(rawPayment,newAmount);\nconst payment=mintRecoveryPurse.withdraw(newAmount);\nconst mintRecoveryPurseAfter=mintRecoveryPurse.getCurrentAmount();\nassert(keyEQ(mintRecoveryPurseBefore,mintRecoveryPurseAfter));\nreturn payment;\n }});\n\n\nconst issuerKit=harden({issuer,mint,brand,mintRecoveryPurse});\nreturn issuerKit;\n };$h‍_once.preparePaymentLedger(preparePaymentLedger);\nharden(preparePaymentLedger);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"preparePaymentLedger":["preparePaymentLedger"]},"__needsImportMeta__":false}