{"imports":[],"exports":[],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   $h‍_imports([]);   /* @jessie-check*/\n\n/*/ <reference types=\"ses\"/>*/\n\n/**\n * @template {AssetKind} [K=AssetKind]\n * @typedef {object} Amount\n * Amounts are descriptions of digital assets, answering the questions\n * \"how much\" and \"of what kind\". Amounts are values labeled with a brand.\n * AmountMath executes the logic of how amounts are changed when digital\n * assets are merged, separated, or otherwise manipulated. For\n * example, a deposit of 2 bucks into a purse that already has 3 bucks\n * gives a new purse balance of 5 bucks. An empty purse has 0 bucks. AmountMath\n * relies heavily on polymorphic MathHelpers, which manipulate the unbranded\n * portion.\n *\n * @property {Brand<K>} brand\n * @property {AssetValueForKind<K>} value\n */\n\n/**\n * @typedef {NatValue | SetValue | CopySet | CopyBag} AmountValue\n * An `AmountValue` describes a set or quantity of assets that can be owned or\n * shared.\n *\n * A fungible `AmountValue` uses a non-negative bigint to represent a quantity\n * of that many assets.\n *\n * A non-fungible `AmountValue` uses an array or CopySet of `Key`s to represent\n * a set of whatever asset each key represents. A `Key` is a passable value\n * that can be used as an element in a set (SetStore or CopySet) or as the\n * key in a map (MapStore or CopyMap).\n *\n * `SetValue` is for the deprecated set representation, using an array directly\n * to represent the array of its elements. `CopySet` is the proper\n * representation using a CopySet.\n *\n * A semi-fungible `CopyBag` is represented as a\n * `CopyBag` of `Key` objects. \"Bag\" is synonymous with MultiSet, where an\n * element of a bag can be present once or more times, i.e., some positive\n * bigint number of times, representing that quantity of the asset represented\n * by that key.\n */\n\n/**\n * @typedef {'nat' | 'set' | 'copySet' | 'copyBag' } AssetKind\n *\n * See doc-comment for `AmountValue`.\n */\n\n/**\n * @template {AssetKind} K\n * @typedef {K extends 'nat' ? NatValue :\n * K extends 'set' ? SetValue :\n * K extends 'copySet' ? CopySet:\n * K extends 'copyBag' ? CopyBag :\n * never\n * } AssetValueForKind\n */\n\n/**\n * @template {AmountValue} V\n * @typedef {V extends NatValue ? 'nat' :\n *  V extends SetValue ? 'set' :\n *  V extends CopySet ? 'copySet' :\n *  V extends CopyBag ? 'copyBag' :\n *  never} AssetKindForValue\n */\n\n/**\n * @template {AssetKind} [K=AssetKind]\n * @typedef {object} DisplayInfo\n * @property {number} [decimalPlaces] Tells the display software how\n *   many decimal places to move the decimal over to the left, or in\n *   other words, which position corresponds to whole numbers. We\n *   require fungible digital assets to be represented in integers, in\n *   the smallest unit (i.e. USD might be represented in mill, a\n *   thousandth of a dollar. In that case, `decimalPlaces` would be\n *   3.) This property is optional, and for non-fungible digital\n *   assets, should not be specified. The decimalPlaces property\n *   should be used for *display purposes only*. Any other use is an\n *   anti-pattern.\n * @property {K} assetKind - the kind of asset, either\n *   AssetKind.NAT (fungible) or\n *   AssetKind.SET or AssetKind.COPY_SET (non-fungible)\n */\n\n/**\n * @template {AssetKind} [K=AssetKind]\n * @typedef {object} Brand\n * The brand identifies the kind of issuer, and has a function to get the\n * alleged name for the kind of asset described. The alleged name (such\n * as 'BTC' or 'moola') is provided by the maker of the issuer and should\n * not be trusted as accurate.\n *\n * Every amount created by a particular AmountMath will share the same brand,\n * but recipients cannot rely on the brand to verify that a purported amount\n * represents the issuer they intended, since the same brand can be reused by\n * a misbehaving issuer.\n *\n * @property {(allegedIssuer: ERef<Issuer>) => Promise<boolean>} isMyIssuer\n * Should be used with `issuer.getBrand` to ensure an issuer and brand match.\n * @property {() => string} getAllegedName\n * @property {() => DisplayInfo<K>} getDisplayInfo\n * Give information to UI on how to display the amount.\n * @property {() => Pattern} getAmountShape\n */\n\n/* /////////////////////////// Issuer //////////////////////////////////////////*/\n\n/**\n * @callback IssuerIsLive\n *\n * Return true if the payment continues to exist.\n *\n * If the payment is a promise, the operation will proceed upon\n * resolution.\n *\n * @param {ERef<Payment>} payment\n * @returns {Promise<boolean>}\n */\n/**\n * @template {AssetKind} K\n * @callback IssuerGetAmountOf\n *\n * Get the amount of digital assets in the payment. Because the\n * payment is not trusted, we cannot call a method on it directly, and\n * must use the issuer instead.\n *\n * If the payment is a promise, the operation will proceed upon\n * resolution.\n *\n * @param {ERef<Payment>} payment\n * @returns {Promise<Amount<K>>}\n */\n\n/**\n * @callback IssuerBurn\n *\n * Burn all of the digital assets in the\n * payment. `optAmount` is optional. If `optAmount` is present, the\n * code will insist that the amount of the digital assets in the\n * payment is equal to `optAmount`, to prevent sending the wrong\n * payment and other confusion.\n *\n * If the payment is a promise, the operation will proceed upon\n * resolution.\n *\n * @param {ERef<Payment>} payment\n * @param {Pattern} [optAmountShape]\n * @returns {Promise<Amount>}\n */\n\n/**\n * @template {AssetKind} K\n * @callback IssuerClaim\n *\n * Transfer all digital assets from the payment to a new payment and\n * delete the original. `optAmount` is optional. If `optAmount` is\n * present, the code will insist that the amount of digital assets in\n * the payment is equal to `optAmount`, to prevent sending the wrong\n * payment and other confusion.\n *\n * If the payment is a promise, the operation will proceed upon\n * resolution.\n *\n * @param {ERef<Payment<K>>} payment\n * @param {Pattern} [optAmountShape]\n * @returns {Promise<Payment<K>>}\n */\n\n/**\n * @template {AssetKind} K\n * @callback IssuerCombine\n *\n * Combine multiple payments into one payment.\n *\n * If any of the payments is a promise, the operation will proceed\n * upon resolution.\n *\n * @param {ERef<Payment<K>>[]} paymentsArray\n * @param {Amount<K>} [optTotalAmount]\n * @returns {Promise<Payment<K>>}\n */\n\n/**\n * @template {AssetKind} K\n * @callback IssuerSplit\n *\n * Split a single payment into two payments,\n * A and B, according to the paymentAmountA passed in.\n *\n * If the payment is a promise, the operation will proceed upon\n * resolution.\n *\n * @param {ERef<Payment<K>>} payment\n * @param {Amount<K>} paymentAmountA\n * @returns {Promise<Payment<K>[]>}\n */\n\n/**\n * @callback IssuerSplitMany\n *\n * Split a single payment into many payments, according to the amounts\n * passed in.\n *\n * If the payment is a promise, the operation will proceed upon\n * resolution.\n *\n * @param {ERef<Payment>} payment\n * @param {Amount[]} amounts\n * @returns {Promise<Payment[]>}\n */\n\n/**\n * @template {AssetKind} [K=AssetKind]\n * @typedef {object} Issuer\n *\n * The issuer cannot mint a new amount, but it can create empty purses\n * and payments. The issuer can also transform payments (splitting\n * payments, combining payments, burning payments, and claiming\n * payments exclusively). The issuer should be gotten from a trusted\n * source and then relied upon as the decider of whether an untrusted\n * payment is valid.\n *\n * @property {() => Brand<K>} getBrand Get the Brand for this Issuer. The\n * Brand indicates the type of digital asset and is shared by the\n * mint, the issuer, and any purses and payments of this particular\n * kind. The brand is not closely held, so this function should not be\n * trusted to identify an issuer alone. Fake digital assets and amount\n * can use another issuer's brand.\n *\n * @property {() => string} getAllegedName Get the allegedName for\n * this mint/issuer\n * @property {() => AssetKind} getAssetKind Get the kind of\n * MathHelpers used by this Issuer.\n * @property {() => DisplayInfo<K>} getDisplayInfo Give information to UI\n *  on how to display amounts for this issuer.\n * @property {() => Purse<K>} makeEmptyPurse Make an empty purse of this\n * brand.\n * @property {IssuerIsLive} isLive\n * @property {IssuerGetAmountOf<K>} getAmountOf\n * @property {IssuerBurn} burn\n */\n\n/**\n * @template {AssetKind} [K=AssetKind]\n * @typedef {object} PaymentLedger\n * @property {Mint<K>} mint\n * @property {Purse<K>} mintRecoveryPurse\n * @property {Issuer<K>} issuer\n * @property {Brand<K>} brand\n */\n\n/**\n * @template {AssetKind} [K=AssetKind]\n * @typedef {object} IssuerKit\n * @property {Mint<K>} mint\n * @property {Purse<K>} mintRecoveryPurse\n * @property {Issuer<K>} issuer\n * @property {Brand<K>} brand\n * @property {DisplayInfo} displayInfo\n */\n\n/**\n * @typedef {object} AdditionalDisplayInfo\n *\n * @property {number} [decimalPlaces] Tells the display software how\n *   many decimal places to move the decimal over to the left, or in\n *   other words, which position corresponds to whole numbers. We\n *   require fungible digital assets to be represented in integers, in\n *   the smallest unit (i.e. USD might be represented in mill, a\n *   thousandth of a dollar. In that case, `decimalPlaces` would be\n *   3.) This property is optional, and for non-fungible digital\n *   assets, should not be specified. The decimalPlaces property\n *   should be used for *display purposes only*. Any other use is an\n *   anti-pattern.\n * @property {AssetKind} [assetKind]\n */\n\n/**\n * @typedef {Ximport('@agoric/swingset-vat').ShutdownWithFailure} ShutdownWithFailure\n */\n\n/**\n * @template {AssetKind} [K=AssetKind]\n * @typedef {object} Mint\n * Holding a Mint carries the right to issue new digital assets. These\n * assets all have the same kind, which is called a Brand.\n *\n * @property {() => Issuer<K>} getIssuer Gets the Issuer for this mint.\n * @property {(newAmount: Amount<K>) => Payment<K>} mintPayment\n * Creates a new Payment containing newly minted amount.\n */\n\n/**\n * @callback DepositFacetReceive\n * @param {Payment} payment\n * @param {Pattern} [optAmountShape]\n * @returns {Amount}\n */\n\n/**\n * @typedef {object} DepositFacet\n * @property {DepositFacetReceive} receive\n * Deposit all the contents of payment into the purse that made this facet,\n * returning the amount. If the optional argument `optAmount` does not equal the\n * amount of digital assets in the payment, throw an error.\n *\n * If payment is a promise, throw an error.\n */\n\n/**\n * @template {AssetKind} K\n * @callback PurseDeposit\n * @param {Payment<K>} payment\n * @param {Pattern} [optAmountShape]\n * @returns {Amount<K>}\n */\n\n/**\n * @template {AssetKind} [K=AssetKind]\n * @typedef {object} Purse\n * Purses hold amount of digital assets of the same brand, but unlike Payments,\n * they are not meant to be sent to others. To transfer digital assets, a\n * Payment should be withdrawn from a Purse. The amount of digital\n * assets in a purse can change through the action of deposit() and withdraw().\n *\n * The primary use for Purses and Payments is for currency-like and goods-like\n * digital assets, but they can also be used to represent other kinds of rights,\n * such as the right to participate in a particular contract.\n *\n * @property {() => Brand<K>} getAllegedBrand Get the alleged Brand for this Purse\n *\n * @property {() => Amount<K>} getCurrentAmount\n * Get the amount contained in this purse.\n *\n * @property {() => LatestTopic<Amount<K>>} getCurrentAmountNotifier\n * Get a lossy notifier for changes to this purse's balance.\n *\n * @property {PurseDeposit<K>} deposit\n * Deposit all the contents of payment into this purse, returning the\n * amount. If the optional argument `optAmount` does not equal the\n * amount of digital assets in the payment, throw an error.\n *\n * If payment is a promise, throw an error.\n *\n * @property {() => DepositFacet} getDepositFacet\n * Return an object whose `receive` method deposits to the current Purse.\n *\n * @property {(amount: Amount<K>) => Payment<K>} withdraw\n * Withdraw amount from this purse into a new Payment.\n *\n * @property {() => CopySet<Payment<K>>} getRecoverySet\n * The set of payments withdrawn from this purse that are still live. These\n * are the payments that can still be recovered in emergencies by, for example,\n * depositing into this purse. Such a deposit action is like canceling an\n * outstanding check because you're tired of waiting for it. Once your\n * cancellation is acknowledged, you can spend the assets at stake on other\n * things. Afterwards, if the recipient of the original check finally gets\n * around to depositing it, their deposit fails.\n *\n * @property {() => Amount<K>} recoverAll\n * For use in emergencies, such as coming back from a traumatic crash and\n * upgrade. This deposits all the payments in this purse's recovery set\n * into the purse itself, returning the total amount of assets recovered.\n */\n\n/**\n * @template {AssetKind} [K=AssetKind]\n * @typedef {object} Payment\n * Payments hold amount of digital assets of the same brand in transit. Payments\n * can be deposited in purses, split into multiple payments, combined, and\n * claimed (getting an exclusive payment). Payments are linear, meaning\n * that either a payment has the same amount of digital assets it\n * started with, or it is used up entirely. It is impossible to partially use a\n * payment.\n *\n * Payments are often received from other actors and therefore should\n * not be trusted themselves. To get the amount of digital assets in a payment,\n * use the trusted issuer: issuer.getAmountOf(payment),\n *\n * Payments can be converted to Purses by getting a trusted issuer and\n * calling `issuer.makeEmptyPurse()` to create a purse, then\n * `purse.deposit(payment)`.\n *\n * @property {() => Brand<K>} getAllegedBrand\n * Get the allegedBrand, indicating the type of digital asset this\n * payment purports to be, and which issuer to use. Because payments\n * are not trusted, any method calls on payments should be treated\n * with suspicion and verified elsewhere.\n */\n\n/**\n * @template {AmountValue} V\n * @typedef {object} MathHelpers\n * All of the difference in how digital asset amount are manipulated can be\n * reduced to the behavior of the math on values. We extract this\n * custom logic into mathHelpers. MathHelpers are about value\n * arithmetic, whereas AmountMath is about amounts, which are the\n * values labeled with a brand. AmountMath use mathHelpers to do their value\n * arithmetic, and then brand the results, making a new amount.\n *\n * The MathHelpers are designed to be called only from AmountMath, and so\n * all methods but coerce can assume their inputs are valid. They only\n * need to do output validation, and only when there is a possibility of\n * invalid output.\n *\n * @property {(allegedValue: V) => V} doCoerce\n * Check the kind of this value and throw if it is not the\n * expected kind.\n *\n * @property {() => V} doMakeEmpty\n * Get the representation for the identity element (often 0 or an\n * empty array)\n *\n * @property {(value: V) => boolean} doIsEmpty\n * Is the value the identity element?\n *\n * @property {(left: V, right: V) => boolean} doIsGTE\n * Is the left greater than or equal to the right?\n *\n * @property {(left: V, right: V) => boolean} doIsEqual\n * Does left equal right?\n *\n * @property {(left: V, right: V) => V} doAdd\n * Return the left combined with the right.\n *\n * @property {(left: V, right: V) => V} doSubtract\n * Return what remains after removing the right from the left. If\n * something in the right was not in the left, we throw an error.\n */\n\n/**\n * @typedef {bigint} NatValue\n */\n\n/**\n * @typedef {Array<Key>} SetValue\n */\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{},"__needsImportMeta__":false}