{"imports":["@agoric/store"],"exports":["AmountShape","AssetKindShape","BrandI","BrandShape","DepositFacetShape","DisplayInfoShape","IssuerKitShape","IssuerShape","MAX_ABSOLUTE_DECIMAL_PLACES","MintShape","NotifierShape","PaymentShape","PurseShape","RatioShape","isCopyBagValue","isCopySetValue","isNatValue","isSetValue","makeIssuerInterfaces"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let M,matches;$h‍_imports([[\"@agoric/store\", [[\"M\", [$h‍_a => (M = $h‍_a)]],[\"matches\", [$h‍_a => (matches = $h‍_a)]]]]]);   \n\n\n\nconst        BrandShape=M.remotable('Brand');$h‍_once.BrandShape(BrandShape);\nconst        IssuerShape=M.remotable('Issuer');$h‍_once.IssuerShape(IssuerShape);\nconst        PaymentShape=M.remotable('Payment');$h‍_once.PaymentShape(PaymentShape);\nconst        PurseShape=M.remotable('Purse');$h‍_once.PurseShape(PurseShape);\nconst        DepositFacetShape=M.remotable('DepositFacet');$h‍_once.DepositFacetShape(DepositFacetShape);\nconst        NotifierShape=M.remotable('Notifier');$h‍_once.NotifierShape(NotifierShape);\nconst        MintShape=M.remotable('Mint');\n\n/**\n * When the AmountValue of an Amount fits the NatValueShape, i.e., when it is\n * a non-negative bigint, then it represents that many units of the\n * fungible asset represented by that amount. The brand of that amount\n * should indeed represent a kind of asset consisting of a countable\n * set of fungible units.\n */$h‍_once.MintShape(MintShape);\nconst NatValueShape=M.nat();\n\n/**\n * When the AmountValue of an Amount fits the CopySetValueShape, i.e., when it\n * is a CopySet, then it represents the set of those\n * keys, where each key represents some individual non-fungible\n * item, like a concert ticket, from the non-fungible asset class\n * represented by that amount's brand. The amount itself represents\n * the set of these items, as opposed to any of the other items\n * from the same asset class.\n *\n * If a given value class represents concert tickets, it seems bizarre\n * that we can form amounts of any key. The hard constraint is that\n * the code that holds the mint for that asset class---the one associated\n * with that brand, only mints the items representing the real units\n * of that asset class as defined by it. Anyone else can put together\n * an amount expressing, for example, that they \"want\" some items that\n * will never be minted. That want will never be satisfied.\n * \"You can't always get...\"\n */\nconst CopySetValueShape=M.set();\n\n/**\n * When the AmountValue of an Amount fits the SetValueShape, i.e., when it\n * is a CopyArray of passable Keys. This representation is deprecated.\n *\n * @deprecated Please change from using array-based SetValues to CopySet-based\n * CopySetValues.\n */\nconst SetValueShape=M.arrayOf(M.key());\n\n/**\n * When the AmountValue of an Amount fits the CopyBagValueShape, i.e., when it\n * is a CopyBag, then it represents the bag (multiset) of those\n * keys, where each key represents some individual semi-fungible\n * item, like a concert ticket, from the semi-fungible asset class\n * represented by that amount's brand. The number of times that key\n * appears in the bag is the number of fungible units of that key.\n * The amount itself represents\n * the bag of these items, as opposed to any of the other items\n * from the same asset class.\n *\n * If a given value class represents concert tickets, it seems bizarre\n * that we can form amounts of any key. The hard constraint is that\n * the code that holds the mint for that asset class---the one associated\n * with that brand, only mints the items representing the real units\n * of that asset class as defined by it. Anyone else can put together\n * an amount expressing, for example, that they \"want\" some items that\n * will never be minted. That want will never be satisfied.\n * \"You can't always get...\"\n */\nconst CopyBagValueShape=M.bag();\n\nconst AmountValueShape=M.or(\nNatValueShape,\nCopySetValueShape,\nSetValueShape,\nCopyBagValueShape);\n\n\nconst        AmountShape=harden({\nbrand:BrandShape,\nvalue:AmountValueShape});$h‍_once.AmountShape(AmountShape);\n\n\nconst        RatioShape=harden({\nnumerator:AmountShape,\ndenominator:AmountShape});\n\n\n/**\n * Returns true if value is a Nat bigint.\n *\n * @param {AmountValue} value\n * @returns {value is Ximport('./types.js').NatValue}\n */$h‍_once.RatioShape(RatioShape);\nconst        isNatValue=(value)=>matches(value,NatValueShape);$h‍_once.isNatValue(isNatValue);\nharden(isNatValue);\n\n/**\n * Returns true if value is a CopySet\n *\n * @param {AmountValue} value\n * @returns {value is CopySet}\n */\nconst        isCopySetValue=(value)=>matches(value,CopySetValueShape);$h‍_once.isCopySetValue(isCopySetValue);\nharden(isCopySetValue);\n\n/**\n * Returns true if value is a pass by copy array structure. Does not\n * check for duplicates. To check for duplicates, use setMathHelpers.coerce.\n *\n * @deprecated Please change from using array-based SetValues to CopySet-based\n * CopySetValues.\n * @param {AmountValue} value\n * @returns {value is SetValue}\n */\nconst        isSetValue=(value)=>matches(value,SetValueShape);$h‍_once.isSetValue(isSetValue);\nharden(isSetValue);\n\n/**\n * Returns true if value is a CopyBag\n *\n * @param {AmountValue} value\n * @returns {value is CopyBag}\n */\nconst        isCopyBagValue=(value)=>matches(value,CopyBagValueShape);$h‍_once.isCopyBagValue(isCopyBagValue);\nharden(isCopyBagValue);\n\n/* One GOOGOLth should be enough decimal places for anybody.*/\nconst        MAX_ABSOLUTE_DECIMAL_PLACES=100;$h‍_once.MAX_ABSOLUTE_DECIMAL_PLACES(MAX_ABSOLUTE_DECIMAL_PLACES);\n\nconst        AssetKindShape=M.or('nat','set','copySet','copyBag');$h‍_once.AssetKindShape(AssetKindShape);\n\nconst        DisplayInfoShape=M.splitRecord(\n{},\n{\ndecimalPlaces:M.and(\nM.gte(-MAX_ABSOLUTE_DECIMAL_PLACES),\nM.lte(MAX_ABSOLUTE_DECIMAL_PLACES)),\n\nassetKind:AssetKindShape},\n\n{\n/* Including this empty `rest` ensures that there are no other*/\n/* properties beyond those in the `base` record.*/});$h‍_once.DisplayInfoShape(DisplayInfoShape);\n\n\n\nconst        IssuerKitShape=harden({\nbrand:BrandShape,\nmint:MintShape,\nmintRecoveryPurse:PurseShape,\nissuer:IssuerShape,\ndisplayInfo:DisplayInfoShape});\n\n\n/* //////////////////////// Interfaces /////////////////////////////////////////*/$h‍_once.IssuerKitShape(IssuerKitShape);\n\nconst        BrandI=M.interface('Brand',{\nisMyIssuer:M.callWhen(M.await(IssuerShape)).returns(M.boolean()),\ngetAllegedName:M.call().returns(M.string()),\ngetDisplayInfo:M.call().returns(DisplayInfoShape),\ngetAmountShape:M.call().returns(M.pattern())});\n\n\n/**\n * @param {Pattern} [brandShape]\n * @param {Pattern} [assetKindShape]\n * @param {Pattern} [amountShape]\n */$h‍_once.BrandI(BrandI);\nconst        makeIssuerInterfaces=(\nbrandShape=BrandShape,\nassetKindShape=AssetKindShape,\namountShape=AmountShape)=>\n{\nconst IssuerI=M.interface('Issuer',{\ngetBrand:M.call().returns(brandShape),\ngetAllegedName:M.call().returns(M.string()),\ngetAssetKind:M.call().returns(assetKindShape),\ngetDisplayInfo:M.call().returns(DisplayInfoShape),\nmakeEmptyPurse:M.call().returns(PurseShape),\n\nisLive:M.callWhen(M.await(PaymentShape)).returns(M.boolean()),\ngetAmountOf:M.callWhen(M.await(PaymentShape)).returns(amountShape),\nburn:M.callWhen(M.await(PaymentShape)).\noptional(M.pattern()).\nreturns(amountShape)});\n\n\nconst MintI=M.interface('Mint',{\ngetIssuer:M.call().returns(IssuerShape),\nmintPayment:M.call(amountShape).returns(PaymentShape)});\n\n\nconst PaymentI=M.interface('Payment',{\ngetAllegedBrand:M.call().returns(brandShape)});\n\n\nconst PurseI=M.interface('Purse',{\ngetAllegedBrand:M.call().returns(brandShape),\ngetCurrentAmount:M.call().returns(amountShape),\ngetCurrentAmountNotifier:M.call().returns(NotifierShape),\n/* PurseI does *not* delay `deposit` until `srcPayment` is fulfulled.*/\n/* Rather, the semantics of `deposit` require it to provide its*/\n/* callers with a strong guarantee that `deposit` messages are*/\n/* processed without further delay in the order they arrive.*/\n/* PurseI therefore requires that the `srcPayment` argument already*/\n/* be a remotable, not a promise.*/\n/* PurseI only calls this raw method after validating that*/\n/* `srcPayment` is a remotable, leaving it*/\n/* to this raw method to validate that this remotable is actually*/\n/* a live payment of the correct brand with sufficient funds.*/\ndeposit:M.call(PaymentShape).optional(M.pattern()).returns(amountShape),\ngetDepositFacet:M.call().returns(DepositFacetShape),\nwithdraw:M.call(amountShape).returns(PaymentShape),\ngetRecoverySet:M.call().returns(M.setOf(PaymentShape)),\nrecoverAll:M.call().returns(amountShape)});\n\n\nconst DepositFacetI=M.interface('DepositFacet',{\nreceive:PurseI.methodGuards.deposit});\n\n\nconst PurseIKit=harden({\npurse:PurseI,\ndepositFacet:DepositFacetI});\n\n\nreturn harden({\nIssuerI,\nMintI,\nPaymentI,\nPurseIKit});\n\n };$h‍_once.makeIssuerInterfaces(makeIssuerInterfaces);\nharden(makeIssuerInterfaces);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"BrandShape":["BrandShape"],"IssuerShape":["IssuerShape"],"PaymentShape":["PaymentShape"],"PurseShape":["PurseShape"],"DepositFacetShape":["DepositFacetShape"],"NotifierShape":["NotifierShape"],"MintShape":["MintShape"],"AmountShape":["AmountShape"],"RatioShape":["RatioShape"],"isNatValue":["isNatValue"],"isCopySetValue":["isCopySetValue"],"isSetValue":["isSetValue"],"isCopyBagValue":["isCopyBagValue"],"MAX_ABSOLUTE_DECIMAL_PLACES":["MAX_ABSOLUTE_DECIMAL_PLACES"],"AssetKindShape":["AssetKindShape"],"DisplayInfoShape":["DisplayInfoShape"],"IssuerKitShape":["IssuerKitShape"],"BrandI":["BrandI"],"makeIssuerInterfaces":["makeIssuerInterfaces"]},"__needsImportMeta__":false}