{"imports":["@agoric/assert","@endo/far","./types-ambient.js","./publish-kit.js","./subscribe.js"],"exports":["makeNotifier","makeNotifierFromAsyncIterable","makeNotifierFromSubscriber","makeNotifierKit"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let assert,E,Far,makePublishKit,subscribeLatest;$h‍_imports([[\"@agoric/assert\", [[\"assert\", [$h‍_a => (assert = $h‍_a)]]]],[\"@endo/far\", [[\"E\", [$h‍_a => (E = $h‍_a)]],[\"Far\", [$h‍_a => (Far = $h‍_a)]]]],[\"./types-ambient.js\", []],[\"./publish-kit.js\", [[\"makePublishKit\", [$h‍_a => (makePublishKit = $h‍_a)]]]],[\"./subscribe.js\", [[\"subscribeLatest\", [$h‍_a => (subscribeLatest = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\n\n/**\n * @template T\n * @param {ERef<LatestTopic<T>>} sharableInternalsP\n * @returns {Notifier<T>}\n */\nconst        makeNotifier=(sharableInternalsP)=>{\n/** @type {Notifier<T>} */\nconst notifier=Far('notifier',{\n...subscribeLatest(sharableInternalsP),\ngetUpdateSince:async(updateCount)=>\nE(sharableInternalsP).getUpdateSince(updateCount),\n\n/**\n * Use this to distribute a Notifier efficiently over the network,\n * by obtaining this from the Notifier to be replicated, and applying\n * `makeNotifier` to it at the new site to get an equivalent local\n * Notifier at that site.\n */\ngetSharableNotifierInternals:async()=>sharableInternalsP,\n/**\n * @deprecated\n * Used only by `makeCastingSpecFromRef`.  Instead that function should use\n * the `StoredFacet` API.\n */\ngetStoreKey:()=>harden({notifier})});\n\nreturn notifier;\n };\n\n/**\n * @template T\n * @param {ERef<Subscriber<T>>} subscriber\n * @returns {Notifier<T>}\n */$h‍_once.makeNotifier(makeNotifier);\nconst        makeNotifierFromSubscriber=(subscriber)=>{\n/**\n * @type {LatestTopic<T>}\n */\nconst baseNotifier=harden({\ngetUpdateSince:(updateCount=undefined)=>\nE(subscriber).getUpdateSince(updateCount)});\n\n\n/** @type {Notifier<T>} */\nconst notifier=Far('notifier',{\n...makeNotifier(baseNotifier),\n...baseNotifier});\n\nreturn notifier;\n };$h‍_once.makeNotifierFromSubscriber(makeNotifierFromSubscriber);\nharden(makeNotifierFromSubscriber);\n\n/**\n * Produces a pair of objects, which allow a service to produce a stream of\n * update promises.\n *\n * The initial state argument has to be truly optional even though it can\n * be any first class value including `undefined`. We need to distinguish the\n * presence vs the absence of it, which we cannot do with the optional argument\n * syntax. Rather we use the arity of the `initialStateArr` array.\n *\n * If no initial state is provided to `makeNotifierKit`, then it starts without\n * an initial state. Its initial state will instead be the state of the first\n * update.\n *\n * @template T\n * @param {[] | [T]} initialStateArr the first state to be returned (typed as rest array to permit `undefined`)\n * @returns {NotifierRecord<T>} the notifier and updater\n */\nconst        makeNotifierKit=(...initialStateArr)=>{\n/** @type {PublishKit<T>} */\nconst{publisher,subscriber}=makePublishKit();\n\nconst notifier=makeNotifierFromSubscriber(subscriber);\n\nconst updater=Far('updater',{\nupdateState:(state)=>publisher.publish(state),\nfinish:(completion)=>publisher.finish(completion),\nfail:(reason)=>publisher.fail(reason)});\n\n\nassert(initialStateArr.length<=1,'too many arguments');\nif(initialStateArr.length===1){\nupdater.updateState(initialStateArr[0]);\n }\n\n/* notifier facet is separate so it can be handed out while updater*/\n/* is tightly held*/\nreturn harden({notifier,updater});\n };\n\n/**\n * Adaptor from async iterable to notifier.\n *\n * @deprecated The resulting notifier is lossless, which is not desirable.\n * Prefer makeNotifierFromSubscriber, and refer to\n * https://github.com/Agoric/agoric-sdk/issues/5413 and\n * https://github.com/Agoric/agoric-sdk/pull/5695 for context.\n *\n * @template T\n * @param {ERef<AsyncIterable<T>>} asyncIterableP\n * @returns {Notifier<T>}\n */$h‍_once.makeNotifierKit(makeNotifierKit);\nconst        makeNotifierFromAsyncIterable=(asyncIterableP)=>{\nconst iteratorP=E(asyncIterableP)[Symbol.asyncIterator]();\n\n/** @type {Promise<UpdateRecord<T>>|undefined} */\nlet optNextPromise;\nlet currentUpdateCount=0n;\n/** @type {ERef<UpdateRecord<T>>|undefined} */\nlet currentResponse;\nlet final=false;\n\n/**\n * @type {LatestTopic<T>}\n */\nconst baseNotifier=Far('baseNotifier',{\ngetUpdateSince(updateCount=-1n){\nif(updateCount<currentUpdateCount){\nif(currentResponse){\nreturn Promise.resolve(currentResponse);\n }\n }else if(updateCount!==currentUpdateCount){\nthrow Error(\n'getUpdateSince argument must be a previously-issued updateCount.');\n\n }\n\n/* Return a final response if we have one, otherwise a promise for the next state.*/\nif(final){\nassert(currentResponse!==undefined);\nreturn Promise.resolve(currentResponse);\n }\nif(!optNextPromise){\nconst nextIterResultP=E(iteratorP).next();\noptNextPromise=E.when(\nnextIterResultP,\n({done,value})=>{\nassert(!final);\nif(done){\nfinal=true;\n }\ncurrentUpdateCount+=1n;\ncurrentResponse=harden({\nvalue,\nupdateCount:done?undefined:currentUpdateCount});\n\noptNextPromise=undefined;\nreturn currentResponse;\n },\n(_reason)=>{\nfinal=true;\ncurrentResponse=\n/** @type {Promise<UpdateRecord<T>>} */\nnextIterResultP;\noptNextPromise=undefined;\nreturn currentResponse;\n });\n\n }\nreturn optNextPromise;\n }});\n\n\n/** @type {Notifier<T>} */\nconst notifier=Far('notifier',{\n/* Don't leak the original asyncIterableP since it may be remote and we also*/\n/* want the same semantics for this exposed iterable and the baseNotifier.*/\n...makeNotifier(baseNotifier),\n...baseNotifier});\n\nreturn notifier;\n };$h‍_once.makeNotifierFromAsyncIterable(makeNotifierFromAsyncIterable);\nharden(makeNotifierFromAsyncIterable);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"makeNotifier":["makeNotifier"],"makeNotifierFromSubscriber":["makeNotifierFromSubscriber"],"makeNotifierKit":["makeNotifierKit"],"makeNotifierFromAsyncIterable":["makeNotifierFromAsyncIterable"]},"__needsImportMeta__":false}