{"imports":["@endo/far","@endo/marshal","@agoric/internal/src/upgrade-api.js","./types-ambient.js"],"exports":["subscribe","subscribeEach","subscribeLatest"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let E,Far,isObject,isUpgradeDisconnection;$h‍_imports([[\"@endo/far\", [[\"E\", [$h‍_a => (E = $h‍_a)]],[\"Far\", [$h‍_a => (Far = $h‍_a)]]]],[\"@endo/marshal\", [[\"isObject\", [$h‍_a => (isObject = $h‍_a)]]]],[\"@agoric/internal/src/upgrade-api.js\", [[\"isUpgradeDisconnection\", [$h‍_a => (isUpgradeDisconnection = $h‍_a)]]]],[\"./types-ambient.js\", []]]);   \n\n\n\n\n\nconst{details:X,Fail}=assert;\nconst sink=()=>{ };\n\n/**\n * Check the promise returned by a function for rejection by vat upgrade,\n * and refetch upon encountering that condition.\n *\n * @template T\n * @param {() => ERef<T>} getter\n * @param {ERef<T>[]} [seed]\n * @returns {Promise<T>}\n */\nconst reconnectAsNeeded=async(getter,seed=[])=>{\nlet disconnection;\nlet lastVersion=-Infinity;\n/* End synchronous prelude.*/\nawait null;\nfor(let i=0;;i+=1){\ntry{\nconst resultP=i<seed.length?seed[i]:getter();\n/* eslint-disable-next-line no-await-in-loop, @jessie.js/no-nested-await*/\nconst result=await resultP;\nreturn result;\n }catch(err){\nif(isUpgradeDisconnection(err)){\nif(!disconnection){\ndisconnection=err;\n }\nconst{incarnationNumber:version}=err;\nif(version>lastVersion){\n/* We don't expect another upgrade in between receiving*/\n/* a disconnection and re-requesting an update, but must*/\n/* nevertheless be prepared for that.*/\nlastVersion=version;\ncontinue;\n }\n }\n/* if `err` is an (Error) object, we can try to associate it with*/\n/* information about the disconnection that prompted the request*/\n/* for which it is a result.*/\nif(isObject(err)&&disconnection&&disconnection!==err){\ntry{\nassert.note(\nerr,\nX `Attempting to recover from disconnection: ${disconnection}`);\n\n }catch(_err){\n/* eslint-disable-next-line no-empty*/\n }\n }\nthrow err;\n }\n }\n };\n\n/**\n * Create a near iterable that corresponds to a potentially far one.\n *\n * @template T\n * @param {ERef<AsyncIterableIterator<T>>} itP\n */\nconst        subscribe=(itP)=>\nFar('AsyncIterable',{\n[Symbol.asyncIterator]:()=>{\nconst it=E(itP)[Symbol.asyncIterator]();\nconst self=Far('AsyncIterableIterator',{\n[Symbol.asyncIterator]:()=>self,\nnext:async()=>E(it).next()});\n\nreturn self;\n }});\n\n\n/**\n * Asyncronously iterates over the contents of a PublicationRecord chain as they\n * appear.  This iteration must drop parts of publication records that are no\n * longer needed so they can be garbage collected.\n *\n * @template T\n * @param {ERef<EachTopic<T>>} topic\n * @param {ERef<PublicationRecord<T>>} nextCellP\n *   PublicationRecord corresponding with the first iteration result\n * @returns {ForkableAsyncIterableIterator<T, T>}\n */$h‍_once.subscribe(subscribe);\nconst makeEachIterator=(topic,nextCellP)=>{\n/* To understand the implementation, start with*/\n/* https://web.archive.org/web/20160404122250/http://wiki.ecmascript.org/doku.php?id=strawman:concurrency#infinite_queue*/\nconst self=Far('EachIterator',{\n[Symbol.asyncIterator]:()=>self,\nnext:()=>{\nconst{\nhead:resultP,\npublishCount:publishCountP,\ntail:tailP}=\nE.get(nextCellP);\n\n/* If tailP is broken by upgrade, we will need to re-request it*/\n/* directly from `topic`.*/\nconst getSuccessor=async()=>{\nconst publishCount=await publishCountP;\nassert.typeof(publishCount,'bigint');\nconst successor=await E(topic).subscribeAfter(publishCount);\nconst newPublishCount=successor.publishCount;\nif(newPublishCount!==publishCount+1n){\nFail `eachIterator broken by gap from publishCount ${publishCount} to ${newPublishCount}`;\n }\nreturn successor;\n };\n\n/* Replace nextCellP on every call to next() so things work even*/\n/* with an eager consumer that doesn't wait for results to settle.*/\nnextCellP=reconnectAsNeeded(getSuccessor,[tailP]);\n\n/* Avoid unhandled rejection warnings here if the previous cell was rejected or*/\n/* there is no further request of this iterator.*/\n/* `tailP` is handled inside `reconnectAsNeeded` and `resultP` is the caller's*/\n/* concern, leaving only `publishCountP` and the new `nextCellP`.*/\nvoid E.when(publishCountP,sink,sink);\nvoid E.when(nextCellP,sink,sink);\nreturn resultP;\n },\nfork:()=>makeEachIterator(topic,nextCellP)});\n\nreturn self;\n };\n\n/**\n * Given a local or remote subscriber, returns a local AsyncIterable which\n * provides \"prefix lossy\" iterations of the underlying PublicationList.\n * By \"prefix lossy\", we mean that you may miss everything published before\n * you ask the returned iterable for an iterator. But the returned iterator\n * will enumerate each thing published from that iterator's starting point\n * up to a disconnection result indicating upgrade of the producer\n * (which breaks the gap-free guarantee and therefore terminates any active\n * iterator while still supporting creation of new iterators).\n *\n * If the underlying PublicationList is terminated, that terminal value will be\n * reported losslessly.\n *\n * @template T\n * @param {ERef<EachTopic<T>>} topic\n */\nconst        subscribeEach=(topic)=>{\nconst iterable=Far('EachIterable',{\n[Symbol.asyncIterator]:()=>{\nconst firstCellP=reconnectAsNeeded(()=>E(topic).subscribeAfter());\nreturn makeEachIterator(topic,firstCellP);\n }});\n\nreturn iterable;\n };$h‍_once.subscribeEach(subscribeEach);\nharden(subscribeEach);\n\n/**\n * @template T\n * @param {ERef<LatestTopic<T>>} topic\n * @param {bigint} [localUpdateCount]\n * @param {IteratorReturnResult<T>} [terminalResult]\n * @returns {ForkableAsyncIterableIterator<T, T>}\n */\nconst cloneLatestIterator=(topic,localUpdateCount,terminalResult)=>{\nlet mutex=Promise.resolve();\n\n/**\n * Request the next update record from the topic, updating our local state,\n * and convert it to an iterator result.\n *\n * @returns {Promise<IteratorResult<T, T>>}\n */\nconst maybeRequestNextResult=async()=>{\nif(terminalResult){\n/* We've reached the end of the topic, just keep returning the last result*/\n/* without further requests.*/\nreturn terminalResult;\n }\n\n/* Send the next request now, skipping past intermediate updates*/\n/* and upgrade disconnections.*/\nconst{value,updateCount}=await reconnectAsNeeded(()=>\nE(topic).getUpdateSince(localUpdateCount));\n\n/* Make sure the next request is for a fresher value.*/\nlocalUpdateCount=updateCount;\n\n/* Make an IteratorResult.*/\nif(updateCount===undefined){\nterminalResult=harden({done:true,value});\nreturn terminalResult;\n }\nreturn harden({done:false,value});\n };\n\nconst self=Far('LatestIterator',{\nfork:()=>cloneLatestIterator(topic,localUpdateCount,terminalResult),\n[Symbol.asyncIterator]:()=>self,\nnext:async()=>{\n/* In this adaptor, once `next()` is called and returns an unresolved*/\n/* promise, further `next()` calls will also return unresolved promises*/\n/* but each call will not trigger another `topic` request until the prior*/\n/* one has settled.*/\n/**/\n/* This linear queueing behavior is only needed for code that uses the*/\n/* async iterator protocol explicitly. When this async iterator is*/\n/* consumed by a for/await/of loop, `next()` will only be called after the*/\n/* promise for the previous iteration result has fulfilled. If it fulfills*/\n/* with `done: true`, the for/await/of loop will never call `next()`*/\n/* again.*/\n/**/\n/* See*/\n/* https://2ality.com/2016/10/asynchronous-iteration.html#queuing-next()-invocations*/\n/* for an explicit use that sends `next()` without waiting.*/\n\nif(terminalResult){\n/* We've reached the end of the topic, just keep returning the last*/\n/* result.*/\nreturn terminalResult;\n }\n\n/* BEGIN CRITICAL SECTION - synchronously enqueue and reassign `mutex`*/\n/**/\n/* Use `mutex` to ensure that we have no more than a single request in*/\n/* flight.*/\nconst nextResult=mutex.then(maybeRequestNextResult);\nmutex=nextResult.then(sink,sink);\n/* END CRITICAL SECTION*/\n\nreturn nextResult;\n }});\n\nreturn self;\n };\n\n/**\n * @template T\n * @param {ERef<LatestTopic<T>>} topic\n * @returns {ForkableAsyncIterableIterator<T, T>}\n */\nconst makeLatestIterator=(topic)=>cloneLatestIterator(topic);\n\n/**\n * Given a local or remote subscriber, returns a local AsyncIterable which\n * provides \"lossy\" iterations of the underlying PublicationList.\n * By \"lossy\", we mean that you may miss any published state if a more\n * recent published state can be reported instead.\n *\n * If the underlying PublicationList is terminated by upgrade of the producer,\n * it will be re-requested. All other terminal values will be losslessly\n * propagated.\n *\n * @template T\n * @param {ERef<LatestTopic<T>>} topic\n */\nconst        subscribeLatest=(topic)=>{\nconst iterable=Far('LatestIterable',{\n[Symbol.asyncIterator]:()=>makeLatestIterator(topic)});\n\nreturn iterable;\n };$h‍_once.subscribeLatest(subscribeLatest);\nharden(subscribeLatest);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"subscribe":["subscribe"],"subscribeEach":["subscribeEach"],"subscribeLatest":["subscribeLatest"]},"__needsImportMeta__":false}