{"imports":["@endo/marshal","@endo/patterns"],"exports":["appendToStoredArray","isCopyMap","isCopySet","makeAtomicProvider","makeCurrentKeysKit","provideLazy"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let Far,M,matches;$h‍_imports([[\"@endo/marshal\", [[\"Far\", [$h‍_a => (Far = $h‍_a)]]]],[\"@endo/patterns\", [[\"M\", [$h‍_a => (M = $h‍_a)]],[\"matches\", [$h‍_a => (matches = $h‍_a)]]]]]);   \n\n\nconst{Fail,quote:q}=assert;\n\n/**\n * Should behave identically to the one in `@endo/patterns`, but\n * reimplemented for now because `@endo/patterns` forgot to export this one.\n * This one is simple enough that I prefer a reimplementation to a deep import.\n * TODO: Undate `@endo/patterns` to export the original, and delete the\n * reimplementation here.\n *\n * @param {Passable} s\n * @returns {s is CopySet}\n */\nconst        isCopySet=(s)=>matches(s,M.set());\n\n/**\n * Should behave identically to the one in `@endo/patterns`, but\n * reimplemented for now because `@endo/patterns` forgot to export this one.\n * This one is simple enough that I prefer a reimplementation to a deep import.\n * TODO: Undate `@endo/patterns` to export the original, and delete the\n * reimplementation here.\n *\n * @param {Passable} m\n * @returns {m is CopyMap}\n */$h‍_once.isCopySet(isCopySet);\nconst        isCopyMap=(m)=>matches(m,M.map());\n\n/**\n * @template K,V\n * @typedef {object} CurrentKeysKit\n * @property {(k: K, v?: V) => void} assertUpdateOnAdd\n * @property {(k: K) => void} assertUpdateOnDelete\n * @property {Iterable<K>} iterableKeys\n */\n\n/**\n * @template K,V\n * @param {() => Iterable<K>} getRawKeys\n * @param {(k: K) => boolean} checkHas\n * @param {RankCompare} compare\n * @param {(k: K, v?: V) => void} assertOkToAdd\n * @param {(k: K) => void} [assertOkToDelete]\n * @param {string} [keyName]\n * @returns {CurrentKeysKit<K,V>}\n */$h‍_once.isCopyMap(isCopyMap);\nconst        makeCurrentKeysKit=(\ngetRawKeys,\ncheckHas,\ncompare,\nassertOkToAdd,\nassertOkToDelete=undefined,\nkeyName='key')=>\n{\nlet updateCount=0;\nlet sortedKeysMemo;\n\nconst assertUpdateOnAdd=(k,v=undefined)=>{\nassertOkToAdd(k,v);\nupdateCount+=1;\nsortedKeysMemo=undefined;\n };\n\nconst assertUpdateOnDelete=(k)=>assertOkToDelete&&assertOkToDelete(k);\n\nconst getSortedKeys=()=>{\nif(sortedKeysMemo===undefined){\nsortedKeysMemo=harden([...getRawKeys()].sort(compare));\n }\nreturn sortedKeysMemo;\n };\n\nconst iterableKeys=Far('Iterable of keys',{\n[Symbol.iterator]:()=>{\nconst generation=updateCount;\ngetSortedKeys();\nconst len=sortedKeysMemo.length;\nlet i=0;\nreturn Far('Iterator of keys',{\nnext:()=>{\ngeneration===updateCount||Fail `Store ${q(keyName)} cursor stale`;\n/* If they're equal, then the sortedKeyMemo is the same one*/\n/* we started with.*/\nfor(;;){\nif(i<len){\nconst value=sortedKeysMemo[i];\ni+=1;\nif(checkHas(value)){\nreturn harden({done:false,value});\n }\n }else{\nreturn harden({done:true,value:undefined});\n }\n }\n }});\n\n }});\n\n\nreturn harden({\nassertUpdateOnAdd,\nassertUpdateOnDelete,\niterableKeys});\n\n };$h‍_once.makeCurrentKeysKit(makeCurrentKeysKit);\nharden(makeCurrentKeysKit);\n\n/**\n * Call `provideLazy` to get or make the value associated with the key.\n * If there already is one, return that. Otherwise,\n * call `makeValue(key)`, remember it as the value for\n * that key, and return it.\n *\n * @template K,V\n * @param {WeakMapStore<K,V>} mapStore\n * @param {K} key\n * @param {(key: K) => V} makeValue\n * @returns {V}\n */\nconst        provideLazy=(mapStore,key,makeValue)=>{\nif(!mapStore.has(key)){\nmapStore.init(key,makeValue(key));\n }\nreturn mapStore.get(key);\n };$h‍_once.provideLazy(provideLazy);\nharden(provideLazy);\n\n/**\n * Helper for use cases in which the maker function is async.\n * For two provideLazy calls with the same key, one may be making when the\n * other call starts and it would make again.\n * (Then there'd be a collision when the second tries to store\n * the key.) This prevents that race condition by immediately storing a Promise\n * for the maker in an ephemeral store.\n *\n * When the `store` argument is durable storage, note that it's possible for\n * termination to happen after the make completes and before it reaches durable\n * storage.\n *\n * @template K\n * @template V\n * @param {WeakMapStore<K, V>} store\n */\nconst        makeAtomicProvider=(store)=>{\n/** @type {Map<K, Promise<V>>} */\nconst pending=new Map();\n\n/**\n * Call `provideAsync` to get or make the value associated with the key,\n * when the maker is asynchronous.\n * If there already is one, return that. Otherwise,\n * call `makeValue(key)`, remember it as the value for\n * that key, and return it.\n *\n * @param {K} key\n * @param {(key: K) => Promise<V>} makeValue make the value for the store\n * if it hasn't been made yet or the last make failed\n * @param {(key: K, value: V) => Promise<void>} [finishValue] runs exactly\n * once after a new value is added to the store\n * @returns {Promise<V>}\n */\nconst provideAsync=(key,makeValue,finishValue)=>{\nif(store.has(key)){\nreturn Promise.resolve(store.get(key));\n }\nif(!pending.has(key)){\nconst valP=makeValue(key).\nthen((v)=>{\nstore.init(key,v);\nreturn v;\n }).\nthen((v)=>{\nif(finishValue){\nreturn finishValue(key,v).then(()=>v);\n }\nreturn v;\n }).\nfinally(()=>{\npending.delete(key);\n });\npending.set(key,valP);\n }\nconst valP=pending.get(key);\nassert(valP);\nreturn valP;\n };\n\nreturn harden({provideAsync});\n };$h‍_once.makeAtomicProvider(makeAtomicProvider);\nharden(makeAtomicProvider);\n/**\n * @template K\n * @template V\n * @typedef {ReturnType<typeof makeAtomicProvider<K, V>>} AtomicProvider<K, V>\n */\n\n/**\n * @template K, V\n * @param {MapStore<K, V[]>} mapStore\n * @param {K} key\n * @param {V} item\n */\nconst        appendToStoredArray=(mapStore,key,item)=>{\nif(mapStore.has(key)){\nconst extant=mapStore.get(key);\nmapStore.set(key,harden([...extant,item]));\n }else{\nmapStore.init(key,harden([item]));\n }\n };$h‍_once.appendToStoredArray(appendToStoredArray);\nharden(appendToStoredArray);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"isCopySet":["isCopySet"],"isCopyMap":["isCopyMap"],"makeCurrentKeysKit":["makeCurrentKeysKit"],"provideLazy":["provideLazy"],"makeAtomicProvider":["makeAtomicProvider"],"appendToStoredArray":["appendToStoredArray"]},"__needsImportMeta__":false}