{"imports":["@agoric/store","@endo/nat","./typeGuards.js"],"exports":["TimeMath"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let mustMatch,Nat,RelativeTimeRecordShape,TimestampRecordShape;$h‍_imports([[\"@agoric/store\", [[\"mustMatch\", [$h‍_a => (mustMatch = $h‍_a)]]]],[\"@endo/nat\", [[\"Nat\", [$h‍_a => (Nat = $h‍_a)]]]],[\"./typeGuards.js\", [[\"RelativeTimeRecordShape\", [$h‍_a => (RelativeTimeRecordShape = $h‍_a)]],[\"TimestampRecordShape\", [$h‍_a => (TimestampRecordShape = $h‍_a)]]]]]);   \n\n\n\nconst{Fail,quote:q}=assert;\n/**\n * @typedef {Ximport('./types').TimerBrand} TimerBrand\n * @typedef {Ximport('./types').Timestamp} Timestamp\n * @typedef {Ximport('./types').RelativeTime} RelativeTime\n * @typedef {Ximport('./types').RelativeTimeValue} RelativeTimeValue\n * @typedef {Ximport('./types').TimestampValue} TimestampValue\n * @typedef {Ximport('./types').TimeMathType} TimeMathType\n *\n */\n\n/**\n * `agreedTimerBrand` is internal to this module.\n *\n * @param {TimerBrand | undefined} leftBrand\n * @param {TimerBrand | undefined} rightBrand\n * @returns {TimerBrand | undefined}\n */\nconst agreedTimerBrand=(leftBrand,rightBrand)=>{\nif(leftBrand===undefined){\nif(rightBrand===undefined){\nreturn undefined;\n }else{\nreturn rightBrand;\n }\n }else if(rightBrand===undefined){\nreturn leftBrand;\n }else{\nleftBrand===rightBrand||\nFail `TimerBrands must match: ${q(leftBrand)} vs ${q(rightBrand)}`;\nreturn leftBrand;\n }\n };\n\n/**\n * `sharedTimerBrand` is internal to this module, and implements the\n * transitional brand checking and contaigion logic explained in the `TimeMath`\n * comment. It is used to define the binary operators that should follow\n * this logic. It does the error checking between the operands, and returns\n * the brand, if any, that should label the resulting time value.\n *\n * @param {Timestamp | RelativeTime} left\n * @param {Timestamp | RelativeTime} right\n * @returns {TimerBrand | undefined}\n */\nconst sharedTimerBrand=(left,right)=>{\nconst leftBrand=typeof left==='bigint'?undefined:left.timerBrand;\nconst rightBrand=typeof right==='bigint'?undefined:right.timerBrand;\nreturn agreedTimerBrand(leftBrand,rightBrand);\n };\n\n/**\n * `absLike` is internal to this module, and used to implement the binary\n * operators in the case where the returned time should be a `Timestamp`\n * rather than a `RelativeTime`.\n *\n * @param {Timestamp | RelativeTime} left\n * @param {Timestamp | RelativeTime} right\n * @param {TimestampValue} absValue\n * @returns {Timestamp}\n */\nconst absLike=(left,right,absValue)=>{\nNat(absValue);\nconst timerBrand=sharedTimerBrand(left,right);\nif(timerBrand){\nreturn harden({\ntimerBrand,\nabsValue});\n\n }else{\nreturn absValue;\n }\n };\n\n/**\n * `relLike` is internal to this module, and used to implement the binary\n * operators in the case where the returned time should be a `RelativeTime`\n * rather than a `Timestamp`.\n *\n * @param {Timestamp | RelativeTime} left\n * @param {Timestamp | RelativeTime} right\n * @param {RelativeTimeValue} relValue\n * @returns {RelativeTime}\n */\nconst relLike=(left,right,relValue)=>{\nNat(relValue);\nconst timerBrand=sharedTimerBrand(left,right);\nif(timerBrand){\nreturn harden({\ntimerBrand,\nrelValue});\n\n }else{\nreturn relValue;\n }\n };\n\n/* For all the following time operators, their documentation is in*/\n/* the `TimeMathType`, since that is the documentation that shows up*/\n/* in the IDE. Well, at least the vscode IDE.*/\n\nconst absValue=(abs)=>{\nif(typeof abs==='bigint'){\nreturn Nat(abs);\n }\nmustMatch(abs,TimestampRecordShape,'timestamp');\nreturn Nat(abs.absValue);\n };\n\nconst relValue=(rel)=>{\nif(typeof rel==='bigint'){\nreturn Nat(rel);\n }\nmustMatch(rel,RelativeTimeRecordShape,'relative');\nreturn Nat(rel.relValue);\n };\n\nconst makeTimestampRecord=(abs,timerBrand)=>\nharden({absValue:abs,timerBrand});\nconst makeRelativeTimeRecord=(rel,timerBrand)=>\nharden({relValue:rel,timerBrand});\n\nconst coerceTimestampRecord=(ts,brand)=>{\nbrand||Fail `must have a brand`;\nif(typeof ts==='number'){\nts=Nat(ts);\n }\nif(typeof ts==='bigint'){\nreturn makeTimestampRecord(ts,brand);\n }else{\nconst{timerBrand}=ts;\nmustMatch(ts,TimestampRecordShape,'timestamp');\nagreedTimerBrand(timerBrand,brand);\nreturn ts;\n }\n };\n\nconst coerceRelativeTimeRecord=(rt,brand)=>{\nbrand||Fail `must have a brand`;\nif(typeof rt==='number'){\nrt=Nat(rt);\n }\nif(typeof rt==='bigint'){\nreturn makeRelativeTimeRecord(rt,brand);\n }else{\nconst{timerBrand}=rt;\nmustMatch(rt,RelativeTimeRecordShape,'relativeTime');\nagreedTimerBrand(timerBrand,brand);\nreturn rt;\n }\n };\n\nconst addAbsRel=(abs,rel)=>\nabsLike(abs,rel,absValue(abs)+relValue(rel));\n\nconst addRelRel=(rel1,rel2)=>\nrelLike(rel1,rel2,relValue(rel1)+relValue(rel2));\n\nconst subtractAbsAbs=(abs1,abs2)=>\nrelLike(abs1,abs2,absValue(abs1)-absValue(abs2));\n\nconst clampedSubtractAbsAbs=(abs1,abs2)=>{\nconst val1=absValue(abs1);\nconst val2=absValue(abs2);\nreturn relLike(abs1,abs2,val1>val2?val1-val2:0n);\n };\n\nconst subtractAbsRel=(abs,rel)=>\nabsLike(abs,rel,absValue(abs)-relValue(rel));\n\nconst subtractRelRel=(rel1,rel2)=>\nrelLike(rel1,rel2,relValue(rel1)-relValue(rel2));\n\nconst isRelZero=(rel)=>relValue(rel)===0n;\n\nconst multiplyRelNat=(rel,nat)=>relLike(rel,nat,relValue(rel)*nat);\n\nconst divideRelNat=(rel,nat)=>relLike(rel,nat,relValue(rel)/nat);\n\nconst divideRelRel=(rel1,rel2)=>{\nsharedTimerBrand(rel1,rel2);/* just error check*/\nreturn relValue(rel1)/relValue(rel2);\n };\n\nconst modAbsRel=(abs,step)=>\nrelLike(abs,step,absValue(abs)%relValue(step));\n\nconst modRelRel=(rel,step)=>\nrelLike(rel,step,relValue(rel)%relValue(step));\n\n/**\n * `compareValues` is internal to this module, and used to implement\n * the time comparison operators.\n *\n * @param {Timestamp | RelativeTime} left\n * @param {Timestamp | RelativeTime} right\n * @param {bigint} v1\n * @param {bigint} v2\n * @returns {RankComparison}\n */\nconst compareValues=(left,right,v1,v2)=>{\nsharedTimerBrand(left,right);\nif(v1<v2){\nreturn-1;\n }else if(v1===v2){\nreturn 0;\n }else{\nassert(v1>v2);\nreturn 1;\n }\n };\n\n/**\n * The `TimeMath` object provides helper methods to do arithmetic on labeled\n * time values, much like `AmountMath` provides helper methods to do arithmetic\n * on labeled asset/money values. Both check for consistency of labels: a\n * binary operation on two labeled objects ensures that the both carry\n * the same label. If they produce another object from the same domain, it\n * will carry the same label. If the operands have incompatible labels,\n * an error is thrown.\n *\n * Unlike amount arithmetic, time arithmetic deals in two kinds of time objects:\n * Timestamps, which represent absolute time, and RelativeTime, which represents\n * the duration between two absolute times. Both kinds of time object\n * are labeled by a `TimerBrand`. For a Timestamp object, the value is\n * a bigint in an `absValue` property. For a RelativeTime object, the value\n * is a bigint in a `relValue` property. Thus we have a runtime safety check\n * to ensure that we don't confused the two, even if we have managed to fool\n * the (unsound) static type system.\n *\n * As a transitional measure, currently many Timestamps and RelativeTimes are\n * still represented by unlabeled bigints. During this transitional period,\n * we allow this, both statically and dynamically. For a normal binary\n * operation, if both inputs are labeled, then we do the full checking as\n * explained above and return a labeled result. If both inputs are unlabeled\n * bigints, we *assume* that they indicate a time of the right kind\n * (Timestamp vs RelativeTime) and timer brand. Since we don't know what\n * brand was intended, we can only return yet another unlabeled bigint.\n *\n * If one operand is labeled and the other is not, we check the labeled operand,\n * *assume* the unlabeled bigint represents the value needed for the other\n * operand, and return a labeled time object with the brand of the labeled\n * operand.\n *\n * @type {TimeMathType}\n */\nconst        TimeMath=harden({\nabsValue,\nrelValue,\ncoerceTimestampRecord,\ncoerceRelativeTimeRecord,\naddAbsRel,\naddRelRel,\nsubtractAbsAbs,\nclampedSubtractAbsAbs,\nsubtractAbsRel,\nsubtractRelRel,\nisRelZero,\nmultiplyRelNat,\ndivideRelNat,\ndivideRelRel,\nmodAbsRel,\nmodRelRel,\ncompareAbs:(abs1,abs2)=>\ncompareValues(abs1,abs2,absValue(abs1),absValue(abs2)),\ncompareRel:(rel1,rel2)=>\ncompareValues(rel1,rel2,relValue(rel1),relValue(rel2))});$h‍_once.TimeMath(TimeMath);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"TimeMath":["TimeMath"]},"__needsImportMeta__":false}