{"imports":["@agoric/store","@agoric/assert","@agoric/ertp","../internal-types.js"],"exports":["assertRightsConserved"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let makeScalarMapStore,assert,Fail,AmountMath;$h‍_imports([[\"@agoric/store\", [[\"makeScalarMapStore\", [$h‍_a => (makeScalarMapStore = $h‍_a)]]]],[\"@agoric/assert\", [[\"assert\", [$h‍_a => (assert = $h‍_a)]],[\"Fail\", [$h‍_a => (Fail = $h‍_a)]]]],[\"@agoric/ertp\", [[\"AmountMath\", [$h‍_a => (AmountMath = $h‍_a)]]]],[\"../internal-types.js\", []]]);Object.defineProperty(assertRightsConserved, 'name', {value: \"assertRightsConserved\"});$h‍_once.assertRightsConserved(assertRightsConserved);   \n\n\n\n\n\n/**\n * Iterate over the amounts and sum, storing the sums in a\n * map by brand.\n *\n * @param  {Amount[]} amounts - an array of amounts\n * @returns {MapStore<Brand, Amount>} sumsByBrand - a map of Brand keys and\n * Amount values. The amounts are the sums.\n */\nconst sumByBrand=(amounts)=>{\n/** @type {MapStore<Brand, Amount>} */\nconst sumsByBrand=makeScalarMapStore('brand');\namounts.forEach((amount)=>{\nconst{brand}=amount;\nif(!sumsByBrand.has(brand)){\nsumsByBrand.init(brand,amount);\n }else{\nconst sumSoFar=sumsByBrand.get(brand);\nsumsByBrand.set(brand,AmountMath.add(sumSoFar,amount));\n }\n });\nreturn sumsByBrand;\n };\n\n/**\n * Assert that the left sums by brand equal the right sums by brand\n *\n * @param  {MapStore<Brand, Amount>} leftSumsByBrand - a map of brands to sums\n * @param  {MapStore<Brand, Amount>} rightSumsByBrand - a map of brands to sums\n */\nconst assertEqualPerBrand=(leftSumsByBrand,rightSumsByBrand)=>{\n/* We cannot assume that all of the brand keys present in*/\n/* leftSumsByBrand are also present in rightSumsByBrand. A empty*/\n/* amount could be introduced or dropped, and this should still be*/\n/* deemed \"equal\" from the perspective of rights conservation.*/\n\n/* Thus, we should allow for a brand to be missing from a map, but*/\n/* only if the sum for the brand in the other map is empty.*/\n\n/**\n * A helper that either gets the sums for the specified brand, or if\n * the brand is absent in the map, returns an empty amount.\n *\n * @param {Brand} brand\n * @returns {{ leftSum: Amount, rightSum: Amount }}\n */\nconst getSums=(brand)=>{\nlet leftSum;\nlet rightSum;\nif(leftSumsByBrand.has(brand)){\nleftSum=leftSumsByBrand.get(brand);\n }\nif(rightSumsByBrand.has(brand)){\nrightSum=rightSumsByBrand.get(brand);\n }\nif(leftSum===undefined){\nassert(rightSum);\nleftSum=AmountMath.makeEmptyFromAmount(rightSum);\n }\nif(rightSum===undefined){\nrightSum=AmountMath.makeEmptyFromAmount(leftSum);\n }\nreturn{leftSum,rightSum};\n };\n\nconst allBrands=new Set([\n...leftSumsByBrand.keys(),\n...rightSumsByBrand.keys()]);\n\n\nallBrands.forEach((brand)=>{\nconst{leftSum,rightSum}=getSums(brand);\nAmountMath.isEqual(leftSum,rightSum)||\nFail `rights were not conserved for brand ${brand} ${leftSum.value} != ${rightSum.value}`;\n });\n };\n\n/**\n * `assertRightsConserved` checks that the total amount per brand is\n * equal to the total amount per brand in the proposed reallocation\n *\n * @param {Amount[]} previousAmounts - an array of the amounts before the\n * proposed reallocation\n * @param {Amount[]} newAmounts - an array of the amounts in the\n * proposed reallocation\n * @returns {void}\n */\nfunction assertRightsConserved(previousAmounts,newAmounts){\nconst sumsPrevAmounts=sumByBrand(previousAmounts);\nconst sumsNewAmounts=sumByBrand(newAmounts);\nassertEqualPerBrand(sumsPrevAmounts,sumsNewAmounts);\n }\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"assertRightsConserved":["assertRightsConserved"]},"__needsImportMeta__":false}