{"imports":[],"exports":[],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   $h‍_imports([]);   /* @jessie-check*/\n\n/*/ <reference types=\"ses\"/>*/\n\n/** @typedef {Ximport('@agoric/ertp').IssuerOptionsRecord} IssuerOptionsRecord */\n\n/* XXX can be tighter than 'any'*/\n/**\n * @typedef {any} Completion\n * Any passable non-thenable. Often an explanatory string.\n */\n\n/**\n * @callback ZCFMakeEmptySeatKit\n * @param {ExitRule} [exit]\n * @returns {ZcfSeatKit}\n */\n\n/**\n * @template {object} [CT=Record<string, unknown>] Contract's custom terms\n * @typedef {object} ZCF Zoe Contract Facet\n *\n * The Zoe interface specific to a contract instance. The Zoe Contract\n * Facet is an API object used by running contract instances to access\n * the Zoe state for that instance. The Zoe Contract Facet is accessed\n * synchronously from within the contract, and usually is referred to\n * in code as zcf.\n *\n * @property {Reallocate} reallocate - reallocate amounts among seats.\n * Deprecated: Use atomicRearrange instead.\n * @property {(keyword: Keyword) => void} assertUniqueKeyword - check\n * whether a keyword is valid and unique and could be added in\n * `saveIssuer`\n * @property {SaveIssuer} saveIssuer - save an issuer to ZCF and Zoe\n * and get the AmountMath and brand synchronously accessible after\n * saving\n * @property {MakeInvitation} makeInvitation\n * @property {(completion: Completion) => void} shutdown\n * @property {ShutdownWithFailure} shutdownWithFailure\n * @property {() => ERef<ZoeService>} getZoeService\n * @property {() => Issuer<'set'>} getInvitationIssuer\n * @property {() => StandardTerms & CT} getTerms\n * @property {<K extends AssetKind>(issuer: Issuer<K>) => Brand<K>} getBrandForIssuer\n * @property {<K extends AssetKind>(brand: Brand<K>) => Issuer<K>} getIssuerForBrand\n * @property {GetAssetKindByBrand} getAssetKind\n * @property {<K extends AssetKind = 'nat'>(\n *   keyword: Keyword,\n *   assetKind?: K,\n *   displayInfo?: AdditionalDisplayInfo,\n *   options?: IssuerOptionsRecord\n * ) => Promise<ZCFMint<K>>} makeZCFMint\n * @property {ZCFRegisterFeeMint} registerFeeMint\n * @property {ZCFMakeEmptySeatKit} makeEmptySeatKit\n * @property {SetTestJig} setTestJig\n * @property {() => Promise<void>} stopAcceptingOffers\n * @property {(strings: Array<string>) => Promise<void>} setOfferFilter\n * @property {() => Promise<Array<string>>} getOfferFilter\n * @property {() => Instance} getInstance\n */\n\n/**\n * @typedef {(seat1: ZCFSeat, seat2: ZCFSeat, ...seatRest:\n * Array<ZCFSeat>) => void} Reallocate\n *\n * The contract can reallocate over seats, which commits the staged\n * allocation for each seat. On commit, the staged allocation becomes\n * the current allocation and the staged allocation is deleted.\n *\n * The reallocation will only succeed if the reallocation 1) conserves\n * rights (the amounts specified have the same total value as the\n * current total amount), and 2) is 'offer-safe' for all parties\n * involved. All seats that have staged allocations must be included\n * as arguments to `reallocate`, or an error is thrown. Additionally,\n * an error is thrown if any seats included in `reallocate` do not\n * have a staged allocation.\n *\n * The reallocation is partial, meaning that it applies only to the\n * seats passed in as arguments. By induction, if rights conservation\n * and offer safety hold before, they will hold after a safe\n * reallocation, even though we only re-validate for the seats whose\n * allocations will change. Since rights are conserved for the change,\n * overall rights will be unchanged, and a reallocation can only\n * effect offer safety for seats whose allocations change.\n */\n\n/**\n * @callback SaveIssuer\n *\n * Informs Zoe about an issuer and returns a promise for acknowledging\n * when the issuer is added and ready.\n *\n * @param {ERef<Issuer>} issuerP Promise for issuer\n * @param {Keyword} keyword Keyword for added issuer\n * @returns {Promise<IssuerRecord<*>>} Issuer is added and ready\n */\n\n/**\n * @typedef {<Result>(\n *   offerHandler: OfferHandler<Result>,\n *   description: string,\n *   customDetails?: object,\n *   proposalShape?: Pattern,\n * ) => Promise<Invitation<Awaited<Result>>>\n * } MakeInvitation\n *\n * Make a credible Zoe invitation for a particular smart contract\n * indicated by the `instance` in the details of the invitation. Zoe\n * also puts the `installation` and a unique `handle` in the details\n * of the invitation. The contract must provide a `description` for\n * the invitation and should include whatever information is necessary\n * for a potential buyer of the invitation to know what they are\n * getting in the `customDetails`. `customDetails` will be\n * placed in the details of the invitation.\n */\n\n/**\n * @callback ZCFRegisterFeeMint\n * @param {Keyword} keyword\n * @param {FeeMintAccess} allegedFeeMintAccess - an object that\n * purports to be the object that grants access to the fee mint\n * @returns {Promise<ZCFMint<'nat'>>}\n */\n\n/**\n * Provide a jig object for testing purposes only.\n *\n * The contract code provides a callback whose return result will\n * be made available to the test that started this contract. The\n * supplied callback will only be called in a testing context,\n * never in production; i.e., it is only called if `testJigSetter`\n * was supplied.\n *\n * If no, `testFn` is supplied, then an empty jig will be used.\n * An additional `zcf` property set to the current ContractFacet\n * will be appended to the returned jig object (overriding any\n * provided by the `testFn`).\n *\n * @callback SetTestJig\n * @param {() => Record<string, unknown>} testFn\n * @returns {void}\n */\n\n/**\n * @template {AssetKind} [K=AssetKind]\n * @typedef {object} ZCFMint\n * @property {() => IssuerRecord<K>} getIssuerRecord\n * @property {(gains: AmountKeywordRecord, zcfSeat?: ZCFSeat) => ZCFSeat} mintGains\n * All the amounts in gains must be of this ZCFMint's brand.\n * The gains' keywords are in the namespace of that seat.\n * Add the gains to that seat's allocation.\n * The resulting state must be offer safe. (Currently, increasing assets can\n * never violate offer safety anyway.)\n *\n * Mint that amount of assets into the pooled purse.\n * If a seat is provided, it is returned. Otherwise a new seat is\n * returned.\n *\n * @property {(losses: AmountKeywordRecord,\n *             zcfSeat: ZCFSeat,\n *            ) => void} burnLosses\n * All the amounts in losses must be of this ZCFMint's brand.\n * The losses' keywords are in the namespace of that seat.\n * Subtract losses from that seat's allocation.\n * The resulting state must be offer safe.\n *\n * Burn that amount of assets from the pooled purse.\n */\n\n/**\n * @callback ZCFSeatFail\n *\n * fail called with the reason for this failure, where reason is\n * normally an instanceof Error.\n * @param {unknown} reason\n * @returns {Error}\n */\n\n/**\n * @callback ZCFGetAmountAllocated\n * The brand is used for filling in an empty amount if the `keyword`\n * is not present in the allocation\n * @param {Keyword} keyword\n * @param {Brand} [brand]\n * @returns {Amount<any>}\n */\n\n/**\n * @typedef {object} ZCFSeat\n * @property {(completion?: Completion) => void} exit\n * @property {ZCFSeatFail} fail\n * @property {() => Promise<Subscriber<Allocation>>} getSubscriber\n * @property {() => boolean} hasExited\n * @property {() => ProposalRecord} getProposal\n * @property {ZCFGetAmountAllocated} getAmountAllocated\n * @property {() => Allocation} getCurrentAllocation\n * @property {() => Allocation} getStagedAllocation\n * Deprecated: Use atomicRearrange instead\n * @property {() => boolean} hasStagedAllocation\n * Deprecated: Use atomicRearrange instead\n * @property {(newAllocation: Allocation) => boolean} isOfferSafe\n * @property {(amountKeywordRecord: AmountKeywordRecord) => AmountKeywordRecord} incrementBy\n * Deprecated: Use atomicRearrange instead\n * @property {(amountKeywordRecord: AmountKeywordRecord) => AmountKeywordRecord} decrementBy\n * Deprecated: Use atomicRearrange instead\n * @property {() => void} clear\n * Deprecated: Use atomicRearrange instead\n */\n\n/**\n * @typedef {{ zcfSeat: ZCFSeat, userSeat: ERef<UserSeat>}} ZcfSeatKit\n */\n\n/**\n * @template {object} OR Offer results\n * @typedef {(seat: ZCFSeat, offerArgs?: object) => OR} HandleOffer\n */\n\n/**\n * @template {object} [OR=unknown] Offer results\n * @typedef {HandleOffer<OR> | { handle: HandleOffer<OR> }} OfferHandler\n */\n\n/**\n * API for a contract start function.\n *\n * CAVEAT: assumes synchronous\n *\n * @deprecated define function signature directly\n *\n * @template {object} [PF=any] Public facet\n * @template {object} [CF=any] Creator facet\n * @template {object} [CT=any] Custom terms\n * @template {object} [PA=any] Private args\n * @callback ContractStartFn\n * @param {ZCF<CT>} zcf\n * @param {PA} privateArgs\n * @returns {ContractStartFnResult<PF, CF>}\n */\n\n/**\n * @template PF Public facet\n * @template CF Creator facet\n * @typedef {object} ContractStartFnResult\n * @property {PF} publicFacet\n * @property {CF} creatorFacet\n * @property {Promise<Invitation>} [creatorInvitation]\n */\n\n/**\n * @template S\n * @typedef {Ximport('../zoeService/utils').ContractOf<S>} ContractOf\n */\n\n/**\n * @typedef {Ximport('../zoeService/utils').AdminFacet} AdminFacet\n */\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{},"__needsImportMeta__":false}