{"imports":["@agoric/store","../contractFacet/rightsConservation.js","../typeGuards.js"],"exports":["TransferPartShape","atomicRearrange","atomicTransfer","fromOnly","toOnly"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let mustMatch,M,assertRightsConserved,AmountKeywordRecordShape,SeatShape;$h‍_imports([[\"@agoric/store\", [[\"mustMatch\", [$h‍_a => (mustMatch = $h‍_a)]],[\"M\", [$h‍_a => (M = $h‍_a)]]]],[\"../contractFacet/rightsConservation.js\", [[\"assertRightsConserved\", [$h‍_a => (assertRightsConserved = $h‍_a)]]]],[\"../typeGuards.js\", [[\"AmountKeywordRecordShape\", [$h‍_a => (AmountKeywordRecordShape = $h‍_a)]],[\"SeatShape\", [$h‍_a => (SeatShape = $h‍_a)]]]]]);   \n\n\n\nconst{Fail,quote:q}=assert;\n\nconst        TransferPartShape=M.splitArray(\nharden([M.opt(SeatShape),M.opt(SeatShape),M.opt(AmountKeywordRecordShape)]),\nharden([M.opt(AmountKeywordRecordShape)]));\n\n\n/**\n * @typedef {[\n *   fromSeat?: ZCFSeat,\n *   toSeat?: ZCFSeat,\n *   fromAmounts?: AmountKeywordRecord,\n *   toAmounts?: AmountKeywordRecord\n * ]} TransferPart\n */\n\n/**\n * Asks Zoe (via zcf) to rearrange the allocations among the seats\n * mentioned. This is a set of changes to allocations that must satisfy\n * several constraints. If these constraints are all met, then the\n * reallocation happens atomically. Otherwise it does not happen\n * at all.\n *\n * The conditions\n *    * All the mentioned seats are still live -- enforced by ZCF.\n *    * No outstanding stagings for any of the mentioned seats.\n *      Stagings now deprecated in favor or atomicRearrange. To\n *      prevent confusion, for each reallocation, it can only be\n *      expressed in the old way or the new way, but not a mixture.\n *    * Offer safety -- enforced by ZCF.\n *    * Overall conservation -- enforced by ZCF.\n *    * The overall transfer is expressed as an array of `TransferPart`.\n *      Each individual `TransferPart` is one of\n *       - A transfer from a `fromSeat` to a `toSeat`.\n *         This is not needed for Zoe's safety, as Zoe does\n its own overall conservation check. Rather, it helps catch\n and diagnose contract bugs earlier.\n *       - A taking from a `fromSeat`'s allocation. See the `fromOnly`\n helper.\n - A giving into a `toSeat`'s allocation. See the `toOnly`\n helper.\n *\n * TODO(6679) Refactor `atomicRearrange`from being a helper into being\n * zcf's replacement for reallocate. It was made a helper during\n * the transition, to avoid interference with progress on Zoe durability.\n *\n * See the helpers below, `fromOnly`, `toOnly`, and `atomicTransfer`,\n * which will remain helpers. These helper are for convenience\n * in expressing atomic rearrangements clearly.\n *\n * @param {ZCF} zcf\n * @param {TransferPart[]} transfers\n */$h‍_once.TransferPartShape(TransferPartShape);\nconst        atomicRearrange=(zcf,transfers)=>{\nmustMatch(transfers,M.arrayOf(M.array()),'transfers');\nconst uniqueSeatSet=new Set();\nfor(const[\nfromSeat=undefined,\ntoSeat=undefined,\nfromAmounts=undefined,\ntoAmounts=undefined]of\ntransfers){\nif(fromSeat){\nif(!fromAmounts){\nthrow Fail `Transfer from ${fromSeat} must say how much`;\n }\nuniqueSeatSet.add(fromSeat);\nif(toSeat){\n/* Conserved transfer between seats*/\nif(toAmounts){\n/* distinct amounts, so we check conservation.*/\nassertRightsConserved(\nObject.values(fromAmounts),\nObject.values(toAmounts));\n\n }/* else fromAmounts will be used as toAmounts*/\nuniqueSeatSet.add(toSeat);\n }else{\n/* Transfer only from fromSeat*/\n!toAmounts||\nFail `Transfer without toSeat cannot have toAmounts ${toAmounts}`;\n }\n }else{\ntoSeat||Fail `Transfer must have at least one of fromSeat or toSeat`;\n/* Transfer only to toSeat*/\n!fromAmounts||\nFail `Transfer without fromSeat cannot have fromAmounts ${fromAmounts}`;\ntoAmounts||Fail `Transfer to ${toSeat} must say how much`;\nuniqueSeatSet.add(toSeat);\n }\n }\n\nconst uniqueSeats=harden([...uniqueSeatSet.keys()]);\nfor(const seat of uniqueSeats){\n!seat.hasStagedAllocation()||\nFail `Cannot mix atomicRearrange with seat stagings: ${seat}`;\n }\n\n/* At this point the basic shape has been validated*/\n\ntry{\nfor(const[\nfromSeat=undefined,\ntoSeat=undefined,\nfromAmounts=undefined,\ntoAmounts=toSeat&&fromAmounts]of\ntransfers){\nif(fromSeat&&fromAmounts){\n/* testing both just to satisfy the type checker*/\nfromSeat.decrementBy(fromAmounts);\n }\nif(toSeat&&toAmounts){\n/* testing both just to satisfy the type checker*/\ntoSeat.incrementBy(toAmounts);\n }\n }\n\n/* Perhaps deprecate this >= 2 restriction?*/\nuniqueSeats.length>=2||\nFail `Can only commit a reallocation among at least 2 seats: ${q(\nuniqueSeats.length)\n }`;\n/* Take it apart and put it back together to satisfy the type checker*/\nconst[seat0,seat1,...restSeats]=uniqueSeats;\nzcf.reallocate(seat0,seat1,...restSeats);\n }finally{\nfor(const seat of uniqueSeats){\nseat.clear();\n }\n }\n };\n\n/**\n * Sometimes a TransferPart in an atomicRearrange only expresses what amounts\n * should be taken from a seat, leaving it to other TransferPart of the\n * same atomicRearrange to balance it out. For this case, the\n * `[fromSeat, undefined, fromAmounts]` form is more clearly expressed as\n * `fromOnly(fromSeat, fromAmounts)`. Unlike TransferPart, both arguments to\n * `fromOnly` are non-optional, as otherwise it doesn't make much sense.\n *\n * @param {ZCFSeat} fromSeat\n * @param {AmountKeywordRecord} fromAmounts\n * @returns {TransferPart}\n */$h‍_once.atomicRearrange(atomicRearrange);\nconst        fromOnly=(fromSeat,fromAmounts)=>\nharden([fromSeat,undefined,fromAmounts]);\n\n/**\n * Sometimes a TransferPart in an atomicRearrange only expresses what amounts\n * should be given to a seat, leaving it to other TransferPart of the\n * same atomicRearrange to balance it out. For this case, the\n * `[undefined, toSeat, undefined, toAmounts]` form is more clearly expressed as\n * `toOnly(toSeat, toAmounts)`. Unlike TransferPart, both arguments to\n * `toOnly` are non-optional, as otherwise it doesn't make much sense.\n *\n * @param {ZCFSeat} toSeat\n * @param {AmountKeywordRecord} toAmounts\n * @returns {TransferPart}\n */$h‍_once.fromOnly(fromOnly);\nconst        toOnly=(toSeat,toAmounts)=>\nharden([undefined,toSeat,undefined,toAmounts]);\n\n/**\n * Special case of atomicRearrange for a single one-way transfer\n *\n * @param {ZCF} zcf\n * @param {ZCFSeat} [fromSeat]\n * @param {ZCFSeat} [toSeat]\n * @param {AmountKeywordRecord} [fromAmounts]\n * @param {AmountKeywordRecord} [toAmounts]\n */$h‍_once.toOnly(toOnly);\nconst        atomicTransfer=(\nzcf,\nfromSeat=undefined,\ntoSeat=undefined,\nfromAmounts=undefined,\ntoAmounts=undefined)=>\natomicRearrange(zcf,harden([[fromSeat,toSeat,fromAmounts,toAmounts]]));$h‍_once.atomicTransfer(atomicTransfer);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"TransferPartShape":["TransferPartShape"],"atomicRearrange":["atomicRearrange"],"fromOnly":["fromOnly"],"toOnly":["toOnly"],"atomicTransfer":["atomicTransfer"]},"__needsImportMeta__":false}