{"imports":[],"exports":[],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   $h‍_imports([]);   /**\n * @typedef {Notifier<Ximport('@agoric/time/src/types').TimestampRecord>} PeriodNotifier\n *\n *  The Notifier that provides notifications that periods have passed.\n *  Since notifiers can't be relied on to produce an output every time\n *  they should, we'll track the time of last payment, and catch up if\n *  any times have been missed. Compound interest will be calculated\n *  using the interestRate.\n */\n\n/**\n * @typedef {Instance} AutoswapInstance\n *   The running contract instance for an Autoswap installation.  The\n *   publicFacet from the Autoswap\n *   instance is used for producing an invitation to sell the\n *   collateral on liquidation.\n */\n\n/**\n * @typedef LoanTerms\n *\n * @property {Ratio} mmr - Maintenance Margin Requirement, a Ratio record.\n * Default is 150%\n *\n * @property {AutoswapInstance} autoswapInstance\n *\n * @property {PriceAuthority} priceAuthority\n *\n *   Used for getting the current value of collateral and setting\n *   liquidation triggers.\n *\n * @property {PeriodNotifier} periodNotifier\n *\n * @property {Ratio} interestRate\n *   The rate in basis points that will be multiplied with the debt on\n *   every period to compound interest.\n *\n * @property {Ximport('@agoric/time/src/types').RelativeTime} interestPeriod\n *\n * @property {Brand} loanBrand\n * @property {Brand} collateralBrand\n */\n\n/**\n * @typedef LenderSeatProperty\n * @property {ZCFSeat} lenderSeat\n *\n *   The ZCFSeat representing the lender's position in the contract.\n */\n\n/**\n * @typedef {LoanTerms & LenderSeatProperty} LoanConfigWithLender\n *\n * The loan now has a lenderSeat, which is added to the config.\n */\n\n/**\n * @typedef BorrowerConfigProperties\n *\n * @property {ZCFSeat} collateralSeat\n *\n *   The ZCFSeat holding the collateral in escrow after the borrower\n *   escrows it\n *\n * @property {() => Amount<'nat'>} getDebt\n *\n *   A function to get the current debt\n *\n * @property {PromiseRecord<PriceQuote>} liquidationPromiseKit\n *\n *   PromiseKit that includes a promise that resolves to a PriceQuote\n *   when liquidation is triggered\n */\n\n/**\n * @typedef BorrowerConfigPropertiesMinusDebt\n *\n * @property {ZCFSeat} collateralSeat\n *\n *   The ZCFSeat holding the collateral in escrow after the borrower\n *   escrows it\n *\n * @property {PromiseRecord<PriceQuote>} liquidationPromiseKit\n *\n *   PromiseKit that includes a promise that resolves to a PriceQuote\n *   when liquidation is triggered\n */\n\n/**\n * @typedef {LoanConfigWithLender & BorrowerConfigProperties } LoanConfigWithBorrower\n *\n * The loan has a lender, a borrower, and collateral escrowed.\n */\n\n/**\n * @typedef {LoanConfigWithLender & BorrowerConfigPropertiesMinusDebt\n * } LoanConfigWithBorrowerMinusDebt\n */\n\n/**\n * @callback ScheduleLiquidation\n * @param {ZCF} zcf\n * @param {LoanConfigWithBorrower} config\n */\n\n/**\n * @callback MakeLendInvitation\n * @param {ZCF} zcf\n * @param {LoanTerms} config\n * @returns {Promise<Invitation>} lendInvitation\n */\n\n/**\n * @callback MakeBorrowInvitation\n * @param {ZCF} zcf\n * @param {LoanConfigWithLender} config\n * @returns {Promise<Invitation>} borrowInvitation\n */\n\n/**\n * @callback MakeCloseLoanInvitation\n * @param {ZCF} zcf\n * @param {LoanConfigWithBorrower} config\n * @returns {Promise<Invitation>} closeLoanInvitation\n */\n\n/**\n * Allows holder to add collateral to the contract. Exits the seat\n * after adding.\n *\n * @callback MakeAddCollateralInvitation\n * @param {ZCF} zcf\n * @param {LoanConfigWithBorrower} config\n * @returns {Promise<Invitation>} addCollateralInvitation\n */\n\n/**\n * @callback Liquidate\n * @param {ZCF} zcf\n * @param {LoanConfigWithBorrower} config\n * @returns {void}\n */\n\n/**\n * @callback MakeDebtCalculator\n * @param {DebtCalculatorConfig} debtCalculatorConfig\n */\n\n/**\n * @callback CalcInterestFn\n * @param {Amount<'nat'>} oldDebt\n * @param {Ratio} interestRate\n * @returns {Amount<'nat'>} interest\n */\n\n/**\n * @typedef {object} DebtCalculatorConfig\n * @property {CalcInterestFn} calcInterestFn\n *\n *   A function to calculate the interest, given the debt value and an\n *   interest rate in basis points.\n *\n * @property {Amount<'nat'>} originalDebt\n *\n *   The debt at the start of the loan, in Loan brand\n *\n * @property {PeriodNotifier} periodNotifier\n *\n *   The AsyncIterable to notify when a period has occurred\n *\n * @property {Ratio} interestRate\n * @property {Ximport('@agoric/time/src/types').RelativeTime} interestPeriod\n *\n *  the period at which the outstanding debt increases by the interestRate\n *\n * @property {ZCF} zcf\n *\n * @property {LoanConfigWithBorrowerMinusDebt} configMinusGetDebt\n * @property {Ximport('@agoric/time/src/types').Timestamp} basetime The starting point from which to calculate\n * interest.\n */\n\n/**\n * @typedef {object} ConfigMinusGetDebt\n * @property {ZCFSeat} collateralSeat\n * @property {PromiseRecord<any>} liquidationPromiseKit\n * @property {bigint} [mmr]\n * @property {Handle<'Instance'>} autoswapInstance\n * @property {PriceAuthority} priceAuthority\n * @property {PeriodNotifier} periodNotifier\n * @property {bigint} interestRate\n * @property {Ximport('@agoric/time/src/types').RelativeTime} interestPeriod\n * @property {ZCFSeat} lenderSeat\n */\n\n/**\n * @typedef {object} BorrowFacet\n *\n * @property {() => Promise<Invitation>} makeCloseLoanInvitation\n *\n * Make an invitation to close the loan by repaying the debt\n *   (including interest).\n *\n * @property {() => Promise<Invitation>} makeAddCollateralInvitation\n *\n * Make an invitation to add collateral to protect against liquidation\n *\n * @property {() => Promise<PriceQuote>} getLiquidationPromise\n *\n * Get a promise for a priceQuote that will resolve if liquidation\n * occurs. The priceQuote is for the value of the collateral that\n * triggered the liquidation. This may be lower than expected if the\n * price is moving quickly.\n *\n * @property {() => Ximport('@agoric/time/src/types').Timestamp} getLastCalculationTimestamp\n *\n * Get the timestamp at which the debt was most recently recalculated.\n *\n * @property {() => Notifier<Amount>} getDebtNotifier\n *\n * Get a Notifier that will be updated when the current debt (an Amount with the Loan\n * Brand) changes. This will increase as interest is added.\n *\n * @property {() => Amount} getRecentCollateralAmount\n *\n * Get a recent report of the amount of collateral in the loan\n */\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{},"__needsImportMeta__":false}