{"imports":[],"exports":[],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   $h‍_imports([]);   /* @jessie-check*/\n\n/**\n * @typedef {object} SeatData\n * @property {ProposalRecord} proposal\n * @property {Allocation} initialAllocation\n * @property {SeatHandle} seatHandle\n * @property {object} [offerArgs]\n */\n\n/**\n * Given an allocation, withdraw payments to create a payout\n *\n * @callback WithdrawPayments\n * @param {Allocation} allocation\n * @returns {PaymentPKeywordRecord}\n */\n\n/**\n * @typedef WithdrawFacet\n * @property {(allocation:Allocation) => PaymentPKeywordRecord} withdrawPayments\n */\n\n/**\n * @typedef {object} InstanceAdminHelper\n * @property {(zoeSeatAdmin: ZoeSeatAdmin) => void} exitZoeSeatAdmin\n * @property {(zoeSeatAdmin: ZoeSeatAdmin) => boolean} hasExited\n */\n\n/**\n * @typedef {object} ZoeSeatAdminKit\n * @property {UserSeat} userSeat\n * @property {ZoeSeatAdmin} zoeSeatAdmin\n */\n\n/**\n * @callback MakeZoeSeatAdminKit\n * Make the Zoe seat admin, user seat and a notifier\n * @param {Allocation} initialAllocation\n * @param {InstanceAdminHelper} instanceAdminHelper\n * @param {ProposalRecord} proposal\n * @param {WithdrawFacet} withdrawFacet\n * @param {ERef<ExitObj>} exitObj\n * @param {ERef<unknown>} [offerResult]\n * @param {Ximport('@agoric/vat-data').Baggage} baggage\n * @returns {ZoeSeatAdminKit}\n */\n\n/**\n * @callback ZoeSeatAdminExit\n * @param {Completion} [completion]\n * @returns {void}\n */\n\n/**\n * @typedef {object} ZoeSeatAdmin\n * @property {(allocation: Allocation) => void} replaceAllocation\n * @property {ZoeSeatAdminExit} exit\n * @property {ShutdownWithFailure} fail called with the reason\n * for calling fail on this seat, where reason is normally an instanceof Error.\n * @property {() => Subscriber<AmountKeywordRecord>} getExitSubscriber\n */\n\n/**\n * @callback {(brand: Brand) => AssetKind} GetAssetKind\n */\n\n/**\n * @typedef {object} HandleOfferResult\n * @property {Promise<unknown>} offerResultPromise\n * @property {ExitObj} exitObj\n */\n\n/**\n * The seatHandle may be created in either the Zoe or ZCF vat,\n * depending on whether the seat comes from a normal offer or a\n * request by the contract for an \"empty\" seat.\n *\n * @typedef {object} InstanceAdmin\n * @property {() => void} assertAcceptingOffers\n * @property {(invitationHandle: InvitationHandle,\n *     initialAllocation: Allocation,\n *     proposal: ProposalRecord,\n *     offerArgs?: object,\n * ) => UserSeat } makeUserSeat\n * @property {MakeNoEscrowSeat} makeNoEscrowSeat\n * @property {() => Instance} getInstance\n * @property {() => object} getPublicFacet\n * @property {() => IssuerKeywordRecord} getIssuers\n * @property {() => BrandKeywordRecord} getBrands\n * @property {() => object} getTerms\n * @property {() => string[]} getOfferFilter\n * @property {() => Installation} getInstallation\n * @property {(completion: Completion) => void} exitAllSeats\n * @property {ShutdownWithFailure} failAllSeats\n * @property {() => void} stopAcceptingOffers\n * @property {(string: string) => boolean} isBlocked\n * @property {(handleOfferObj: HandleOfferObj, publicFacet: unknown) => void} initDelayedState\n * @property {(strings: string[]) => void} setOfferFilter\n */\n\n/**\n * The seatHandle may be created in either the Zoe or ZCF vat,\n * depending on whether the seat comes from a normal offer or a\n * request by the contract for an \"empty\" seat.\n *\n * @typedef {object} HandleOfferObj\n * @property {(invitationHandle: InvitationHandle,\n *             seatData: SeatData,\n *            ) => HandleOfferResult} handleOffer\n */\n\n/**\n * @callback ZoeInstanceAdminMakeInvitation\n * @param {InvitationHandle} invitationHandle\n * @param {string} description\n * @param {Record<string, any>} [customDetails]\n * @param {Pattern} [proposalShape]\n * @returns {Invitation}\n */\n\n/**\n * @typedef {object} ZoeInstanceAdmin\n * @property {ZoeInstanceAdminMakeInvitation} makeInvitation\n * @property {(issuerP: ERef<Issuer>,\n *             keyword: Keyword\n *            ) => Promise<IssuerRecord>} saveIssuer\n * @property {MakeZoeMint} makeZoeMint\n * @property {RegisterFeeMint} registerFeeMint\n * @property {MakeNoEscrowSeat} makeNoEscrowSeat\n * @property {ReplaceAllocations} replaceAllocations\n * @property {(completion: Completion) => void} exitAllSeats\n * @property {ShutdownWithFailure} failAllSeats\n * @property {(seatHandle: SeatHandle, completion: Completion) => void} exitSeat\n * @property {(seatHandle: SeatHandle, reason: Error) => void} failSeat\n * @property {() => void} stopAcceptingOffers\n * @property {(strings: Array<string>) => void} setOfferFilter\n * @property {() => Array<string>} getOfferFilter\n * @property {(seatHandle: SeatHandle) => Subscriber<AmountKeywordRecord>} getExitSubscriber\n */\n\n/**\n * @callback RegisterFeeMint\n * @param {Keyword} keyword - the keyword to use for the issuer\n * @param {FeeMintAccess} allegedFeeMintAccess - an object that\n * purports to be the object that allows access to the feeMint\n * @returns {ZoeMint<'nat'>}\n */\n\n/**\n * @callback WrapIssuerKitWithZoeMint\n * @param {Keyword} keyword - the keyword to use for the issuer\n * @param {IssuerKit} localIssuerKit - an issuer kit that originates\n * within Zoe\n */\n\n/**\n * @callback MakeZoeMint\n * @param {Keyword} keyword\n * @param {AssetKind} [assetKind]\n * @param {AdditionalDisplayInfo} [displayInfo]\n * @param {IssuerOptionsRecord} [options]\n * @returns {ZoeMint}\n */\n\n/**\n * @callback MakeNoEscrowSeat\n * @param {Allocation} initialAllocation\n * @param {ProposalRecord} proposal\n * @param {ExitObj} exitObj\n * @param {SeatHandle} seatHandle\n * @returns {UserSeat}\n */\n\n/**\n * @callback ReplaceAllocations\n * @param {SeatHandleAllocation[]} seatHandleAllocations\n */\n\n/**\n * @typedef {object} SeatHandleAllocation\n * @property {SeatHandle} seatHandle\n * @property {Allocation} allocation\n */\n\n/**\n * @template {AssetKind} [K=AssetKind]\n * @typedef {object} ZoeMint\n * @property {() => IssuerRecord<K>} getIssuerRecord\n * @property {(totalToMint: Amount<K>) => void} mintAndEscrow\n * @property {(totalToBurn: Amount<K>) => void} withdrawAndBurn\n * Note that the burning is asynchronous, and so may not have happened by\n * the time withdrawAndBurn returns. We rely on our other bookkeeping so that\n * these assets are assumed burned elsewhere, so no one will try to access\n * them even before they are actually burned.\n */\n\n/**\n * @typedef {object} ZCFRoot\n * @property {StartZcf} startZcf\n * @property {RestartContract} restartContract\n */\n\n/**\n * @typedef {object} ExecuteContractResult\n * @property {object} creatorFacet\n * @property {Promise<Invitation>} creatorInvitation\n * @property {object} publicFacet\n * @property {HandleOfferObj} handleOfferObj\n */\n\n/**\n * @callback StartZcf\n * @param {ERef<ZoeInstanceAdmin>} zoeInstanceAdmin\n * @param {InstanceRecord} instanceRecordFromZoe\n * @param {IssuerRecords} issuerStorageFromZoe\n * @param {object} [privateArgs]\n * @returns {Promise<ExecuteContractResult>}\n */\n\n/**\n * @callback RestartContract\n * @param {object} [privateArgs]\n * @returns {Promise<ExecuteUpgradeableContractResult>}\n */\n\n/**\n * @callback MakeExitObj\n * @param {ProposalRecord} proposal\n * @param {ZCFSeat} zoeSeatAdmin\n * @returns {ExitObj}\n */\n\n/**\n * @typedef {object} ExitObj\n * @property {() => void} exit\n */\n\n/**\n * @typedef {Handle<'Seat'>} SeatHandle\n */\n\n/**\n * @callback GetAssetKindByBrand\n * Get the assetKind for a brand known by Zoe\n *\n * To be deleted when brands have a property for assetKind\n *\n * @param {Brand} brand\n * @returns {AssetKind}\n */\n\n/**\n * @typedef {Array<IssuerRecord>} IssuerRecords\n */\n\n/**\n * @callback MakeZCFSeat\n * @param {SeatData} seatData\n * @returns {ZCFSeat}\n */\n\n/**\n * @callback DropAllReferences\n *\n * Drops all of the references in the seat-related weakStores by\n * dropping the stores\n * @returns {void}\n */\n\n/**\n * @typedef {object} ZcfSeatManager\n * @property {MakeZCFSeat} makeZCFSeat\n * @property {Reallocate} reallocate\n * @property {DropAllReferences} dropAllReferences\n */\n\n/**\n * @typedef {object} ZcfMintReallocator\n * @property {(zcfSeat: ZCFSeat, newAllocation: Allocation) => void} reallocate\n */\n\n/**\n * @callback CreateSeatManager\n *\n * The SeatManager holds the active zcfSeats and can reallocate and\n * make new zcfSeats.\n *\n * @param {ERef<ZoeInstanceAdmin>} zoeInstanceAdmin\n * @param {GetAssetKindByBrand} getAssetKindByBrand\n * @param {ShutdownWithFailure} shutdownWithFailure\n * @param {Ximport('@agoric/vat-data').Baggage} zcfBaggage\n * @returns {{ seatManager: ZcfSeatManager, zcfMintReallocator: ZcfMintReallocator }}\n */\n\n/**\n * @callback InstanceStateAddIssuer\n *\n * Add an issuer and its keyword to the instanceRecord for the\n * contract instance\n *\n * @param {Keyword} keyword\n * @param {IssuerRecord} issuerRecord\n * @returns {void}\n */\n\n/**\n * @callback InstanceStateGetTerms\n * @returns {AnyTerms}\n */\n\n/**\n * @callback InstanceStateGetInstallation\n * @returns {Installation}\n */\n\n/**\n * @callback InstanceRecordGetIssuers\n * @returns {IssuerKeywordRecord}\n */\n\n/**\n * @callback InstanceRecordGetBrands\n * @returns {BrandKeywordRecord}\n */\n\n/**\n * @typedef {object} InstanceState\n * @property {InstanceStateAddIssuer} addIssuer\n * @property {GetInstanceRecord} getInstanceRecord\n * @property {InstanceStateGetTerms} getTerms\n * @property {InstanceStateGetInstallation} getInstallation\n * @property {InstanceRecordGetIssuers} getIssuers\n * @property {InstanceRecordGetBrands} getBrands\n * @property {(keyword: Keyword) => void} assertUniqueKeyword\n */\n\n/**\n * @callback GetInstanceRecord\n * @returns {InstanceRecord}\n */\n\n/**\n * @callback IssuerStorageGetIssuerRecords\n * @param {Issuer[]} issuers\n * @returns {IssuerRecords}\n */\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{},"__needsImportMeta__":false}