{"imports":[],"exports":[],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   $h‍_imports([]);   /* @jessie-check*/\n\n/*/ <reference types=\"ses\"/>*/\n\n/**\n * @typedef {object} ZoeService\n *\n * Zoe provides a framework for deploying and working with smart\n * contracts. It is accessed as a long-lived and well-trusted service\n * that enforces offer safety for the contracts that use it. Zoe has a\n * single `invitationIssuer` for the entirety of its lifetime. By\n * having a reference to Zoe, a user can get the `invitationIssuer`\n * and thus validate any `invitation` they receive from someone else.\n *\n * Zoe has two different facets: the public Zoe service and the\n * contract facet (ZCF). Each contract instance has a copy of ZCF\n * within its vat. The contract and ZCF never have direct access to\n * the users' payments or the Zoe purses.\n *\n * @property {GetInvitationIssuer} getInvitationIssuer\n *\n * Zoe has a single `invitationIssuer` for the entirety of its\n * lifetime. By having a reference to Zoe, a user can get the\n * `invitationIssuer` and thus validate any `invitation` they receive\n * from someone else. The mint associated with the invitationIssuer\n * creates the ERTP payments that represent the right to interact with\n * a smart contract in particular ways.\n *\n * @property {InstallBundle} install\n * @property {InstallBundleID} installBundleID\n * @property {Ximport('./utils').StartInstance} startInstance\n * @property {Offer} offer\n * @property {Ximport('./utils').GetPublicFacet} getPublicFacet\n * @property {GetIssuers} getIssuers\n * @property {GetBrands} getBrands\n * @property {Ximport('./utils').GetTerms} getTerms\n * @property {GetOfferFilter} getOfferFilter\n * @property {GetInstallationForInstance} getInstallationForInstance\n * @property {GetInstance} getInstance\n * @property {GetInstallation} getInstallation\n * @property {GetInvitationDetails} getInvitationDetails\n * Return an object with the instance, installation, description, invitation\n * handle, and any custom properties specific to the contract.\n * @property {GetFeeIssuer} getFeeIssuer\n * @property {GetConfiguration} getConfiguration\n * @property {GetBundleIDFromInstallation} getBundleIDFromInstallation\n * @property {(invitationHandle: InvitationHandle) => Pattern | undefined} getProposalShapeForInvitation\n */\n\n/**\n * @callback GetInvitationIssuer\n * @returns {Promise<Issuer<'set'>>}\n */\n\n/**\n * @callback GetFeeIssuer\n * @returns {Promise<Issuer<'nat'>>}\n */\n\n/**\n * @callback GetConfiguration\n * @returns {{\n *   feeIssuerConfig: FeeIssuerConfig,\n * }}\n */\n\n/**\n * @callback GetIssuers\n * @param {Ximport('./utils').Instance<any>} instance\n * @returns {Promise<IssuerKeywordRecord>}\n */\n\n/**\n * @callback GetBrands\n * @param {Ximport('./utils').Instance<any>} instance\n * @returns {Promise<BrandKeywordRecord>}\n */\n\n/**\n * @callback GetOfferFilter\n * @param {Ximport('./utils').Instance<any>} instance\n * @returns {string[]}\n */\n\n/**\n * @callback SetOfferFilter\n * @param {Instance} instance\n * @param {string[]} strings\n */\n\n/**\n * @callback GetInstallationForInstance\n * @param {Ximport('./utils').Instance<any>} instance\n * @returns {Promise<Installation>}\n */\n\n/**\n * @callback GetInstance\n * @param {ERef<Invitation>} invitation\n * @returns {Promise<Ximport('./utils').Instance<any>>}\n */\n\n/**\n * @callback GetInstallation\n * @param {ERef<Invitation>} invitation\n * @returns {Promise<Installation>}\n */\n\n/**\n * @callback GetInvitationDetails\n * @param {ERef<Invitation>} invitation\n * @returns {Promise<InvitationDetails>}\n */\n\n/* TODO remove support for source bundles, leaving only support for hash bundles.*/\n/* https://github.com/Agoric/agoric-sdk/issues/4565*/\n/**\n * @callback InstallBundle\n *\n * Create an installation by safely evaluating the code and\n * registering it with Zoe. Returns an installation.\n *\n * @param {Bundle | SourceBundle} bundle\n * @param {string} [bundleLabel]\n * @returns {Promise<Installation>}\n */\n\n/* TODO consolidate installBundleID into install.*/\n/* https://github.com/Agoric/agoric-sdk/issues/4974*/\n/**\n * @callback InstallBundleID\n *\n * Create an installation from a Bundle ID. Returns an installation.\n *\n * @param {BundleID} bundleID\n * @param {string} [bundleLabel]\n * @returns {Promise<Installation>}\n */\n\n/**\n * @callback GetBundleIDFromInstallation\n *\n * Verify that an alleged Installation is real, and return the Bundle ID it\n * will use for contract code.\n *\n * @param {ERef<Installation>} allegedInstallation\n * @returns {Promise<BundleID>}\n */\n\n/**\n * @typedef {<Args, Result>(\n *   invitation: ERef<Invitation<Result, Args>>,\n *   proposal?: Proposal,\n *   paymentKeywordRecord?: PaymentPKeywordRecord,\n *   offerArgs?: Args,\n *   ) => Promise<UserSeat<Result>>\n * } Offer\n *\n * To redeem an invitation, the user normally provides a proposal (their\n * rules for the offer) as well as payments to be escrowed by Zoe.  If\n * either the proposal or payments would be empty, indicate this by\n * omitting that argument or passing undefined, rather than passing an\n * empty record.\n *\n * The proposal has three parts: `want` and `give` are used by Zoe to\n * enforce offer safety, and `exit` is used to specify the particular\n * payout-liveness policy that Zoe can guarantee. `want` and `give`\n * are objects with keywords as keys and amounts as values.\n * `paymentKeywordRecord` is a record with keywords as keys, and the\n * values are the actual payments to be escrowed. A payment is\n * expected for every rule under `give`.\n */\n\n/**\n * Zoe uses seats to access or manipulate offers. They let contracts and users\n * interact with them. Zoe has two kinds of seats. ZCFSeats are used within\n * contracts and with zcf methods. UserSeats represent offers external to Zoe\n * and the contract. The party who exercises an invitation and sends the offer()\n * message to Zoe gets a UserSeat that can check payouts' status or retrieve the\n * result of processing the offer in the contract. This varies, but examples are\n * a string and an invitation for another seat.\n *\n * Also, a UserSeat can be handed to an agent outside Zoe and the contract,\n * letting them query or monitor the current state, access the payouts and\n * result, and, if it's allowed for this seat, call tryExit().\n *\n * Since anyone can attempt to exit the seat if they have a reference to it, you\n * should only share a UserSeat with trusted parties.\n *\n * UserSeat includes queries for the associated offer's current state and an\n * operation to request that the offer exit, as follows:\n *\n * @see {@link https://docs.agoric.com/zoe/api/zoe.html#userseat-object}}\n * @template {object} [OR=unknown]\n * @typedef {object} UserSeat\n * @property {() => Promise<ProposalRecord>} getProposal\n * @property {() => Promise<PaymentPKeywordRecord>} getPayouts\n * returns a promise for a KeywordPaymentRecord containing all the payouts from\n * this seat. The promise will resolve after the seat has exited.\n * @property {(keyword: Keyword) => Promise<Payment<any>>} getPayout\n * returns a promise for the Payment corresponding to the indicated keyword.\n * The promise will resolve after the seat has exited.\n * @property {() => Promise<OR>} getOfferResult\n * @property {() => void} [tryExit]\n * Note: Only works if the seat's `proposal` has an `OnDemand` `exit` clause. Zoe's\n * offer-safety guarantee applies no matter how a seat's interaction with a\n * contract ends. Under normal circumstances, the participant might be able to\n * call `tryExit()`, or the contract might do something explicitly. On exiting,\n * the seat holder gets its current `allocation` and the `seat` can no longer\n * interact with the contract.\n * @property {() => Promise<boolean>} hasExited\n * Returns true if the seat has exited, false if it is still active.\n * @property {() => Promise<0|1>} numWantsSatisfied returns 1 if the proposal's\n * want clause was satisfied by the final allocation, otherwise 0. This is\n * numeric to support a planned enhancement called \"multiples\" which will allow\n * the return value to be any non-negative number. The promise will resolve\n * after the seat has exited.\n * @property {() => Promise<Allocation>} getFinalAllocation\n * return a promise for the final allocation. The promise will resolve after the\n * seat has exited.\n * @property {() => Subscriber<Completion>} getExitSubscriber returns a subscriber that\n * will be notified when the seat has exited or failed.\n */\n\n/**\n * @typedef {Partial<ProposalRecord>} Proposal\n *\n * @typedef {{give: AmountKeywordRecord,\n *            want: AmountKeywordRecord,\n *            exit: ExitRule\n *           }} ProposalRecord\n */\n\n/**\n * @typedef {Record<Keyword, Amount<any>>} AmountKeywordRecord\n *\n * The keys are keywords, and the values are amounts. For example:\n * { Asset: AmountMath.make(assetBrand, 5n), Price:\n * AmountMath.make(priceBrand, 9n) }\n */\n\n/**\n * @typedef {object} Waker\n * @property {() => void} wake\n */\n\n/**\n * @typedef {Ximport('@agoric/time/src/types').Timestamp} Deadline\n */\n\n/**\n * @typedef {object} Timer\n * @property {(deadline: Deadline, wakerP: ERef<Waker>) => void} setWakeup\n */\n\n/**\n * @typedef {object} OnDemandExitRule\n * @property {null} onDemand\n */\n\n/**\n * @typedef {object} WaivedExitRule\n * @property {null} waived\n */\n\n/**\n * @typedef {object} AfterDeadlineExitRule\n * @property {{timer:Timer, deadline:Deadline}} afterDeadline\n */\n\n/**\n * @typedef {OnDemandExitRule | WaivedExitRule | AfterDeadlineExitRule} ExitRule\n *\n * The possible keys are 'waived', 'onDemand', and 'afterDeadline'.\n * `timer` and `deadline` only are used for the `afterDeadline` key.\n * The possible records are:\n * `{ waived: null }`\n * `{ onDemand: null }`\n * `{ afterDeadline: { timer :Timer<Deadline>, deadline :Deadline } }\n */\n\n/**\n * @typedef {Ximport('./utils').Instance<any>} Instance\n */\n\n/**\n * @typedef {Ximport('@agoric/swingset-vat').VatAdminSvc} VatAdminSvc\n */\n\n/**\n * @typedef {{bundleCap: Ximport('@agoric/swingset-vat').BundleCap } | {name: string} | {id: BundleID}} ZCFSpec\n */\n\n/**\n * @typedef {Record<string, any>} SourceBundle\n * Opaque type for a JSONable source bundle\n */\n\n/**\n * @typedef {Record<Keyword,ERef<Payment<any>>>} PaymentPKeywordRecord\n * @typedef {Record<Keyword,Payment<any>>} PaymentKeywordRecord\n */\n\n/**\n * @typedef {object} InvitationDetails\n * @property {Installation} installation\n * @property {Ximport('./utils').Instance<any>} instance\n * @property {InvitationHandle} handle\n * @property {string} description\n * @property {Record<string, any>} [customDetails]\n */\n\n/**\n * @template [SF=any] contract start function\n * @typedef {Ximport('./utils').Installation<SF>} Installation\n */\n\n/**\n * @template {Installation} I\n * @typedef {Ximport('./utils').InstallationStart<I>} InstallationStart\n */\n\n/**\n * @typedef {object} FeeIssuerConfig\n * @property {string} name\n * @property {AssetKind} assetKind\n * @property {DisplayInfo} displayInfo\n */\n\n/**\n * @typedef {object} ZoeFeesConfig\n * @property {NatValue} getPublicFacetFee\n */\n\n/**\n * @typedef {Handle<'feeMintAccess'>} FeeMintAccess\n */\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{},"__needsImportMeta__":false}