{"imports":[],"exports":[],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   $h‍_imports([]);   /* @jessie-check*/\n\n/**\n * @typedef {object} PriceQuote\n * @property {Amount<'set'>} quoteAmount\n * Amount whose value is a PriceQuoteValue\n * @property {ERef<Payment<'set'>>} quotePayment\n * The `quoteAmount` wrapped as a payment\n */\n\n/**\n * @typedef {[PriceDescription]} PriceQuoteValue\n * A single-valued set of PriceDescriptions.  This is the `value` in\n * PriceQuote.quoteAmount (`{ brand, value: PriceQuoteValue }`).\n */\n\n/**\n * @typedef {object} PriceDescription\n * A description of a single quote\n * @property {Amount<'nat'>} amountIn\n * The amount supplied to a trade\n * @property {Amount<'nat'>} amountOut\n * The quoted result of trading `amountIn`\n * @property {Ximport('@agoric/time/src/types').TimerService} timer\n * The service that gave the `timestamp`\n * @property {Ximport('@agoric/time/src/types').TimestampRecord} timestamp\n * A timestamp according to `timer` for the quote\n * @property {any} [conditions]\n * Additional conditions for the quote\n */\n\n/**\n * @callback PriceQuoteCreate\n * @param {PriceQuery} priceQuery\n * @returns {ERef<PriceQuote> | undefined}\n */\n\n/**\n * @callback PriceQuoteTrigger\n * @param {PriceQuoteCreate} createQuote\n */\n\n/**\n * @typedef {object} PriceAuthorityAdmin\n * @property {(createQuote: PriceQuoteCreate) => Promise<void>} fireTriggers\n */\n\n/**\n * @typedef {object} PriceAuthorityKit\n * @property {PriceAuthority} priceAuthority\n * @property {PriceAuthorityAdmin} adminFacet\n */\n\n/**\n * @typedef {object} MutableQuote\n * @property {(reason?: any) => void} cancel\n * @property {(amountIn: Amount<'nat'>, amountOut: Amount<'nat'>) => void} updateLevel\n * @property {() => ERef<PriceQuote>} getPromise\n */\n\n/**\n * @typedef {object} PriceAuthority\n * An object that mints PriceQuotes and handles\n * triggers and notifiers for changes in the price\n *\n * @property {(brandIn: Brand, brandOut: Brand) => ERef<Issuer<'set'>>} getQuoteIssuer\n * Get the ERTP issuer of PriceQuotes for a given brandIn/brandOut pair\n *\n * @property {(brandIn: Brand,\n *             brandOut: Brand\n * ) => ERef<Ximport('@agoric/time/src/types').TimerService>} getTimerService\n * Get the timer used in PriceQuotes for a given brandIn/brandOut pair\n *\n * @property {(amountIn: Amount<'nat'>,\n *             brandOut: Brand<'nat'>\n *            ) => ERef<Notifier<PriceQuote>>} makeQuoteNotifier\n * Be notified of the latest PriceQuotes for a given\n * `amountIn`.  The rate at which these are issued may be very different between\n * `priceAuthorities`.\n *\n * @property {(deadline: Ximport('@agoric/time/src/types').Timestamp,\n *             amountIn: Amount<'nat'>,\n *             brandOut: Brand<'nat'>\n * ) => Promise<PriceQuote>} quoteAtTime\n * Resolves after `deadline` passes on the\n * priceAuthority's timerService with the price quote of `amountIn` at that time\n *\n * @property {(amountIn: Amount<'nat'>,\n *             brandOut: Brand<'nat'>\n * ) => Promise<PriceQuote>} quoteGiven\n * Get a quote corresponding to the specified amountIn\n *\n * @property {(brandIn: Brand<'nat'>,\n *             amountOut: Amount<'nat'>) => Promise<PriceQuote>} quoteWanted\n * Get a quote corresponding to the specified amountOut\n *\n * @property {(amountIn: Amount<'nat'>,\n *             amountOutLimit: Amount<'nat'>\n * ) => Promise<PriceQuote>} quoteWhenGT\n * Resolve when a price quote of `amountIn` exceeds `amountOutLimit`\n *\n * @property {(amountIn: Amount<'nat'>,\n *             amountOutLimit: Amount<'nat'>\n * ) => Promise<PriceQuote>} quoteWhenGTE\n * Resolve when a price quote of `amountIn` reaches or exceeds `amountOutLimit`\n *\n * @property {(amountIn: Amount,\n *             amountOutLimit: Amount\n * ) => Promise<PriceQuote>} quoteWhenLTE\n * Resolve when a price quote of `amountIn` reaches or drops below\n * `amountOutLimit`\n *\n * @property {(amountIn: Amount,\n *             amountOutLimit: Amount\n * ) => Promise<PriceQuote>} quoteWhenLT\n * Resolve when the price quote of `amountIn` drops below `amountOutLimit`\n *\n * @property {(amountIn: Amount,\n *             amountOutLimit: Amount\n * ) => ERef<MutableQuote>} mutableQuoteWhenGT\n * Resolve when a price quote of `amountIn` exceeds `amountOutLimit`\n *\n * @property {(amountIn: Amount,\n *             amountOutLimit: Amount\n * ) => ERef<MutableQuote>} mutableQuoteWhenGTE\n * Resolve when a price quote of `amountIn` reaches or exceeds\n * `amountOutLimit`\n *\n * @property {(amountIn: Amount,\n *             amountOutLimit: Amount\n * ) => ERef<MutableQuote>} mutableQuoteWhenLTE\n * Resolve when a price quote of `amountIn` reaches or drops below\n * `amountOutLimit`\n *\n * @property {(amountIn: Amount,\n *             amountOutLimit: Amount\n * ) => ERef<MutableQuote>} mutableQuoteWhenLT\n * Resolve when the price quote of `amountIn` drops below `amountOutLimit`\n */\n\n/**\n * @typedef {(amount: Amount<'nat'>) => Amount<'nat'>} PriceCalculator\n */\n\n/**\n * @callback PriceQuery\n * @param {PriceCalculator} calcAmountIn\n * @param {PriceCalculator} calcAmountOut\n * @returns {{ amountIn: Amount<'nat'>, amountOut: Amount<'nat'>, timestamp?: Ximport('@agoric/time/src/types').TimestampRecord } | undefined}\n */\n\n/**\n * @typedef {object} PriceLevel\n * A description of a single quote\n *\n * @property {Amount<'nat'>} amountIn\n * The amount supplied to a trade\n * @property {Amount<'nat'>} amountOut\n * The quoted result of trading `amountIn`\n */\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{},"__needsImportMeta__":false}