{"imports":[],"exports":["makeEnvironmentCaptor"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   $h‍_imports([]);   /* @ts-check*/\n\n/* `@endo/env-options` needs to be imported quite early, and so should*/\n/* avoid importing from ses or anything that depends on ses.*/\n\n/* /////////////////////////////////////////////////////////////////////////////*/\n/* Prelude of cheap good - enough imitations of things we'd use or*/\n/* do differently if we could depend on ses*/\n\nconst{freeze}=Object;\nconst{apply}=Reflect;\n\n/* Should be equivalent to the one in ses' commons.js even though it*/\n/* uses the other technique.*/\nconst uncurryThis=\n(fn)=>\n(receiver,...args)=>\napply(fn,receiver,args);\nconst arrayPush=uncurryThis(Array.prototype.push);\n\nconst q=JSON.stringify;\n\nconst Fail=(literals,...args)=>{\nlet msg=literals[0];\nfor(let i=0;i<args.length;i+=1){\nmsg= `${msg}${args[i]}${literals[i+1]}`;\n }\nthrow Error(msg);\n };\n\n/* end prelude*/\n/* /////////////////////////////////////////////////////////////////////////////*/\n\n/**\n * `makeEnvironmentCaptor` provides a mechanism for getting environment\n * variables, if they are needed, and a way to catalog the names of all\n * the environment variables that were captured.\n *\n * @param {object} aGlobal\n */\nconst        makeEnvironmentCaptor=(aGlobal)=>{\nconst capturedEnvironmentOptionNames=[];\n\n/**\n * Gets an environment option by name and returns the option value or the\n * given default.\n *\n * @param {string} optionName\n * @param {string} defaultSetting\n * @returns {string}\n */\nconst getEnvironmentOption=(optionName,defaultSetting)=>{\n/* eslint-disable-next-line @endo/no-polymorphic-call*/\ntypeof optionName==='string'||\nFail `Environment option name ${q(optionName)} must be a string.`;\n/* eslint-disable-next-line @endo/no-polymorphic-call*/\ntypeof defaultSetting==='string'||\nFail `Environment option default setting ${q(\ndefaultSetting)\n } must be a string.`;\n\n/** @type {string} */\nlet setting=defaultSetting;\nconst globalProcess=aGlobal.process;\nif(globalProcess&&typeof globalProcess==='object'){\nconst globalEnv=globalProcess.env;\nif(globalEnv&&typeof globalEnv==='object'){\nif(optionName in globalEnv){\narrayPush(capturedEnvironmentOptionNames,optionName);\nconst optionValue=globalEnv[optionName];\n/* eslint-disable-next-line @endo/no-polymorphic-call*/\ntypeof optionValue==='string'||\nFail `Environment option named ${q(\noptionName)\n }, if present, must have a corresponding string value, got ${q(\noptionValue)\n }`;\nsetting=optionValue;\n }\n }\n }\nreturn setting;\n };\nfreeze(getEnvironmentOption);\n\nconst getCapturedEnvironmentOptionNames=()=>{\nreturn freeze([...capturedEnvironmentOptionNames]);\n };\nfreeze(getCapturedEnvironmentOptionNames);\n\nreturn freeze({getEnvironmentOption,getCapturedEnvironmentOptionNames});\n };$h‍_once.makeEnvironmentCaptor(makeEnvironmentCaptor);\nfreeze(makeEnvironmentCaptor);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"makeEnvironmentCaptor":["makeEnvironmentCaptor"]},"__needsImportMeta__":false}