{"imports":["@endo/env-options"],"exports":["trackTurns"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let makeEnvironmentCaptor;$h‍_imports([[\"@endo/env-options\", [[\"makeEnvironmentCaptor\", [$h‍_a => (makeEnvironmentCaptor = $h‍_a)]]]]]);   \n\n\nconst{getEnvironmentOption}=makeEnvironmentCaptor(globalThis);\n\n/* NOTE: We can't import these because they're not in scope before lockdown.*/\n/* import { assert, details as X, Fail } from '@agoric/assert';*/\n\n/* WARNING: Global Mutable State!*/\n/* This state is communicated to `assert` that makes it available to the*/\n/* causal console, which affects the console log output. Normally we*/\n/* regard the ability to see console log output as a meta-level privilege*/\n/* analogous to the ability to debug. Aside from that, this module should*/\n/* not have any observably mutable state.*/\n\nlet hiddenPriorError;\nlet hiddenCurrentTurn=0;\nlet hiddenCurrentEvent=0;\n\nconst DEBUG=getEnvironmentOption('DEBUG','');\n\n/* Turn on if you seem to be losing error logging at the top of the event loop*/\nconst VERBOSE=DEBUG.split(':').includes('track-turns');\n\n/* Track-turns is disabled by default and can be enabled by an environment*/\n/* option.*/\nconst TRACK_TURNS=getEnvironmentOption('TRACK_TURNS','disabled');\nif(TRACK_TURNS!=='enabled'&&TRACK_TURNS!=='disabled'){\nthrow TypeError( `unrecognized TRACK_TURNS ${JSON.stringify(TRACK_TURNS)}`);\n }\nconst ENABLED=(TRACK_TURNS||'disabled')==='enabled';\n\n/* We hoist the following functions out of trackTurns() to discourage the*/\n/* closures from holding onto 'args' or 'func' longer than necessary,*/\n/* which we've seen cause HandledPromise arguments to be retained for*/\n/* a surprisingly long time.*/\n\nconst addRejectionNote=(detailsNote)=>(reason)=>{\nif(reason instanceof Error){\nassert.note(reason,detailsNote);\n }\nif(VERBOSE){\nconsole.log('REJECTED at top of event loop',reason);\n }\n };\n\nconst wrapFunction=\n(func,sendingError,X)=>\n(...args)=>{\nhiddenPriorError=sendingError;\nhiddenCurrentTurn+=1;\nhiddenCurrentEvent=0;\ntry{\nlet result;\ntry{\nresult=func(...args);\n }catch(err){\nif(err instanceof Error){\nassert.note(\nerr,\nX `Thrown from: ${hiddenPriorError}:${hiddenCurrentTurn}.${hiddenCurrentEvent}`);\n\n }\nif(VERBOSE){\nconsole.log('THROWN to top of event loop',err);\n }\nthrow err;\n }\n/* Must capture this now, not when the catch triggers.*/\nconst detailsNote=X `Rejection from: ${hiddenPriorError}:${hiddenCurrentTurn}.${hiddenCurrentEvent}`;\nPromise.resolve(result).catch(addRejectionNote(detailsNote));\nreturn result;\n }finally{\nhiddenPriorError=undefined;\n }\n };\n\n/**\n * Given a list of `TurnStarterFn`s, returns a list of `TurnStarterFn`s whose\n * `this`-free call behaviors are not observably different to those that\n * cannot see console output. The only purpose is to cause additional\n * information to appear on the console.\n *\n * The call to `trackTurns` is itself a sending event, that occurs in some call\n * stack in some turn number at some event number within that turn. Each call\n * to any of the returned `TurnStartFn`s is a receiving event that begins a new\n * turn. This sending event caused each of those receiving events.\n *\n * @template {TurnStarterFn[]} T\n * @param {T} funcs\n * @returns {T}\n */\nconst        trackTurns=(funcs)=>{\nif(!ENABLED||typeof globalThis==='undefined'||!globalThis.assert){\nreturn funcs;\n }\nconst{details:X}=assert;\n\nhiddenCurrentEvent+=1;\nconst sendingError=Error(\n `Event: ${hiddenCurrentTurn}.${hiddenCurrentEvent}`);\n\nif(hiddenPriorError!==undefined){\nassert.note(sendingError,X `Caused by: ${hiddenPriorError}`);\n }\n\nreturn (/** @type {T} */\nfuncs.map((func)=>func&&wrapFunction(func,sendingError,X)));\n\n };\n\n/**\n * An optional function that is not this-sensitive, expected to be called at\n * bottom of stack to start a new turn.\n *\n * @typedef {((...args: any[]) => any) | undefined} TurnStarterFn\n */$h‍_once.trackTurns(trackTurns);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"trackTurns":["trackTurns"]},"__needsImportMeta__":false}