{"imports":["@endo/far","@endo/patterns"],"exports":["defendPrototype","defendPrototypeKit"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let E,Far,listDifference,objectMap,mustMatch,M;$h‍_imports([[\"@endo/far\", [[\"E\", [$h‍_a => (E = $h‍_a)]],[\"Far\", [$h‍_a => (Far = $h‍_a)]]]],[\"@endo/patterns\", [[\"listDifference\", [$h‍_a => (listDifference = $h‍_a)]],[\"objectMap\", [$h‍_a => (objectMap = $h‍_a)]],[\"mustMatch\", [$h‍_a => (mustMatch = $h‍_a)]],[\"M\", [$h‍_a => (M = $h‍_a)]]]]]);   \n\n\n/** @typedef {Ximport('@endo/patterns').Method} Method */\n/** @typedef {Ximport('@endo/patterns').MethodGuard} MethodGuard */\n/** @typedef {Ximport('@endo/patterns').InterfaceGuard} InterfaceGuard */\n\nconst{quote:q,Fail}=assert;\nconst{apply,ownKeys}=Reflect;\nconst{defineProperties}=Object;\n\n/**\n * A method guard, for inclusion in an interface guard, that enforces only that\n * all arguments are passable and that the result is passable. (In far classes,\n * \"any\" means any *passable*.) This is the least possible enforcement for a\n * method guard, and is implied by all other method guards.\n */\nconst MinMethodGuard=M.call().rest(M.any()).returns(M.any());\n\nconst defendSyncArgs=(args,methodGuard,label)=>{\nconst{argGuards,optionalArgGuards,restArgGuard}=methodGuard;\nconst paramsPattern=M.splitArray(\nargGuards,\noptionalArgGuards,\nrestArgGuard);\n\nmustMatch(harden(args),paramsPattern,label);\n };\n\n/**\n * @param {Method} method\n * @param {MethodGuard} methodGuard\n * @param {string} label\n * @returns {Method}\n */\nconst defendSyncMethod=(method,methodGuard,label)=>{\nconst{returnGuard}=methodGuard;\nconst{syncMethod}={\n/* Note purposeful use of `this` and concise method syntax*/\nsyncMethod(...args){\ndefendSyncArgs(harden(args),methodGuard,label);\nconst result=apply(method,this,args);\nmustMatch(harden(result),returnGuard, `${label}: result`);\nreturn result;\n }};\n\nreturn syncMethod;\n };\n\nconst isAwaitArgGuard=(argGuard)=>\nargGuard&&typeof argGuard==='object'&&argGuard.klass==='awaitArg';\n\nconst desync=(methodGuard)=>{\nconst{argGuards,optionalArgGuards=[],restArgGuard}=methodGuard;\n!isAwaitArgGuard(restArgGuard)||\nFail `Rest args may not be awaited: ${restArgGuard}`;\nconst rawArgGuards=[...argGuards,...optionalArgGuards];\n\nconst awaitIndexes=[];\nfor(let i=0;i<rawArgGuards.length;i+=1){\nconst argGuard=rawArgGuards[i];\nif(isAwaitArgGuard(argGuard)){\nrawArgGuards[i]=argGuard.argGuard;\nawaitIndexes.push(i);\n }\n }\nreturn{\nawaitIndexes,\nrawMethodGuard:{\nargGuards:rawArgGuards.slice(0,argGuards.length),\noptionalArgGuards:rawArgGuards.slice(argGuards.length),\nrestArgGuard}};\n\n\n };\n\nconst defendAsyncMethod=(method,methodGuard,label)=>{\nconst{returnGuard}=methodGuard;\nconst{awaitIndexes,rawMethodGuard}=desync(methodGuard);\nconst{asyncMethod}={\n/* Note purposeful use of `this` and concise method syntax*/\nasyncMethod(...args){\nconst awaitList=awaitIndexes.map((i)=>args[i]);\nconst p=Promise.all(awaitList);\nconst rawArgs=[...args];\nconst resultP=E.when(p,(awaitedArgs)=>{\nfor(let j=0;j<awaitIndexes.length;j+=1){\nrawArgs[awaitIndexes[j]]=awaitedArgs[j];\n }\ndefendSyncArgs(rawArgs,rawMethodGuard,label);\nreturn apply(method,this,rawArgs);\n });\nreturn E.when(resultP,(result)=>{\nmustMatch(harden(result),returnGuard, `${label}: result`);\nreturn result;\n });\n }};\n\nreturn asyncMethod;\n };\n\n/**\n *\n * @param {Method} method\n * @param {MethodGuard} methodGuard\n * @param {string} label\n */\nconst defendMethod=(method,methodGuard,label)=>{\nconst{klass,callKind}=methodGuard;\nassert(klass==='methodGuard');\nif(callKind==='sync'){\nreturn defendSyncMethod(method,methodGuard,label);\n }else{\nassert(callKind==='async');\nreturn defendAsyncMethod(method,methodGuard,label);\n }\n };\n\n/**\n * @typedef {string} FacetName\n */\n\n/**\n * @typedef {Record<string | symbol, CallableFunction>} Methods\n */\n\n/**\n * @template [S = any]\n * @template {Methods} [M = any]\n * @typedef {{ state: S, self: M }} ClassContext\n */\n\n/**\n * @template [S = any]\n * @template {Record<FacetName, Methods>} [F = any]\n * @typedef {{ state: S, facets: F }} KitContext\n */\n\n/**\n * @typedef {(facet: any) => KitContext} KitContextProvider\n * @typedef {((representative: any) => ClassContext) | KitContextProvider} ContextProvider\n */\n\n/**\n * @param {string} methodTag\n * @param {ContextProvider} contextProvider\n * @param {CallableFunction} behaviorMethod\n * @param {boolean} [thisfulMethods]\n * @param {MethodGuard} [methodGuard]\n */\nconst bindMethod=(\nmethodTag,\ncontextProvider,\nbehaviorMethod,\nthisfulMethods=false,\nmethodGuard=undefined)=>\n{\nassert.typeof(behaviorMethod,'function');\n\nconst getContext=(self)=>{\nconst context=contextProvider(self);\ncontext||\nFail `${q(methodTag)} may only be applied to a valid instance: ${self}`;\nreturn context;\n };\n\n/* Violating all Jessie rules to create representatives that inherit*/\n/* methods from a shared prototype. The bound method therefore needs*/\n/* to mention `this`. We define it using concise method syntax*/\n/* so that it will be `this` sensitive but not constructable.*/\n/**/\n/* We normally consider `this` unsafe because of the hazard of a*/\n/* method of one abstraction being applied to an instance of*/\n/* another abstraction. To prevent that attack, the bound method*/\n/* checks that its `this` is in the map in which its representatives*/\n/* are registered.*/\nlet{method}=thisfulMethods?\n{\nmethod(...args){\nthis||\nFail `thisful method ${methodTag} called without 'this' object`;\nconst context=getContext(this);\nreturn apply(behaviorMethod,context,args);\n }}:\n\n{\nmethod(...args){\nconst context=getContext(this);\nreturn apply(behaviorMethod,null,[context,...args]);\n }};\n\nif(methodGuard){\nmethod=defendMethod(method,methodGuard,methodTag);\n }else if(thisfulMethods){\n/* For far classes ensure that inputs and outputs are passable.*/\nmethod=defendMethod(method,MinMethodGuard,methodTag);\n }\ndefineProperties(method,{\nname:{value:methodTag},\nlength:{\nvalue:thisfulMethods?behaviorMethod.length:behaviorMethod.length-1}});\n\n\nreturn method;\n };\n\n/**\n * @template {Record<string | symbol, CallableFunction>} T\n * @param {string} tag\n * @param {ContextProvider} contextProvider\n * @param {T} behaviorMethods\n * @param {boolean} [thisfulMethods]\n * @param {InterfaceGuard} [interfaceGuard]\n * @returns {T & Ximport('@endo/eventual-send').RemotableBrand<{}, T>}\n */\nconst        defendPrototype=(\ntag,\ncontextProvider,\nbehaviorMethods,\nthisfulMethods=false,\ninterfaceGuard=undefined)=>\n{\nconst prototype={};\nconst methodNames=ownKeys(behaviorMethods).filter(\n/* By ignoring any method named \"constructor\", we can use a*/\n/* class.prototype as a behaviorMethods.*/\n(name)=>name!=='constructor');\n\nlet methodGuards;\nif(interfaceGuard){\nconst{\nklass,\ninterfaceName,\nmethodGuards:mg,\nsloppy=false}=\ninterfaceGuard;\nmethodGuards=mg;\nassert.equal(klass,'Interface');\nassert.typeof(interfaceName,'string');\n{\nconst methodGuardNames=ownKeys(methodGuards);\nconst unimplemented=listDifference(methodGuardNames,methodNames);\nunimplemented.length===0||\nFail `methods ${q(unimplemented)} not implemented by ${q(tag)}`;\nif(!sloppy){\nconst unguarded=listDifference(methodNames,methodGuardNames);\nunguarded.length===0||\nFail `methods ${q(unguarded)} not guarded by ${q(interfaceName)}`;\n }\n }\n }\nfor(const prop of methodNames){\nprototype[prop]=bindMethod(\n `In ${q(prop)} method of (${tag})`,\ncontextProvider,\nbehaviorMethods[prop],\nthisfulMethods,\n/* TODO some tool does not yet understand the `?.[` syntax*/\nmethodGuards&&methodGuards[prop]);\n\n }\n\nreturn Far(tag,/** @type {T} */prototype);\n };$h‍_once.defendPrototype(defendPrototype);\nharden(defendPrototype);\n\n/**\n * @param {string} tag\n * @param {Record<FacetName, KitContextProvider>} contextProviderKit\n * @param {Record<FacetName, Record<string | symbol, CallableFunction>>} behaviorMethodsKit\n * @param {boolean} [thisfulMethods]\n * @param {Record<string, InterfaceGuard>} [interfaceGuardKit]\n */\nconst        defendPrototypeKit=(\ntag,\ncontextProviderKit,\nbehaviorMethodsKit,\nthisfulMethods=false,\ninterfaceGuardKit=undefined)=>\n{\nconst facetNames=ownKeys(behaviorMethodsKit).sort();\nfacetNames.length>1||Fail `A multi-facet object must have multiple facets`;\nif(interfaceGuardKit){\nconst interfaceNames=ownKeys(interfaceGuardKit);\nconst extraInterfaceNames=listDifference(facetNames,interfaceNames);\nextraInterfaceNames.length===0||\nFail `Interfaces ${q(extraInterfaceNames)} not implemented by ${q(tag)}`;\nconst extraFacetNames=listDifference(interfaceNames,facetNames);\nextraFacetNames.length===0||\nFail `Facets ${q(extraFacetNames)} of ${q(tag)} not guarded by interfaces`;\n }\nconst contextMapNames=ownKeys(contextProviderKit);\nconst extraContextNames=listDifference(facetNames,contextMapNames);\nextraContextNames.length===0||\nFail `Contexts ${q(extraContextNames)} not implemented by ${q(tag)}`;\nconst extraFacetNames=listDifference(contextMapNames,facetNames);\nextraFacetNames.length===0||\nFail `Facets ${q(extraFacetNames)} of ${q(tag)} missing contexts`;\nreturn objectMap(behaviorMethodsKit,(behaviorMethods,facetName)=>\ndefendPrototype(\n `${tag} ${facetName}`,\ncontextProviderKit[facetName],\nbehaviorMethods,\nthisfulMethods,\ninterfaceGuardKit&&interfaceGuardKit[facetName]));\n\n\n };$h‍_once.defendPrototypeKit(defendPrototypeKit);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"defendPrototype":["defendPrototype"],"defendPrototypeKit":["defendPrototypeKit"]},"__needsImportMeta__":false}