{"imports":["@endo/nat","@endo/pass-style","./encodeToCapData.js"],"exports":["decodeToJustin"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let Nat,getErrorConstructor,isObject,passableSymbolForName,QCLASS;$h‍_imports([[\"@endo/nat\", [[\"Nat\", [$h‍_a => (Nat = $h‍_a)]]]],[\"@endo/pass-style\", [[\"getErrorConstructor\", [$h‍_a => (getErrorConstructor = $h‍_a)]],[\"isObject\", [$h‍_a => (isObject = $h‍_a)]],[\"passableSymbolForName\", [$h‍_a => (passableSymbolForName = $h‍_a)]]]],[\"./encodeToCapData.js\", [[\"QCLASS\", [$h‍_a => (QCLASS = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\n\n\n/** @typedef {Ximport('./types.js').Encoding} Encoding */\n/** @template T @typedef {Ximport('./types.js').CapData<T>} CapData */\n\nconst{ownKeys}=Reflect;\nconst{isArray}=Array;\nconst{stringify:quote}=JSON;\nconst{quote:q,details:X,Fail}=assert;\n\n/**\n * @typedef {object} Indenter\n * @property {(openBracket: string) => number} open\n * @property {() => number} line\n * @property {(token: string) => number} next\n * @property {(closeBracket: string) => number} close\n * @property {() => string} done\n */\n\n/**\n * Generous whitespace for readability\n *\n * @returns {Indenter}\n */\nconst makeYesIndenter=()=>{\nconst strings=[];\nlet level=0;\nlet needSpace=false;\nconst line=()=>{\nneedSpace=false;\nreturn strings.push('\\n','  '.repeat(level));\n };\nreturn harden({\nopen:(openBracket)=>{\nlevel+=1;\nif(needSpace){\nstrings.push(' ');\n }\nneedSpace=false;\nreturn strings.push(openBracket);\n },\nline,\nnext:(token)=>{\nif(needSpace&&token!==','){\nstrings.push(' ');\n }\nneedSpace=true;\nreturn strings.push(token);\n },\nclose:(closeBracket)=>{\nassert(level>=1);\nlevel-=1;\nline();\nreturn strings.push(closeBracket);\n },\ndone:()=>{\nassert.equal(level,0);\nreturn strings.join('');\n }});\n\n };\n\n/**\n * If the last character of one token together with the first character\n * of the next token matches this pattern, then the two tokens must be\n * separated by whitespace to preserve their meaning. Otherwise the\n * whitespace in unnecessary.\n *\n * The `<!` and `->` cases prevent the accidental formation of an\n * html-like comment. I don't think the double angle brackets are actually\n * needed but I haven't thought about it enough to remove them.\n */\nconst badPairPattern=/^(?:\\w\\w|<<|>>|\\+\\+|--|<!|->)$/;\n\n/**\n * Minimum whitespace needed to preseve meaning.\n *\n * @returns {Indenter}\n */\nconst makeNoIndenter=()=>{\n/** @type {string[]} */\nconst strings=[];\nreturn harden({\nopen:(openBracket)=>strings.push(openBracket),\nline:()=>strings.length,\nnext:(token)=>{\nif(strings.length>=1){\nconst last=strings[strings.length-1];\nif(last.length>=1&&token.length>=1){\nconst pair= `${last[last.length-1]}${token[0]}`;\nif(badPairPattern.test(pair)){\nstrings.push(' ');\n }\n }\n }\nreturn strings.push(token);\n },\nclose:(closeBracket)=>{\nif(strings.length>=1&&strings[strings.length-1]===','){\nstrings.pop();\n }\nreturn strings.push(closeBracket);\n },\ndone:()=>strings.join('')});\n\n };\n\nconst identPattern=/^[a-zA-Z]\\w*$/;\nharden(identPattern);\nconst AtAtPrefixPattern=/^@@(.*)$/;\nharden(AtAtPrefixPattern);\n\n/**\n * @param {Encoding} encoding\n * @param {boolean=} shouldIndent\n * @param {any[]} [slots]\n * @returns {string}\n */\nconst decodeToJustin=(encoding,shouldIndent=false,slots=[])=>{\n/**\n * The first pass does some input validation.\n * Its control flow should mirror `recur` as closely as possible\n * and the two should be maintained together. They must visit everything\n * in the same order.\n *\n * TODO now that ibids are gone, we should fold this back together into\n * one validating pass.\n *\n * @param {Encoding} rawTree\n * @returns {void}\n */\nconst prepare=(rawTree)=>{\nif(!isObject(rawTree)){\nreturn;\n }\n/* Assertions of the above to narrow the type.*/\nassert.typeof(rawTree,'object');\nassert(rawTree!==null);\nif(QCLASS in rawTree){\nconst qclass=rawTree[QCLASS];\ntypeof qclass==='string'||\nFail `invalid qclass typeof ${q(typeof qclass)}`;\nassert(!isArray(rawTree));\nswitch(rawTree['@qclass']){\ncase'undefined':\ncase'NaN':\ncase'Infinity':\ncase'-Infinity':{\nreturn;\n }\ncase'bigint':{\nconst{digits}=rawTree;\ntypeof digits==='string'||\nFail `invalid digits typeof ${q(typeof digits)}`;\nreturn;\n }\ncase'@@asyncIterator':{\nreturn;\n }\ncase'symbol':{\nconst{name}=rawTree;\nassert.typeof(name,'string');\nconst sym=passableSymbolForName(name);\nassert.typeof(sym,'symbol');\nreturn;\n }\ncase'tagged':{\nconst{tag,payload}=rawTree;\nassert.typeof(tag,'string');\nprepare(payload);\nreturn;\n }\ncase'slot':{\nconst{index,iface}=rawTree;\nassert.typeof(index,'number');\nNat(index);\nif(iface!==undefined){\nassert.typeof(iface,'string');\n }\nreturn;\n }\ncase'hilbert':{\nconst{original,rest}=rawTree;\n'original'in rawTree||\nFail `Invalid Hilbert Hotel encoding ${rawTree}`;\nprepare(original);\nif('rest'in rawTree){\nif(typeof rest!=='object'){\nthrow Fail `Rest ${rest} encoding must be an object`;\n }\nif(rest===null){\nthrow Fail `Rest ${rest} encoding must not be null`;\n }\nif(isArray(rest)){\nthrow Fail `Rest ${rest} encoding must not be an array`;\n }\nif(QCLASS in rest){\nthrow Fail `Rest encoding ${rest} must not contain ${q(QCLASS)}`;\n }\nconst names=ownKeys(rest);\nfor(const name of names){\ntypeof name==='string'||\nFail `Property name ${name} of ${rawTree} must be a string`;\nprepare(rest[name]);\n }\n }\nreturn;\n }\ncase'error':{\nconst{name,message}=rawTree;\ntypeof name==='string'||\nFail `invalid error name typeof ${q(typeof name)}`;\ngetErrorConstructor(name)!==undefined||\nFail `Must be the name of an Error constructor ${name}`;\ntypeof message==='string'||\nFail `invalid error message typeof ${q(typeof message)}`;\nreturn;\n }\n\ndefault:{\nassert.fail(X `unrecognized ${q(QCLASS)} ${q(qclass)}`,TypeError);\n }}\n\n }else if(isArray(rawTree)){\nconst{length}=rawTree;\nfor(let i=0;i<length;i+=1){\nprepare(rawTree[i]);\n }\n }else{\nconst names=ownKeys(rawTree);\nfor(const name of names){\nif(typeof name!=='string'){\nthrow Fail `Property name ${name} of ${rawTree} must be a string`;\n }\nprepare(rawTree[name]);\n }\n }\n };\n\nconst makeIndenter=shouldIndent?makeYesIndenter:makeNoIndenter;\nlet out=makeIndenter();\n\n/**\n * This is the second pass recursion after the first pass `prepare`.\n * The first pass did some input validation so\n * here we can safely assume everything those things are validated.\n *\n * @param {Encoding} rawTree\n * @returns {number}\n */\nconst decode=(rawTree)=>{\n/* eslint-disable-next-line no-use-before-define*/\nreturn recur(rawTree);\n };\n\nconst decodeProperty=(name,value)=>{\nout.line();\nif(name==='__proto__'){\n/* JavaScript interprets `{__proto__: x, ...}`*/\n/* as making an object inheriting from `x`, whereas*/\n/* in JSON it is simply a property name. Preserve the*/\n/* JSON meaning.*/\nout.next( `[\"__proto__\"]:`);\n }else if(identPattern.test(name)){\nout.next( `${name}:`);\n }else{\nout.next( `${quote(name)}:`);\n }\ndecode(value);\nout.next(',');\n };\n\n/**\n * Modeled after `fullRevive` in marshal.js\n *\n * @param {Encoding} rawTree\n * @returns {number}\n */\nconst recur=(rawTree)=>{\nif(!isObject(rawTree)){\n/* primitives get quoted*/\nreturn out.next(quote(rawTree));\n }\n/* Assertions of the above to narrow the type.*/\nassert.typeof(rawTree,'object');\nassert(rawTree!==null);\nif(QCLASS in rawTree){\nconst qclass=rawTree[QCLASS];\nassert.typeof(qclass,'string');\nassert(!isArray(rawTree));\n/* Switching on `encoded[QCLASS]` (or anything less direct, like*/\n/* `qclass`) does not discriminate rawTree in typescript@4.2.3 and*/\n/* earlier.*/\nswitch(rawTree['@qclass']){\n/* Encoding of primitives not handled by JSON*/\ncase'undefined':\ncase'NaN':\ncase'Infinity':\ncase'-Infinity':{\n/* Their qclass is their expression source.*/\nreturn out.next(qclass);\n }\ncase'bigint':{\nconst{digits}=rawTree;\nassert.typeof(digits,'string');\nreturn out.next( `${BigInt(digits)}n`);\n }\ncase'@@asyncIterator':{\n/* TODO deprecated. Eventually remove.*/\nreturn out.next('Symbol.asyncIterator');\n }\ncase'symbol':{\nconst{name}=rawTree;\nassert.typeof(name,'string');\nconst sym=passableSymbolForName(name);\nassert.typeof(sym,'symbol');\nconst registeredName=Symbol.keyFor(sym);\nif(registeredName===undefined){\nconst match=AtAtPrefixPattern.exec(name);\nassert(match!==null);\nconst suffix=match[1];\nassert(Symbol[suffix]===sym);\nassert(identPattern.test(suffix));\nreturn out.next( `Symbol.${suffix}`);\n }\nreturn out.next( `Symbol.for(${quote(registeredName)})`);\n }\ncase'tagged':{\nconst{tag,payload}=rawTree;\nout.next( `makeTagged(${quote(tag)},`);\ndecode(payload);\nreturn out.next(')');\n }\n\ncase'slot':{\nlet{iface}=rawTree;\nconst index=Number(Nat(rawTree.index));\nconst nestedRender=(arg)=>{\nconst oldOut=out;\ntry{\nout=makeNoIndenter();\ndecode(arg);\nreturn out.done();\n }finally{\nout=oldOut;\n }\n };\nif(index<slots.length){\nconst slot=nestedRender(slots[index]);\nif(iface===undefined){\nreturn out.next( `slotToVal(${slot})`);\n }\niface=nestedRender(iface);\nreturn out.next( `slotToVal(${slot},${iface})`);\n }else if(iface===undefined){\nreturn out.next( `slot(${index})`);\n }\niface=nestedRender(iface);\nreturn out.next( `slot(${index},${iface})`);\n }\n\ncase'hilbert':{\nconst{original,rest}=rawTree;\nout.open('{');\ndecodeProperty(QCLASS,original);\nif('rest'in rawTree){\nassert.typeof(rest,'object');\nassert(rest!==null);\nconst names=ownKeys(rest);\nfor(const name of names){\nif(typeof name!=='string'){\nthrow Fail `Property name ${q(\nname)\n } of ${rest} must be a string`;\n }\ndecodeProperty(name,rest[name]);\n }\n }\nreturn out.close('}');\n }\n\ncase'error':{\nconst{name,message}=rawTree;\nreturn out.next( `${name}(${quote(message)})`);\n }\n\ndefault:{\nassert.fail(X `unrecognized ${q(QCLASS)} ${q(qclass)}`,TypeError);\n }}\n\n }else if(isArray(rawTree)){\nconst{length}=rawTree;\nif(length===0){\nreturn out.next('[]');\n }else{\nout.open('[');\nfor(let i=0;i<length;i+=1){\nout.line();\ndecode(rawTree[i]);\nout.next(',');\n }\nreturn out.close(']');\n }\n }else{\n/* rawTree is an `EncodingRecord` which only has string keys,*/\n/* but since ownKeys is not generic, it can't propagate that*/\nconst names=/** @type {string[]} */ownKeys(rawTree);\nif(names.length===0){\nreturn out.next('{}');\n }else{\nout.open('{');\nfor(const name of names){\ndecodeProperty(name,rawTree[name]);\n }\nreturn out.close('}');\n }\n }\n };\nprepare(encoding);\ndecode(encoding);\nreturn out.done();\n };$h‍_once.decodeToJustin(decodeToJustin);\nharden(decodeToJustin);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"decodeToJustin":["decodeToJustin"]},"__needsImportMeta__":false}