{"imports":["@endo/pass-style"],"exports":["makeDecodeFromSmallcaps","makeEncodeToSmallcaps"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let passStyleOf,isErrorLike,makeTagged,getTag,hasOwnPropertyOf,assertPassableSymbol,nameForPassableSymbol,passableSymbolForName;$h‍_imports([[\"@endo/pass-style\", [[\"passStyleOf\", [$h‍_a => (passStyleOf = $h‍_a)]],[\"isErrorLike\", [$h‍_a => (isErrorLike = $h‍_a)]],[\"makeTagged\", [$h‍_a => (makeTagged = $h‍_a)]],[\"getTag\", [$h‍_a => (getTag = $h‍_a)]],[\"hasOwnPropertyOf\", [$h‍_a => (hasOwnPropertyOf = $h‍_a)]],[\"assertPassableSymbol\", [$h‍_a => (assertPassableSymbol = $h‍_a)]],[\"nameForPassableSymbol\", [$h‍_a => (nameForPassableSymbol = $h‍_a)]],[\"passableSymbolForName\", [$h‍_a => (passableSymbolForName = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n/** @typedef {Ximport('@endo/pass-style').Passable} Passable */\n/** @typedef {Ximport('@endo/pass-style').Remotable} Remotable */\n/* @typedef {Ximport('./types.js').SmallcapsEncoding} SmallcapsEncoding *X/*/\n/* @typedef {Ximport('./types.js').SmallcapsEncodingUnion} SmallcapsEncodingUnion *X/*/\n/** @typedef {any} SmallcapsEncoding */\n/** @typedef {any} SmallcapsEncodingUnion */\n\nconst{ownKeys}=Reflect;\nconst{isArray}=Array;\nconst{is,entries,fromEntries}=Object;\nconst{details:X,Fail,quote:q}=assert;\n\nconst BANG='!'.charCodeAt(0);\nconst DASH='-'.charCodeAt(0);\n\n/**\n * An `encodeToSmallcaps` function takes a passable and returns a\n * JSON-representable object (i.e., round-tripping it through\n * `JSON.stringify` and `JSON.parse` with no replacers or revivers\n * returns an equivalent structure except for object identity).\n * We call this representation a Smallcaps Encoding.\n *\n * A `decodeFromSmallcaps` function takes as argument what it\n * *assumes* is the result of a plain `JSON.parse` with no resolver. It then\n * must validate that it is a valid Smallcaps Encoding, and if it is,\n * return a corresponding passable.\n *\n * Smallcaps considers the characters between `!` (ascii code 33, BANG)\n * and `-` (ascii code 45, DASH) to be special prefixes allowing\n * representation of JSON-incompatible data using strings.\n * These characters, in order, are `!\"#$%&'()*+,-`\n * Of these, smallcaps currently uses the following:\n *\n *  * `!` - escaped string\n *  * `+` - non-negative bigint\n *  * `-` - negative bigint\n *  * `#` - manifest constant\n *  * `%` - symbol\n *  * `$` - remotable\n *  * `&` - promise\n *\n * All other special characters (`\"'()*,`) are reserved for future use.\n *\n * The manifest constants that smallcaps currently uses for values:\n *  * `#undefined`\n *  * `#NaN`\n *  * `#Infinity`\n *  * `#-Infinity`\n *\n * and for property names analogous to capdata @qclass:\n *  * `#tag`\n *  * `#error`\n *\n * All other encoded strings beginning with `#` are reserved for\n * future use.\n *\n * @param {string} encodedStr\n * @returns {boolean}\n */\nconst startsSpecial=(encodedStr)=>{\nif(encodedStr===''){\nreturn false;\n }\n/* charCodeAt(0) and number compare is a bit faster.*/\nconst code=encodedStr.charCodeAt(0);\n/* eslint-disable-next-line yoda*/\nreturn BANG<=code&&code<=DASH;\n };\n\n/**\n * @typedef {object} EncodeToSmallcapsOptions\n * @property {(\n *   remotable: Remotable,\n *   encodeRecur: (p: Passable) => SmallcapsEncoding\n * ) => SmallcapsEncoding} [encodeRemotableToSmallcaps]\n * @property {(\n *   promise: Promise,\n *   encodeRecur: (p: Passable) => SmallcapsEncoding\n * ) => SmallcapsEncoding} [encodePromiseToSmallcaps]\n * @property {(\n *   error: Error,\n *   encodeRecur: (p: Passable) => SmallcapsEncoding\n * ) => SmallcapsEncoding} [encodeErrorToSmallcaps]\n */\n\nconst dontEncodeRemotableToSmallcaps=(rem)=>\nFail `remotable unexpected: ${rem}`;\n\nconst dontEncodePromiseToSmallcaps=(prom)=>Fail `promise unexpected: ${prom}`;\n\nconst dontEncodeErrorToSmallcaps=(err)=>\nFail `error object unexpected: ${q(err)}`;\n\n/**\n * @param {EncodeToSmallcapsOptions} [encodeOptions]\n * encodeOptions is actually optional, but not marked as such to work around\n * https://github.com/microsoft/TypeScript/issues/50286\n *\n * @returns {(passable: Passable) => SmallcapsEncoding}\n */\nconst        makeEncodeToSmallcaps=(encodeOptions={})=>{\nconst{\nencodeRemotableToSmallcaps=dontEncodeRemotableToSmallcaps,\nencodePromiseToSmallcaps=dontEncodePromiseToSmallcaps,\nencodeErrorToSmallcaps=dontEncodeErrorToSmallcaps}=\nencodeOptions;\n\nconst assertEncodedError=(encoding)=>{\ntypeof encoding==='object'&&hasOwnPropertyOf(encoding,'#error')||\nFail `internal: Error encoding must have \"#error\" property: ${q(\nencoding)\n }`;\n/* Assert that the #error property decodes to a string.*/\nconst message=encoding['#error'];\ntypeof message==='string'&&(\n!startsSpecial(message)||message.startsWith('!'))||\nFail `internal: Error encoding must have string message: ${q(message)}`;\n };\n\n/**\n * Must encode `val` into plain JSON data *canonically*, such that\n * `JSON.stringify(encode(v1)) === JSON.stringify(encode(v1))`. For most\n * encodings, the order of properties of each node of the output\n * structure is determined by the algorithm below without special\n * arrangement, usually by being expressed directly as an object literal.\n * The exception is copyRecords, whose natural enumeration order\n * can differ between copyRecords that our distributed object semantics\n * considers to be equivalent.\n * Since, for each copyRecord, we only accept string property names,\n * not symbols, we can canonically sort the names first.\n * JSON.stringify will then visit these in that sorted order.\n *\n * Encoding with a canonical-JSON encoder would also solve this canonicalness\n * problem in a more modular and encapsulated manner. Note that the\n * actual order produced here, though it agrees with canonical-JSON on\n * copyRecord property ordering, differs from canonical-JSON as a whole\n * in that the other record properties are visited in the order in which\n * they are literally written below. TODO perhaps we should indeed switch\n * to a canonical JSON encoder, and not delicately depend on the order\n * in which these object literals are written.\n *\n * Readers must not care about this order anyway. We impose this requirement\n * mainly to reduce non-determinism exposed outside a vat.\n *\n * @param {Passable} passable\n * @returns {SmallcapsEncoding} except that `encodeToSmallcaps` does not generally\n * `harden` this result before returning. Rather, `encodeToSmallcaps` is not\n * directly exposed.\n * What's exposed instead is a wrapper that freezes the output before\n * returning. If this turns out to impede static analysis for `harden` safety,\n * we can always put the (now redundant) hardens back in. They don't hurt.\n */\nconst encodeToSmallcapsRecur=(passable)=>{\n/* First we handle all primitives. Some can be represented directly as*/\n/* JSON, and some must be encoded into smallcaps strings.*/\nconst passStyle=passStyleOf(passable);\nswitch(passStyle){\ncase'null':\ncase'boolean':{\n/* pass through to JSON*/\nreturn passable;\n }\ncase'string':{\nif(startsSpecial(passable)){\n/* Strings that start with a special char are quoted with `!`.*/\n/* Since `!` is itself a special character, this trivially does*/\n/* the Hilbert hotel. Also, since the special characters are*/\n/* a continuous subrange of ascii, this quoting is sort-order*/\n/* preserving.*/\nreturn `!${passable}`;\n }\n/* All other strings pass through to JSON*/\nreturn passable;\n }\ncase'undefined':{\nreturn'#undefined';\n }\ncase'number':{\n/* Special-case numbers with no digit-based representation.*/\nif(Number.isNaN(passable)){\nreturn'#NaN';\n }else if(passable===Infinity){\nreturn'#Infinity';\n }else if(passable===-Infinity){\nreturn'#-Infinity';\n }\n/* Pass through everything else, replacing -0 with 0.*/\nreturn is(passable,-0)?0:passable;\n }\ncase'bigint':{\nconst str=String(passable);\nreturn (/** @type {bigint} */passable<0n?str:`+${str}`);\n }\ncase'symbol':{\nassertPassableSymbol(passable);\nconst name=/** @type {string} */nameForPassableSymbol(passable);\nreturn `%${name}`;\n }\ncase'copyRecord':{\n/* Currently copyRecord allows only string keys so this will*/\n/* work. If we allow sortable symbol keys, this will need to*/\n/* become more interesting.*/\nconst names=ownKeys(passable).sort();\nreturn fromEntries(\nnames.map((name)=>[\nencodeToSmallcapsRecur(name),\nencodeToSmallcapsRecur(passable[name])]));\n\n\n }\ncase'copyArray':{\nreturn passable.map(encodeToSmallcapsRecur);\n }\ncase'tagged':{\nreturn{\n'#tag':encodeToSmallcapsRecur(getTag(passable)),\npayload:encodeToSmallcapsRecur(passable.payload)};\n\n }\ncase'remotable':{\nconst result=encodeRemotableToSmallcaps(\npassable,\nencodeToSmallcapsRecur);\n\nif(typeof result==='string'&&result.startsWith('$')){\nreturn result;\n }\n/* `throw` is noop since `Fail` throws. But linter confused*/\nthrow Fail `internal: Remotable encoding must start with \"$\": ${result}`;\n }\ncase'promise':{\nconst result=encodePromiseToSmallcaps(\npassable,\nencodeToSmallcapsRecur);\n\nif(typeof result==='string'&&result.startsWith('&')){\nreturn result;\n }\nthrow Fail `internal: Promise encoding must start with \"&\": ${result}`;\n }\ncase'error':{\nconst result=encodeErrorToSmallcaps(passable,encodeToSmallcapsRecur);\nassertEncodedError(result);\nreturn result;\n }\ndefault:{\nassert.fail(\nX `internal: Unrecognized passStyle ${q(passStyle)}`,\nTypeError);\n\n }}\n\n };\nconst encodeToSmallcaps=(passable)=>{\nif(isErrorLike(passable)){\n/* We pull out this special case to accommodate errors that are not*/\n/* valid Passables. For example, because they're not frozen.*/\n/* The special case can only ever apply at the root, and therefore*/\n/* outside the recursion, since an error could only be deeper in*/\n/* a passable structure if it were passable.*/\n/**/\n/* We pull out this special case because, for these errors, we're much*/\n/* more interested in reporting whatever diagnostic information they*/\n/* carry than we are about reporting problems encountered in reporting*/\n/* this information.*/\nconst result=harden(\nencodeErrorToSmallcaps(passable,encodeToSmallcapsRecur));\n\nassertEncodedError(result);\nreturn result;\n }\nreturn harden(encodeToSmallcapsRecur(passable));\n };\nreturn harden(encodeToSmallcaps);\n };$h‍_once.makeEncodeToSmallcaps(makeEncodeToSmallcaps);\nharden(makeEncodeToSmallcaps);\n\n/**\n * @typedef {object} DecodeFromSmallcapsOptions\n * @property {(\n *   encodedRemotable: SmallcapsEncoding,\n *   decodeRecur: (e :SmallcapsEncoding) => Passable\n * ) => Remotable} [decodeRemotableFromSmallcaps]\n * @property {(\n *   encodedPromise: SmallcapsEncoding,\n *   decodeRecur: (e :SmallcapsEncoding) => Passable\n * ) => Promise} [decodePromiseFromSmallcaps]\n * @property {(\n *   encodedError: SmallcapsEncoding,\n *   decodeRecur: (e :SmallcapsEncoding) => Passable\n * ) => Error} [decodeErrorFromSmallcaps]\n */\n\nconst dontDecodeRemotableFromSmallcaps=(encoding)=>\nFail `remotable unexpected: ${encoding}`;\nconst dontDecodePromiseFromSmallcaps=(encoding)=>\nFail `promise unexpected: ${encoding}`;\nconst dontDecodeErrorFromSmallcaps=(encoding)=>\nFail `error unexpected: ${q(encoding)}`;\n\n/**\n * @param {DecodeFromSmallcapsOptions} [decodeOptions]\n * @returns {(encoded: SmallcapsEncoding) => Passable}\n */\nconst        makeDecodeFromSmallcaps=(decodeOptions={})=>{\nconst{\ndecodeRemotableFromSmallcaps=dontDecodeRemotableFromSmallcaps,\ndecodePromiseFromSmallcaps=dontDecodePromiseFromSmallcaps,\ndecodeErrorFromSmallcaps=dontDecodeErrorFromSmallcaps}=\ndecodeOptions;\n\n/**\n * `decodeFromSmallcaps` may rely on `encoding` being the result of a\n * plain call to JSON.parse. However, it *cannot* rely on `encoding`\n * having been produced by JSON.stringify on the output of `encodeToSmallcaps`\n * above, i.e., `decodeFromSmallcaps` cannot rely on `encoding` being a\n * valid marshalled representation. Rather, `decodeFromSmallcaps` must\n * validate that.\n *\n * @param {SmallcapsEncoding} encoding must be hardened\n */\nconst decodeFromSmallcaps=(encoding)=>{\nswitch(typeof encoding){\ncase'boolean':\ncase'number':{\nreturn encoding;\n }\ncase'string':{\nif(!startsSpecial(encoding)){\nreturn encoding;\n }\nconst c=encoding.charAt(0);\nswitch(c){\ncase'!':{\n/* un-hilbert-ify the string*/\nreturn encoding.slice(1);\n }\ncase'%':{\nreturn passableSymbolForName(encoding.slice(1));\n }\ncase'#':{\nswitch(encoding){\ncase'#undefined':{\nreturn undefined;\n }\ncase'#NaN':{\nreturn NaN;\n }\ncase'#Infinity':{\nreturn Infinity;\n }\ncase'#-Infinity':{\nreturn-Infinity;\n }\ndefault:{\nassert.fail(X `unknown constant \"${q(encoding)}\"`,TypeError);\n }}\n\n }\ncase'+':\ncase'-':{\nreturn BigInt(encoding);\n }\ncase'$':{\nconst result=decodeRemotableFromSmallcaps(\nencoding,\ndecodeFromSmallcaps);\n\nif(passStyleOf(result)!=='remotable'){\nFail `internal: decodeRemotableFromSmallcaps option must return a remotable: ${result}`;\n }\nreturn result;\n }\ncase'&':{\nconst result=decodePromiseFromSmallcaps(\nencoding,\ndecodeFromSmallcaps);\n\nif(passStyleOf(result)!=='promise'){\nFail `internal: decodePromiseFromSmallcaps option must return a promise: ${result}`;\n }\nreturn result;\n }\ndefault:{\nthrow Fail `Special char ${q(\nc)\n } reserved for future use: ${encoding}`;\n }}\n\n }\ncase'object':{\nif(encoding===null){\nreturn encoding;\n }\n\nif(isArray(encoding)){\nreturn encoding.map((val)=>decodeFromSmallcaps(val));\n }\n\nif(hasOwnPropertyOf(encoding,'#tag')){\nconst{'#tag':tag,payload,...rest}=encoding;\ntypeof tag==='string'||\nFail `Value of \"#tag\", the tag, must be a string: ${encoding}`;\nownKeys(rest).length===0||\nFail `#tag record unexpected properties: ${q(ownKeys(rest))}`;\nreturn makeTagged(\ndecodeFromSmallcaps(tag),\ndecodeFromSmallcaps(payload));\n\n }\n\nif(hasOwnPropertyOf(encoding,'#error')){\nconst result=decodeErrorFromSmallcaps(\nencoding,\ndecodeFromSmallcaps);\n\npassStyleOf(result)==='error'||\nFail `internal: decodeErrorFromSmallcaps option must return an error: ${result}`;\nreturn result;\n }\n\nconst decodeEntry=([encodedName,encodedVal])=>{\ntypeof encodedName==='string'||\nFail `Property name ${q(\nencodedName)\n } of ${encoding} must be a string`;\n!encodedName.startsWith('#')||\nFail `Unrecognized record type ${q(encodedName)}: ${encoding}`;\nconst name=decodeFromSmallcaps(encodedName);\ntypeof name==='string'||\nFail `Decoded property name ${name} from ${encoding} must be a string`;\nreturn[name,decodeFromSmallcaps(encodedVal)];\n };\nconst decodedEntries=entries(encoding).map(decodeEntry);\nreturn fromEntries(decodedEntries);\n }\ndefault:{\nassert.fail(\nX `internal: unrecognized JSON typeof ${q(\ntypeof encoding)\n }: ${encoding}`,\nTypeError);\n\n }}\n\n };\nreturn harden(decodeFromSmallcaps);\n };$h‍_once.makeDecodeFromSmallcaps(makeDecodeFromSmallcaps);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"makeEncodeToSmallcaps":["makeEncodeToSmallcaps"],"makeDecodeFromSmallcaps":["makeDecodeFromSmallcaps"]},"__needsImportMeta__":false}