{"imports":["@endo/pass-style"],"exports":["QCLASS","makeDecodeFromCapData","makeEncodeToCapData"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let passStyleOf,isErrorLike,makeTagged,isObject,getTag,hasOwnPropertyOf,assertPassableSymbol,nameForPassableSymbol,passableSymbolForName;$h‍_imports([[\"@endo/pass-style\", [[\"passStyleOf\", [$h‍_a => (passStyleOf = $h‍_a)]],[\"isErrorLike\", [$h‍_a => (isErrorLike = $h‍_a)]],[\"makeTagged\", [$h‍_a => (makeTagged = $h‍_a)]],[\"isObject\", [$h‍_a => (isObject = $h‍_a)]],[\"getTag\", [$h‍_a => (getTag = $h‍_a)]],[\"hasOwnPropertyOf\", [$h‍_a => (hasOwnPropertyOf = $h‍_a)]],[\"assertPassableSymbol\", [$h‍_a => (assertPassableSymbol = $h‍_a)]],[\"nameForPassableSymbol\", [$h‍_a => (nameForPassableSymbol = $h‍_a)]],[\"passableSymbolForName\", [$h‍_a => (passableSymbolForName = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n/** @typedef {Ximport('@endo/pass-style').Passable} Passable */\n/** @typedef {Ximport('./types.js').Encoding} Encoding */\n/** @typedef {Ximport('@endo/pass-style').Remotable} Remotable */\n/** @typedef {Ximport('./types.js').EncodingUnion} EncodingUnion */\n\nconst{ownKeys}=Reflect;\nconst{isArray}=Array;\nconst{\ngetOwnPropertyDescriptors,\ndefineProperties,\nis,\nentries,\nfromEntries,\nfreeze}=\nObject;\nconst{details:X,Fail,quote:q}=assert;\n\n/**\n * Special property name that indicates an encoding that needs special\n * decoding.\n */\nconst QCLASS='@qclass';$h‍_once.QCLASS(QCLASS);\n\n\n/**\n * @param {Encoding} encoded\n * @returns {encoded is EncodingUnion}\n */\nconst hasQClass=(encoded)=>hasOwnPropertyOf(encoded,QCLASS);\n\n/**\n * @param {Encoding} encoded\n * @param {string} qclass\n * @returns {boolean}\n */\nconst qclassMatches=(encoded,qclass)=>\nisObject(encoded)&&\n!isArray(encoded)&&\nhasQClass(encoded)&&\nencoded[QCLASS]===qclass;\n\n/**\n * @typedef {object} EncodeToCapDataOptions\n * @property {(\n *   remotable: Remotable,\n *   encodeRecur: (p: Passable) => Encoding\n * ) => Encoding} [encodeRemotableToCapData]\n * @property {(\n *   promise: Promise,\n *   encodeRecur: (p: Passable) => Encoding\n * ) => Encoding} [encodePromiseToCapData]\n * @property {(\n *   error: Error,\n *   encodeRecur: (p: Passable) => Encoding\n * ) => Encoding} [encodeErrorToCapData]\n */\n\nconst dontEncodeRemotableToCapData=(rem)=>Fail `remotable unexpected: ${rem}`;\n\nconst dontEncodePromiseToCapData=(prom)=>Fail `promise unexpected: ${prom}`;\n\nconst dontEncodeErrorToCapData=(err)=>Fail `error object unexpected: ${err}`;\n\n/**\n * @param {EncodeToCapDataOptions} [encodeOptions]\n * @returns {(passable: Passable) => Encoding}\n */\nconst        makeEncodeToCapData=(encodeOptions={})=>{\nconst{\nencodeRemotableToCapData=dontEncodeRemotableToCapData,\nencodePromiseToCapData=dontEncodePromiseToCapData,\nencodeErrorToCapData=dontEncodeErrorToCapData}=\nencodeOptions;\n\n/**\n * Must encode `val` into plain JSON data *canonically*, such that\n * `JSON.stringify(encode(v1)) === JSON.stringify(encode(v1))`. For most\n * encodings, the order of properties of each node of the output\n * structure is determined by the algorithm below without special\n * arrangement, usually by being expressed directly as an object literal.\n * The exception is copyRecords, whose natural enumeration order\n * can differ between copyRecords that our distributed object semantics\n * considers to be equivalent.\n * Since, for each copyRecord, we only accept string property names,\n * not symbols, we can canonically sort the names first.\n * JSON.stringify will then visit these in that sorted order.\n *\n * Encoding with a canonical-JSON encoder would also solve this canonicalness\n * problem in a more modular and encapsulated manner. Note that the\n * actual order produced here, though it agrees with canonical-JSON on\n * copyRecord property ordering, differs from canonical-JSON as a whole\n * in that the other record properties are visited in the order in which\n * they are literally written below. TODO perhaps we should indeed switch\n * to a canonical JSON encoder, and not delicately depend on the order\n * in which these object literals are written.\n *\n * Readers must not care about this order anyway. We impose this requirement\n * mainly to reduce non-determinism exposed outside a vat.\n *\n * @param {Passable} passable\n * @returns {Encoding} except that `encodeToCapData` does not generally\n * `harden` this result before returning. Rather, `encodeToCapData` is not\n * directly exposed.\n * What's exposed instead is a wrapper that freezes the output before\n * returning. If this turns out to impede static analysis for `harden` safety,\n * we can always put the (now redundant) hardens back in. They don't hurt.\n */\nconst encodeToCapDataRecur=(passable)=>{\n/* First we handle all primitives. Some can be represented directly as*/\n/* JSON, and some must be encoded as [QCLASS] composites.*/\nconst passStyle=passStyleOf(passable);\nswitch(passStyle){\ncase'null':\ncase'boolean':\ncase'string':{\n/* pass through to JSON*/\nreturn passable;\n }\ncase'undefined':{\nreturn{[QCLASS]:'undefined'};\n }\ncase'number':{\n/* Special-case numbers with no digit-based representation.*/\nif(Number.isNaN(passable)){\nreturn{[QCLASS]:'NaN'};\n }else if(passable===Infinity){\nreturn{[QCLASS]:'Infinity'};\n }else if(passable===-Infinity){\nreturn{[QCLASS]:'-Infinity'};\n }\n/* Pass through everything else, replacing -0 with 0.*/\nreturn is(passable,-0)?0:passable;\n }\ncase'bigint':{\nreturn{\n[QCLASS]:'bigint',\ndigits:String(passable)};\n\n }\ncase'symbol':{\nassertPassableSymbol(passable);\nconst name=/** @type {string} */nameForPassableSymbol(passable);\nreturn{\n[QCLASS]:'symbol',\nname};\n\n }\ncase'copyRecord':{\nif(hasOwnPropertyOf(passable,QCLASS)){\n/* Hilbert hotel*/\nconst{[QCLASS]:qclassValue,...rest}=passable;\n/** @type {Encoding} */\nconst result={\n[QCLASS]:'hilbert',\noriginal:encodeToCapDataRecur(qclassValue)};\n\nif(ownKeys(rest).length>=1){\n/* We harden the entire capData encoding before we return it.*/\n/* `encodeToCapData` requires that its input be Passable, and*/\n/* therefore hardened.*/\n/* The `freeze` here is needed anyway, because the `rest` is*/\n/* freshly constructed by the `...` above, and we're using it*/\n/* as imput in another call to `encodeToCapData`.*/\nresult.rest=encodeToCapDataRecur(freeze(rest));\n }\nreturn result;\n }\n/* Currently copyRecord allows only string keys so this will*/\n/* work. If we allow sortable symbol keys, this will need to*/\n/* become more interesting.*/\nconst names=ownKeys(passable).sort();\nreturn fromEntries(\nnames.map((name)=>[name,encodeToCapDataRecur(passable[name])]));\n\n }\ncase'copyArray':{\nreturn passable.map(encodeToCapDataRecur);\n }\ncase'tagged':{\nreturn{\n[QCLASS]:'tagged',\ntag:getTag(passable),\npayload:encodeToCapDataRecur(passable.payload)};\n\n }\ncase'remotable':{\nconst encoded=encodeRemotableToCapData(\npassable,\nencodeToCapDataRecur);\n\nif(qclassMatches(encoded,'slot')){\nreturn encoded;\n }\n/* `throw` is noop since `Fail` throws. But linter confused*/\nthrow Fail `internal: Remotable encoding must be an object with ${q(\nQCLASS)\n } ${q('slot')}: ${encoded}`;\n }\ncase'promise':{\nconst encoded=encodePromiseToCapData(passable,encodeToCapDataRecur);\nif(qclassMatches(encoded,'slot')){\nreturn encoded;\n }\nthrow Fail `internal: Promise encoding must be an object with ${q(\nQCLASS,\n'slot')\n }: ${encoded}`;\n }\ncase'error':{\nconst encoded=encodeErrorToCapData(passable,encodeToCapDataRecur);\nif(qclassMatches(encoded,'error')){\nreturn encoded;\n }\nthrow Fail `internal: Error encoding must be an object with ${q(\nQCLASS,\n'error')\n }: ${encoded}`;\n }\ndefault:{\nthrow assert.fail(\nX `internal: Unrecognized passStyle ${q(passStyle)}`,\nTypeError);\n\n }}\n\n };\nconst encodeToCapData=(passable)=>{\nif(isErrorLike(passable)){\n/* We pull out this special case to accommodate errors that are not*/\n/* valid Passables. For example, because they're not frozen.*/\n/* The special case can only ever apply at the root, and therefore*/\n/* outside the recursion, since an error could only be deeper in*/\n/* a passable structure if it were passable.*/\n/**/\n/* We pull out this special case because, for these errors, we're much*/\n/* more interested in reporting whatever diagnostic information they*/\n/* carry than we are about reporting problems encountered in reporting*/\n/* this information.*/\nreturn harden(encodeErrorToCapData(passable,encodeToCapDataRecur));\n }\nreturn harden(encodeToCapDataRecur(passable));\n };\nreturn harden(encodeToCapData);\n };$h‍_once.makeEncodeToCapData(makeEncodeToCapData);\nharden(makeEncodeToCapData);\n\n/**\n * @typedef {object} DecodeOptions\n * @property {(\n *   encodedRemotable: Encoding,\n *   decodeRecur: (e: Encoding) => Passable\n * ) => (Promise|Remotable)} [decodeRemotableFromCapData]\n * @property {(\n *   encodedPromise: Encoding,\n *   decodeRecur: (e: Encoding) => Passable\n * ) => (Promise|Remotable)} [decodePromiseFromCapData]\n * @property {(\n *   encodedError: Encoding,\n *   decodeRecur: (e: Encoding) => Passable\n * ) => Error} [decodeErrorFromCapData]\n */\n\nconst dontDecodeRemotableOrPromiseFromCapData=(slotEncoding)=>\nFail `remotable or promise unexpected: ${slotEncoding}`;\nconst dontDecodeErrorFromCapData=(errorEncoding)=>\nFail `error unexpected: ${errorEncoding}`;\n\n/**\n * The current encoding does not give the decoder enough into to distinguish\n * whether a slot represents a promise or a remotable. As an implementation\n * restriction until this is fixed, if either is provided, both must be\n * provided and they must be the same.\n *\n * This seems like the best starting point to incrementally evolve to an\n * API where these can reliably differ.\n * See https://github.com/Agoric/agoric-sdk/issues/4334\n *\n * @param {DecodeOptions} [decodeOptions]\n * @returns {(encoded: Encoding) => Passable}\n */\nconst        makeDecodeFromCapData=(decodeOptions={})=>{\nconst{\ndecodeRemotableFromCapData=dontDecodeRemotableOrPromiseFromCapData,\ndecodePromiseFromCapData=dontDecodeRemotableOrPromiseFromCapData,\ndecodeErrorFromCapData=dontDecodeErrorFromCapData}=\ndecodeOptions;\n\ndecodeRemotableFromCapData===decodePromiseFromCapData||\nFail `An implementation restriction for now: If either decodeRemotableFromCapData or decodePromiseFromCapData is provided, both must be provided and they must be the same: ${q(\ndecodeRemotableFromCapData)\n } vs ${q(decodePromiseFromCapData)}`;\n\n/**\n * `decodeFromCapData` may rely on `jsonEncoded` being the result of a\n * plain call to JSON.parse. However, it *cannot* rely on `jsonEncoded`\n * having been produced by JSON.stringify on the output of `encodeToCapData`\n * above, i.e., `decodeFromCapData` cannot rely on `jsonEncoded` being a\n * valid marshalled representation. Rather, `decodeFromCapData` must\n * validate that.\n *\n * @param {Encoding} jsonEncoded must be hardened\n */\nconst decodeFromCapData=(jsonEncoded)=>{\nif(!isObject(jsonEncoded)){\n/* primitives pass through*/\nreturn jsonEncoded;\n }\nif(isArray(jsonEncoded)){\nreturn jsonEncoded.map((encodedVal)=>decodeFromCapData(encodedVal));\n }else if(hasQClass(jsonEncoded)){\nconst qclass=jsonEncoded[QCLASS];\ntypeof qclass==='string'||\nFail `invalid ${q(QCLASS)} typeof ${q(typeof qclass)}`;\nswitch(qclass){\n/* Encoding of primitives not handled by JSON*/\ncase'undefined':{\nreturn undefined;\n }\ncase'NaN':{\nreturn NaN;\n }\ncase'Infinity':{\nreturn Infinity;\n }\ncase'-Infinity':{\nreturn-Infinity;\n }\ncase'bigint':{\n/* Using @ts-ignore rather than @ts-expect-error below because*/\n/* with @ts-expect-error I get a red underline in vscode, but*/\n/* without it I get errors from `yarn lint`.*/\n/* @ts-ignore inadequate type inference*/\n/* See https://github.com/endojs/endo/pull/1259#discussion_r954561901*/\nconst{digits}=jsonEncoded;\ntypeof digits==='string'||\nFail `invalid digits typeof ${q(typeof digits)}`;\nreturn BigInt(digits);\n }\ncase'@@asyncIterator':{\n/* Deprecated qclass. TODO make conditional*/\n/* on environment variable. Eventually remove, but after confident*/\n/* that there are no more supported senders.*/\n/**/\n/* Using @ts-ignore rather than @ts-expect-error below because*/\n/* with @ts-expect-error I get a red underline in vscode, but*/\n/* without it I get errors from `yarn lint`.*/\n/* @ts-ignore inadequate type inference*/\n/* See https://github.com/endojs/endo/pull/1259#discussion_r954561901*/\nreturn Symbol.asyncIterator;\n }\ncase'symbol':{\n/* Using @ts-ignore rather than @ts-expect-error below because*/\n/* with @ts-expect-error I get a red underline in vscode, but*/\n/* without it I get errors from `yarn lint`.*/\n/* @ts-ignore inadequate type inference*/\n/* See https://github.com/endojs/endo/pull/1259#discussion_r954561901*/\nconst{name}=jsonEncoded;\nreturn passableSymbolForName(name);\n }\ncase'tagged':{\n/* Using @ts-ignore rather than @ts-expect-error below because*/\n/* with @ts-expect-error I get a red underline in vscode, but*/\n/* without it I get errors from `yarn lint`.*/\n/* @ts-ignore inadequate type inference*/\n/* See https://github.com/endojs/endo/pull/1259#discussion_r954561901*/\nconst{tag,payload}=jsonEncoded;\nreturn makeTagged(tag,decodeFromCapData(payload));\n }\ncase'slot':{\n/* See note above about how the current encoding cannot reliably*/\n/* distinguish which we should call, so in the non-default case*/\n/* both must be the same and it doesn't matter which we call.*/\nconst decoded=decodeRemotableFromCapData(\njsonEncoded,\ndecodeFromCapData);\n\n/* BEWARE: capdata does not check that `decoded` is*/\n/* a promise or a remotable, since that would break some*/\n/* capdata clients. We are deprecating capdata, and these clients*/\n/* will need to update before switching to smallcaps.*/\nreturn decoded;\n }\ncase'error':{\nconst decoded=decodeErrorFromCapData(\njsonEncoded,\ndecodeFromCapData);\n\nif(passStyleOf(decoded)==='error'){\nreturn decoded;\n }\nthrow Fail `internal: decodeErrorFromCapData option must return an error: ${decoded}`;\n }\ncase'hilbert':{\n/* Using @ts-ignore rather than @ts-expect-error below because*/\n/* with @ts-expect-error I get a red underline in vscode, but*/\n/* without it I get errors from `yarn lint`.*/\n/* @ts-ignore inadequate type inference*/\n/* See https://github.com/endojs/endo/pull/1259#discussion_r954561901*/\nconst{original,rest}=jsonEncoded;\nhasOwnPropertyOf(jsonEncoded,'original')||\nFail `Invalid Hilbert Hotel encoding ${jsonEncoded}`;\n/* Don't harden since we're not done mutating it*/\nconst result={[QCLASS]:decodeFromCapData(original)};\nif(hasOwnPropertyOf(jsonEncoded,'rest')){\nconst isNonEmptyObject=\ntypeof rest==='object'&&\nrest!==null&&\nownKeys(rest).length>=1;\nif(!isNonEmptyObject){\nthrow Fail `Rest encoding must be a non-empty object: ${rest}`;\n }\nconst restObj=decodeFromCapData(rest);\n/* TODO really should assert that `passStyleOf(rest)` is*/\n/* `'copyRecord'` but we'd have to harden it and it is too*/\n/* early to do that.*/\n!hasOwnPropertyOf(restObj,QCLASS)||\nFail `Rest must not contain its own definition of ${q(QCLASS)}`;\ndefineProperties(result,getOwnPropertyDescriptors(restObj));\n }\nreturn result;\n }\n/* @ts-expect-error This is the error case we're testing for*/\ncase'ibid':{\nthrow Fail `The capData protocol no longer supports ${q(QCLASS)} ${q(\nqclass)\n }`;\n }\ndefault:{\nthrow assert.fail(\nX `unrecognized ${q(QCLASS)} ${q(qclass)}`,\nTypeError);\n\n }}\n\n }else{\nassert(typeof jsonEncoded==='object'&&jsonEncoded!==null);\nconst decodeEntry=([name,encodedVal])=>{\ntypeof name==='string'||\nFail `Property ${q(name)} of ${jsonEncoded} must be a string`;\nreturn[name,decodeFromCapData(encodedVal)];\n };\nconst decodedEntries=entries(jsonEncoded).map(decodeEntry);\nreturn fromEntries(decodedEntries);\n }\n };\nreturn harden(decodeFromCapData);\n };$h‍_once.makeDecodeFromCapData(makeDecodeFromCapData);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"QCLASS":["QCLASS"],"makeEncodeToCapData":["makeEncodeToCapData"],"makeDecodeFromCapData":["makeDecodeFromCapData"]},"__needsImportMeta__":false}