{"imports":["@endo/pass-style"],"exports":["isEncodedRemotable","makeDecodePassable","makeEncodePassable","passStylePrefixes","recordNames","recordValues","zeroPad"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let getTag,makeTagged,passStyleOf,assertRecord,isErrorLike,nameForPassableSymbol,passableSymbolForName;$h‍_imports([[\"@endo/pass-style\", [[\"getTag\", [$h‍_a => (getTag = $h‍_a)]],[\"makeTagged\", [$h‍_a => (makeTagged = $h‍_a)]],[\"passStyleOf\", [$h‍_a => (passStyleOf = $h‍_a)]],[\"assertRecord\", [$h‍_a => (assertRecord = $h‍_a)]],[\"isErrorLike\", [$h‍_a => (isErrorLike = $h‍_a)]],[\"nameForPassableSymbol\", [$h‍_a => (nameForPassableSymbol = $h‍_a)]],[\"passableSymbolForName\", [$h‍_a => (passableSymbolForName = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\n\n\n\n/** @typedef {Ximport('@endo/pass-style').PassStyle} PassStyle */\n/** @typedef {Ximport('@endo/pass-style').Passable} Passable */\n/** @typedef {Ximport('@endo/pass-style').RemotableObject} Remotable */\n/** @template T @typedef {Ximport('@endo/pass-style').CopyRecord<T>} CopyRecord */\n/** @typedef {Ximport('./types.js').RankCover} RankCover */\n\nconst{quote:q,Fail}=assert;\nconst{fromEntries,is}=Object;\nconst{ownKeys}=Reflect;\n\n/**\n * Assuming that `record` is a CopyRecord, we have only\n * string-named own properties. `recordNames` returns those name *reverse*\n * sorted, because that's how records are compared, encoded, and sorted.\n *\n * @template T\n * @param {CopyRecord<T>} record\n * @returns {string[]}\n */\nconst        recordNames=(record)=>\n/* https://github.com/endojs/endo/pull/1260#discussion_r1003657244*/\n/* compares two ways of reverse sorting, and shows that `.sort().reverse()`*/\n/* is currently faster on Moddable XS, while the other way,*/\n/* `.sort(reverseComparator)`, is faster on v8. We currently care more about*/\n/* XS performance, so we reverse sort using `.sort().reverse()`.*/\nharden(/** @type {string[]} */ownKeys(record).sort().reverse());$h‍_once.recordNames(recordNames);\nharden(recordNames);\n\n/**\n * Assuming that `record` is a CopyRecord and `names` is `recordNames(record)`,\n * return the corresponding array of property values.\n *\n * @template T\n * @param {CopyRecord<T>} record\n * @param {string[]} names\n * @returns {T[]}\n */\nconst        recordValues=(record,names)=>\nharden(names.map((name)=>record[name]));$h‍_once.recordValues(recordValues);\nharden(recordValues);\n\n/**\n * @param {unknown} n\n * @param {number} size\n * @returns {string}\n */\nconst        zeroPad=(n,size)=>{\nconst nStr= `${n}`;\nassert(nStr.length<=size);\nconst str= `00000000000000000000${nStr}`;\nconst result=str.substring(str.length-size);\nassert(result.length===size);\nreturn result;\n };$h‍_once.zeroPad(zeroPad);\nharden(zeroPad);\n\n/* This is the JavaScript analog to a C union: a way to map between a float as a*/\n/* number and the bits that represent the float as a buffer full of bytes.  Note*/\n/* that the mutation of static state here makes this invalid Jessie code, but*/\n/* doing it this way saves the nugatory and gratuitous allocations that would*/\n/* happen every time you do a conversion -- and in practical terms it's safe*/\n/* because we put the value in one side and then immediately take it out the*/\n/* other; there is no actual state retained in the classic sense and thus no*/\n/* re-entrancy issue.*/\nconst asNumber=new Float64Array(1);\nconst asBits=new BigUint64Array(asNumber.buffer);\n\n/* JavaScript numbers are encoded by outputting the base-16*/\n/* representation of the binary value of the underlying IEEE floating point*/\n/* representation.  For negative values, all bits of this representation are*/\n/* complemented prior to the base-16 conversion, while for positive values, the*/\n/* sign bit is complemented.  This ensures both that negative values sort before*/\n/* positive values and that negative values sort according to their negative*/\n/* magnitude rather than their positive magnitude.  This results in an ASCII*/\n/* encoding whose lexicographic sort order is the same as the numeric sort order*/\n/* of the corresponding numbers.*/\n\n/* TODO Choose the same canonical NaN encoding that cosmWasm and ewasm chose.*/\nconst CanonicalNaNBits='fff8000000000000';\n\n/**\n * @param {number} n\n * @returns {string}\n */\nconst encodeBinary64=(n)=>{\n/* Normalize -0 to 0 and NaN to a canonical encoding*/\nif(is(n,-0)){\nn=0;\n }else if(is(n,NaN)){\nreturn `f${CanonicalNaNBits}`;\n }\nasNumber[0]=n;\nlet bits=asBits[0];\nif(n<0){\nbits^=0xffffffffffffffffn;\n }else{\nbits^=0x8000000000000000n;\n }\nreturn `f${zeroPad(bits.toString(16),16)}`;\n };\n\n/**\n * @param {string} encoded\n * @returns {number}\n */\nconst decodeBinary64=(encoded)=>{\nencoded.startsWith('f')||Fail `Encoded number expected: ${encoded}`;\nlet bits=BigInt( `0x${encoded.substring(1)}`);\nif(encoded[1]<'8'){\nbits^=0xffffffffffffffffn;\n }else{\nbits^=0x8000000000000000n;\n }\nasBits[0]=bits;\nconst result=asNumber[0];\n!is(result,-0)||Fail `Unexpected negative zero: ${encoded}`;\nreturn result;\n };\n\n/**\n * Encode a JavaScript bigint using a variant of Elias delta coding, with an\n * initial component for the length of the digit count as a unary string, a\n * second component for the decimal digit count, and a third component for the\n * decimal digits preceded by a gratuitous separating colon.\n * To ensure that the lexicographic sort order of encoded values matches the\n * numeric sort order of the corresponding numbers, the characters of the unary\n * prefix are different for negative values (type \"n\" followed by any number of\n * \"#\"s [which sort before decimal digits]) vs. positive and zero values (type\n * \"p\" followed by any number of \"~\"s [which sort after decimal digits]) and\n * each decimal digit of the encoding for a negative value is replaced with its\n * ten's complement (so that negative values of the same scale sort by\n * *descending* absolute value).\n *\n * @param {bigint} n\n * @returns {string}\n */\nconst encodeBigInt=(n)=>{\nconst abs=n<0n?-n:n;\nconst nDigits=abs.toString().length;\nconst lDigits=nDigits.toString().length;\nif(n<0n){\nreturn `n${\n/* A \"#\" for each digit beyond the first*/\n/* in the decimal *count* of decimal digits.*/\n'#'.repeat(lDigits-1)\n }${\n/* The ten's complement of the count of digits.*/\n(10**lDigits-nDigits).toString().padStart(lDigits,'0')\n }:${\n/* The ten's complement of the digits.*/\n(10n**BigInt(nDigits)+n).toString().padStart(nDigits,'0')\n }`;\n }else{\nreturn `p${\n/* A \"~\" for each digit beyond the first*/\n/* in the decimal *count* of decimal digits.*/\n'~'.repeat(lDigits-1)\n }${\n/* The count of digits.*/\nnDigits\n }:${\n/* The digits.*/\nn\n }`;\n }\n };\n\n/**\n * @param {string} encoded\n * @returns {bigint}\n */\nconst decodeBigInt=(encoded)=>{\nconst typePrefix=encoded.charAt(0);/* faster than encoded[0]*/\nlet rem=encoded.slice(1);\ntypePrefix==='p'||\ntypePrefix==='n'||\nFail `Encoded bigint expected: ${encoded}`;\n\nconst lDigits=rem.search(/[0-9]/)+1;\nlDigits>=1||Fail `Digit count expected: ${encoded}`;\nrem=rem.slice(lDigits-1);\n\nrem.length>=lDigits||Fail `Complete digit count expected: ${encoded}`;\nconst snDigits=rem.slice(0,lDigits);\nrem=rem.slice(lDigits);\n/^[0-9]+$/.test(snDigits)||Fail `Decimal digit count expected: ${encoded}`;\nlet nDigits=parseInt(snDigits,10);\nif(typePrefix==='n'){\n/* TODO Assert to reject forbidden encodings*/\n/* like \"n0:\" and \"n00:…\" and \"n91:…\" through \"n99:…\"?*/\nnDigits=10**lDigits-nDigits;\n }\n\nrem.startsWith(':')||Fail `Separator expected: ${encoded}`;\nrem=rem.slice(1);\nrem.length===nDigits||\nFail `Fixed-length digit sequence expected: ${encoded}`;\nlet n=BigInt(rem);\nif(typePrefix==='n'){\n/* TODO Assert to reject forbidden encodings*/\n/* like \"n9:0\" and \"n8:00\" and \"n8:91\" through \"n8:99\"?*/\nn=-(10n**BigInt(nDigits)-n);\n }\n\nreturn n;\n };\n\n/* `'\\u0000'` is the terminator after elements.*/\n/* `'\\u0001'` is the backslash-like escape character, for*/\n/* escaping both of these characters.*/\n\nconst encodeArray=(array,encodePassable)=>{\nconst chars=['['];\nfor(const element of array){\nconst enc=encodePassable(element);\nfor(const c of enc){\nif(c==='\\u0000'||c==='\\u0001'){\nchars.push('\\u0001');\n }\nchars.push(c);\n }\nchars.push('\\u0000');\n }\nreturn chars.join('');\n };\n\n/**\n * @param {string} encoded\n * @param {(encoded: string) => Passable} decodePassable\n * @returns {Array}\n */\nconst decodeArray=(encoded,decodePassable)=>{\nencoded.startsWith('[')||Fail `Encoded array expected: ${encoded}`;\nconst elements=[];\nconst elemChars=[];\nfor(let i=1;i<encoded.length;i+=1){\nconst c=encoded[i];\nif(c==='\\u0000'){\nconst encodedElement=elemChars.join('');\nelemChars.length=0;\nconst element=decodePassable(encodedElement);\nelements.push(element);\n }else if(c==='\\u0001'){\ni+=1;\ni<encoded.length||Fail `unexpected end of encoding ${encoded}`;\nconst c2=encoded[i];\nc2==='\\u0000'||\nc2==='\\u0001'||\nFail `Unexpected character after u0001 escape: ${c2}`;\nelemChars.push(c2);\n }else{\nelemChars.push(c);\n }\n }\nelemChars.length===0||Fail `encoding terminated early: ${encoded}`;\nreturn harden(elements);\n };\n\nconst encodeRecord=(record,encodePassable)=>{\nconst names=recordNames(record);\nconst values=recordValues(record,names);\nreturn `(${encodeArray(harden([names,values]),encodePassable)}`;\n };\n\nconst decodeRecord=(encoded,decodePassable)=>{\nassert(encoded.startsWith('('));\nconst keysvals=decodeArray(encoded.substring(1),decodePassable);\nkeysvals.length===2||Fail `expected keys,values pair: ${encoded}`;\nconst[keys,vals]=keysvals;\n\npassStyleOf(keys)==='copyArray'&&\npassStyleOf(vals)==='copyArray'&&\nkeys.length===vals.length&&\nkeys.every((key)=>typeof key==='string')||\nFail `not a valid record encoding: ${encoded}`;\nconst mapEntries=keys.map((key,i)=>[key,vals[i]]);\nconst record=harden(fromEntries(mapEntries));\nassertRecord(record,'decoded record');\nreturn record;\n };\n\nconst encodeTagged=(tagged,encodePassable)=>\n `:${encodeArray(harden([getTag(tagged),tagged.payload]),encodePassable)}`;\n\nconst decodeTagged=(encoded,decodePassable)=>{\nassert(encoded.startsWith(':'));\nconst tagpayload=decodeArray(encoded.substring(1),decodePassable);\ntagpayload.length===2||Fail `expected tag,payload pair: ${encoded}`;\nconst[tag,payload]=tagpayload;\npassStyleOf(tag)==='string'||\nFail `not a valid tagged encoding: ${encoded}`;\nreturn makeTagged(tag,payload);\n };\n\n/**\n * @typedef {object} EncodeOptions\n * @property {(\n *   remotable: Remotable,\n *   encodeRecur: (p: Passable) => string,\n * ) => string} [encodeRemotable]\n * @property {(\n *   promise: Promise,\n *   encodeRecur: (p: Passable) => string,\n * ) => string} [encodePromise]\n * @property {(\n *   error: Error,\n *   encodeRecur: (p: Passable) => string,\n * ) => string} [encodeError]\n */\n\n/**\n * @param {EncodeOptions} [encodeOptions]\n * @returns {(passable: Passable) => string}\n */\nconst        makeEncodePassable=(encodeOptions={})=>{\nconst{\nencodeRemotable=(rem,_)=>Fail `remotable unexpected: ${rem}`,\nencodePromise=(prom,_)=>Fail `promise unexpected: ${prom}`,\nencodeError=(err,_)=>Fail `error unexpected: ${err}`}=\nencodeOptions;\n\nconst encodePassable=(passable)=>{\nif(isErrorLike(passable)){\nreturn encodeError(passable,encodePassable);\n }\nconst passStyle=passStyleOf(passable);\nswitch(passStyle){\ncase'null':{\nreturn'v';\n }\ncase'undefined':{\nreturn'z';\n }\ncase'number':{\nreturn encodeBinary64(passable);\n }\ncase'string':{\nreturn `s${passable}`;\n }\ncase'boolean':{\nreturn `b${passable}`;\n }\ncase'bigint':{\nreturn encodeBigInt(passable);\n }\ncase'remotable':{\nconst result=encodeRemotable(passable,encodePassable);\nresult.startsWith('r')||\nFail `internal: Remotable encoding must start with \"r\": ${result}`;\nreturn result;\n }\ncase'error':{\nconst result=encodeError(passable,encodePassable);\nresult.startsWith('!')||\nFail `internal: Error encoding must start with \"!\": ${result}`;\nreturn result;\n }\ncase'promise':{\nconst result=encodePromise(passable,encodePassable);\nresult.startsWith('?')||\nFail `internal: Promise encoding must start with \"?\": ${result}`;\nreturn result;\n }\ncase'symbol':{\nreturn `y${nameForPassableSymbol(passable)}`;\n }\ncase'copyArray':{\nreturn encodeArray(passable,encodePassable);\n }\ncase'copyRecord':{\nreturn encodeRecord(passable,encodePassable);\n }\ncase'tagged':{\nreturn encodeTagged(passable,encodePassable);\n }\ndefault:{\nthrow Fail `a ${q(passStyle)} cannot be used as a collection passable`;\n }}\n\n };\nreturn harden(encodePassable);\n };$h‍_once.makeEncodePassable(makeEncodePassable);\nharden(makeEncodePassable);\n\n/**\n * @typedef {object} DecodeOptions\n * @property {(\n *   encodedRemotable: string,\n *   decodeRecur: (e: string) => Passable\n * ) => Remotable} [decodeRemotable]\n * @property {(\n *   encodedPromise: string,\n *   decodeRecur: (e: string) => Passable\n * ) => Promise} [decodePromise]\n * @property {(\n *   encodedError: string,\n *   decodeRecur: (e: string) => Passable\n * ) => Error} [decodeError]\n */\n\n/**\n * @param {DecodeOptions} [decodeOptions]\n * @returns {(encoded: string) => Passable}\n */\nconst        makeDecodePassable=(decodeOptions={})=>{\nconst{\ndecodeRemotable=(rem,_)=>Fail `remotable unexpected: ${rem}`,\ndecodePromise=(prom,_)=>Fail `promise unexpected: ${prom}`,\ndecodeError=(err,_)=>Fail `error unexpected: ${err}`}=\ndecodeOptions;\n\nconst decodePassable=(encoded)=>{\nswitch(encoded.charAt(0)){\ncase'v':{\nreturn null;\n }\ncase'z':{\nreturn undefined;\n }\ncase'f':{\nreturn decodeBinary64(encoded);\n }\ncase's':{\nreturn encoded.substring(1);\n }\ncase'b':{\nreturn encoded.substring(1)!=='false';\n }\ncase'n':\ncase'p':{\nreturn decodeBigInt(encoded);\n }\ncase'r':{\nreturn decodeRemotable(encoded,decodePassable);\n }\ncase'?':{\nreturn decodePromise(encoded,decodePassable);\n }\ncase'!':{\nreturn decodeError(encoded,decodePassable);\n }\ncase'y':{\nreturn passableSymbolForName(encoded.substring(1));\n }\ncase'[':{\nreturn decodeArray(encoded,decodePassable);\n }\ncase'(':{\nreturn decodeRecord(encoded,decodePassable);\n }\ncase':':{\nreturn decodeTagged(encoded,decodePassable);\n }\ndefault:{\nthrow Fail `invalid database key: ${encoded}`;\n }}\n\n };\nreturn harden(decodePassable);\n };$h‍_once.makeDecodePassable(makeDecodePassable);\nharden(makeDecodePassable);\n\nconst        isEncodedRemotable=(encoded)=>encoded.charAt(0)==='r';$h‍_once.isEncodedRemotable(isEncodedRemotable);\nharden(isEncodedRemotable);\n\n/* /////////////////////////////////////////////////////////////////////////////*/\n\n/**\n * @type {Record<PassStyle, string>}\n * The single prefix characters to be used for each PassStyle category.\n * `bigint` is a two character string because each of those characters\n * individually is a valid bigint prefix. `n` for \"negative\" and `p` for\n * \"positive\". The ordering of these prefixes is the same as the\n * rankOrdering of their respective PassStyles. This table is imported by\n * rankOrder.js for this purpose.\n *\n * In addition, `|` is the remotable->ordinal mapping prefix:\n * This is not used in covers but it is\n * reserved from the same set of strings. Note that the prefix is > any\n * prefix used by any cover so that ordinal mapping keys are always outside\n * the range of valid collection entry keys.\n */\nconst        passStylePrefixes={\nerror:'!',\ncopyRecord:'(',\ntagged:':',\npromise:'?',\ncopyArray:'[',\nboolean:'b',\nnumber:'f',\nbigint:'np',\nremotable:'r',\nstring:'s',\nnull:'v',\nsymbol:'y',\nundefined:'z'};$h‍_once.passStylePrefixes(passStylePrefixes);\n\nObject.setPrototypeOf(passStylePrefixes,null);\nharden(passStylePrefixes);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"recordNames":["recordNames"],"recordValues":["recordValues"],"zeroPad":["zeroPad"],"makeEncodePassable":["makeEncodePassable"],"makeDecodePassable":["makeDecodePassable"],"isEncodedRemotable":["isEncodedRemotable"],"passStylePrefixes":["passStylePrefixes"]},"__needsImportMeta__":false}