{"imports":["@endo/pass-style","./encodePassable.js"],"exports":["FullRankCover","assertRankSorted","comparatorMirrorImage","compareAntiRank","compareRank","coveredEntries","getIndexCover","getPassStyleCover","intersectRankCovers","isRankSorted","makeComparatorKit","makeFullOrderComparatorKit","sortByRank","trivialComparator","unionRankCovers"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let getTag,passStyleOf,nameForPassableSymbol,passStylePrefixes,recordNames,recordValues;$h‍_imports([[\"@endo/pass-style\", [[\"getTag\", [$h‍_a => (getTag = $h‍_a)]],[\"passStyleOf\", [$h‍_a => (passStyleOf = $h‍_a)]],[\"nameForPassableSymbol\", [$h‍_a => (nameForPassableSymbol = $h‍_a)]]]],[\"./encodePassable.js\", [[\"passStylePrefixes\", [$h‍_a => (passStylePrefixes = $h‍_a)]],[\"recordNames\", [$h‍_a => (recordNames = $h‍_a)]],[\"recordValues\", [$h‍_a => (recordValues = $h‍_a)]]]]]);   \n\n\n\n\n\n\n/** @typedef {Ximport('@endo/pass-style').Passable} Passable */\n/** @typedef {Ximport('@endo/pass-style').PassStyle} PassStyle */\n/** @typedef {Ximport('./types.js').RankCover} RankCover */\n/** @typedef {Ximport('./types.js').RankComparison} RankComparison */\n/** @typedef {Ximport('./types.js').RankCompare} RankCompare */\n/** @typedef {Ximport('./types.js').FullCompare} FullCompare */\n\nconst{Fail,quote:q}=assert;\nconst{entries,fromEntries,setPrototypeOf,is}=Object;\n\n/**\n * @typedef {object} RankComparatorKit\n * @property {RankCompare} comparator\n * @property {RankCompare} antiComparator\n */\n\n/**\n * @typedef {object} FullComparatorKit\n * @property {FullCompare} comparator\n * @property {FullCompare} antiComparator\n */\n\n/**\n * @typedef {[number, number]} IndexCover\n */\n\n/**\n * This is the equality comparison used by JavaScript's Map and Set\n * abstractions, where NaN is the same as NaN and -0 is the same as\n * 0. Marshal serializes -0 as zero, so the semantics of our distributed\n * object system does not distinguish 0 from -0.\n *\n * `sameValueZero` is the EcmaScript spec name for this equality comparison,\n * but TODO we need a better name for the API.\n *\n * @param {any} x\n * @param {any} y\n * @returns {boolean}\n */\nconst sameValueZero=(x,y)=>x===y||is(x,y);\n\nconst        trivialComparator=(left,right)=>\n/* eslint-disable-next-line no-nested-ternary, @endo/restrict-comparison-operands*/\nleft<right?-1:left===right?0:1;\n\n/**\n * @typedef {Record<PassStyle, { index: number, cover: RankCover }>} PassStyleRanksRecord\n */$h‍_once.trivialComparator(trivialComparator);\n\nconst passStyleRanks=/** @type {PassStyleRanksRecord} */\nfromEntries(\nentries(passStylePrefixes)\n/* Sort entries by ascending prefix.*/.\nsort(([_leftStyle,leftPrefixes],[_rightStyle,rightPrefixes])=>{\nreturn trivialComparator(leftPrefixes,rightPrefixes);\n }).\nmap(([passStyle,prefixes],index)=>{\n/* Cover all strings that start with any character in `prefixes`,*/\n/* verifying that it is sorted so that is*/\n/* all s such that prefixes.at(0) ≤ s < successor(prefixes.at(-1)).*/\nprefixes===[...prefixes].sort().join('')||\nFail `unsorted prefixes for passStyle ${q(passStyle)}: ${q(prefixes)}`;\nconst cover=[\nprefixes.charAt(0),\nString.fromCharCode(prefixes.charCodeAt(prefixes.length-1)+1)];\n\nreturn[passStyle,{index,cover}];\n }));\n\n\nsetPrototypeOf(passStyleRanks,null);\nharden(passStyleRanks);\n\n/**\n * Associate with each passStyle a RankCover that may be an overestimate,\n * and whose results therefore need to be filtered down. For example, because\n * there is not a smallest or biggest bigint, bound it by `NaN` (the last place\n * number) and `''` (the empty string, which is the first place string). Thus,\n * a range query using this range may include these values, which would then\n * need to be filtered out.\n *\n * @param {PassStyle} passStyle\n * @returns {RankCover}\n */\nconst        getPassStyleCover=(passStyle)=>passStyleRanks[passStyle].cover;$h‍_once.getPassStyleCover(getPassStyleCover);\nharden(getPassStyleCover);\n\n/**\n * @type {WeakMap<RankCompare,WeakSet<Passable[]>>}\n */\nconst memoOfSorted=new WeakMap();\n\n/**\n * @type {WeakMap<RankCompare,RankCompare>}\n */\nconst comparatorMirrorImages=new WeakMap();\n\n/**\n * @param {RankCompare=} compareRemotables\n * An option to create a comparator in which an internal order is\n * assigned to remotables. This defaults to a comparator that\n * always returns `0`, meaning that all remotables are tied\n * for the same rank.\n * @returns {RankComparatorKit}\n */\nconst        makeComparatorKit=(compareRemotables=(_x,_y)=>0)=>{\n/** @type {RankCompare} */\nconst comparator=(left,right)=>{\nif(sameValueZero(left,right)){\nreturn 0;\n }\nconst leftStyle=passStyleOf(left);\nconst rightStyle=passStyleOf(right);\nif(leftStyle!==rightStyle){\nreturn trivialComparator(\npassStyleRanks[leftStyle].index,\npassStyleRanks[rightStyle].index);\n\n }\n/* eslint-disable @endo/restrict-comparison-operands --\n * We know `left` and `right` are comparable.\n */\nswitch(leftStyle){\ncase'remotable':{\nreturn compareRemotables(left,right);\n }\ncase'undefined':\ncase'null':\ncase'error':\ncase'promise':{\n/* For each of these passStyles, all members of that passStyle are tied*/\n/* for the same rank.*/\nreturn 0;\n }\ncase'boolean':\ncase'bigint':\ncase'string':{\n/* Within each of these passStyles, the rank ordering agrees with*/\n/* JavaScript's relational operators `<` and `>`.*/\nif(left<right){\nreturn-1;\n }else{\nassert(left>right);\nreturn 1;\n }\n }\ncase'symbol':{\nreturn comparator(\nnameForPassableSymbol(left),\nnameForPassableSymbol(right));\n\n }\ncase'number':{\n/* `NaN`'s rank is after all other numbers.*/\nif(Number.isNaN(left)){\nassert(!Number.isNaN(right));\nreturn 1;\n }else if(Number.isNaN(right)){\nreturn-1;\n }\n/* The rank ordering of non-NaN numbers agrees with JavaScript's*/\n/* relational operators '<' and '>'.*/\nif(left<right){\nreturn-1;\n }else{\nassert(left>right);\nreturn 1;\n }\n }\ncase'copyRecord':{\n/* Lexicographic by inverse sorted order of property names, then*/\n/* lexicographic by corresponding values in that same inverse*/\n/* order of their property names. Comparing names by themselves first,*/\n/* all records with the exact same set of property names sort next to*/\n/* each other in a rank-sort of copyRecords.*/\n\n/* The copyRecord invariants enforced by passStyleOf ensure that*/\n/* all the property names are strings. We need the reverse sorted order*/\n/* of these names, which we then compare lexicographically. This ensures*/\n/* that if the names of record X are a subset of the names of record Y,*/\n/* then record X will have an earlier rank and sort to the left of Y.*/\nconst leftNames=recordNames(left);\nconst rightNames=recordNames(right);\n\nconst result=comparator(leftNames,rightNames);\nif(result!==0){\nreturn result;\n }\nreturn comparator(\nrecordValues(left,leftNames),\nrecordValues(right,rightNames));\n\n }\ncase'copyArray':{\n/* Lexicographic*/\nconst len=Math.min(left.length,right.length);\nfor(let i=0;i<len;i+=1){\nconst result=comparator(left[i],right[i]);\nif(result!==0){\nreturn result;\n }\n }\n/* If all matching elements were tied, then according to their lengths.*/\n/* If array X is a prefix of array Y, then X has an earlier rank than Y.*/\nreturn comparator(left.length,right.length);\n }\ncase'tagged':{\n/* Lexicographic by `[Symbol.toStringTag]` then `.payload`.*/\nconst labelComp=comparator(getTag(left),getTag(right));\nif(labelComp!==0){\nreturn labelComp;\n }\nreturn comparator(left.payload,right.payload);\n }\ndefault:{\nthrow Fail `Unrecognized passStyle: ${q(leftStyle)}`;\n }}\n\n/* eslint-enable */\n };\n\n/** @type {RankCompare} */\nconst antiComparator=(x,y)=>comparator(y,x);\n\nmemoOfSorted.set(comparator,new WeakSet());\nmemoOfSorted.set(antiComparator,new WeakSet());\ncomparatorMirrorImages.set(comparator,antiComparator);\ncomparatorMirrorImages.set(antiComparator,comparator);\n\nreturn harden({comparator,antiComparator});\n };\n/**\n * @param {RankCompare} comparator\n * @returns {RankCompare=}\n */$h‍_once.makeComparatorKit(makeComparatorKit);\nconst        comparatorMirrorImage=(comparator)=>\ncomparatorMirrorImages.get(comparator);\n\n/**\n * @param {Passable[]} passables\n * @param {RankCompare} compare\n * @returns {boolean}\n */$h‍_once.comparatorMirrorImage(comparatorMirrorImage);\nconst        isRankSorted=(passables,compare)=>{\nconst subMemoOfSorted=memoOfSorted.get(compare);\nassert(subMemoOfSorted!==undefined);\nif(subMemoOfSorted.has(passables)){\nreturn true;\n }\nassert(passStyleOf(passables)==='copyArray');\nfor(let i=1;i<passables.length;i+=1){\nif(compare(passables[i-1],passables[i])>=1){\nreturn false;\n }\n }\nsubMemoOfSorted.add(passables);\nreturn true;\n };$h‍_once.isRankSorted(isRankSorted);\nharden(isRankSorted);\n\n/**\n * @param {Passable[]} sorted\n * @param {RankCompare} compare\n */\nconst        assertRankSorted=(sorted,compare)=>\nisRankSorted(sorted,compare)||\n/* TODO assert on bug could lead to infinite recursion. Fix.*/\n/* eslint-disable-next-line no-use-before-define*/\nFail `Must be rank sorted: ${sorted} vs ${sortByRank(sorted,compare)}`;$h‍_once.assertRankSorted(assertRankSorted);\nharden(assertRankSorted);\n\n/**\n * TODO SECURITY BUG: https://github.com/Agoric/agoric-sdk/issues/4260\n * sortByRank currently uses `Array.prototype.sort` directly, and\n * so only works correctly when given a `compare` function that considers\n * `undefined` strictly bigger (`>`) than everything else. This is\n * because `Array.prototype.sort` bizarrely moves all `undefined`s to\n * the end of the array regardless, without consulting the `compare`\n * function. This is a genuine bug for us NOW because sometimes we sort\n * in reverse order by passing a reversed rank comparison function.\n *\n * @param {Iterable<Passable>} passables\n * @param {RankCompare} compare\n * @returns {Passable[]}\n */\nconst        sortByRank=(passables,compare)=>{\nif(Array.isArray(passables)){\nharden(passables);\n/* Calling isRankSorted gives it a chance to get memoized for*/\n/* this `compare` function even if it was already memoized for a different*/\n/* `compare` function.*/\nif(isRankSorted(passables,compare)){\nreturn passables;\n }\n }\nconst unsorted=[...passables];\nunsorted.forEach(harden);\nconst sorted=harden(unsorted.sort(compare));\nconst subMemoOfSorted=memoOfSorted.get(compare);\nassert(subMemoOfSorted!==undefined);\nsubMemoOfSorted.add(sorted);\nreturn sorted;\n };$h‍_once.sortByRank(sortByRank);\nharden(sortByRank);\n\n/**\n * See\n * https://en.wikipedia.org/wiki/Binary_search_algorithm#Procedure_for_finding_the_leftmost_element\n *\n * @param {Passable[]} sorted\n * @param {RankCompare} compare\n * @param {Passable} key\n * @param {(\"leftMost\" | \"rightMost\")=} bias\n * @returns {number}\n */\nconst rankSearch=(sorted,compare,key,bias='leftMost')=>{\nassertRankSorted(sorted,compare);\nlet left=0;\nlet right=sorted.length;\nwhile(left<right){\nconst m=Math.floor((left+right)/2);\nconst comp=compare(sorted[m],key);\nif(comp<=-1||comp===0&&bias==='rightMost'){\nleft=m+1;\n }else{\nassert(comp>=1||comp===0&&bias==='leftMost');\nright=m;\n }\n }\nreturn bias==='leftMost'?left:right-1;\n };\n\n/**\n * @param {Passable[]} sorted\n * @param {RankCompare} compare\n * @param {RankCover} rankCover\n * @returns {IndexCover}\n */\nconst        getIndexCover=(sorted,compare,[leftKey,rightKey])=>{\nassertRankSorted(sorted,compare);\nconst leftIndex=rankSearch(sorted,compare,leftKey,'leftMost');\nconst rightIndex=rankSearch(sorted,compare,rightKey,'rightMost');\nreturn[leftIndex,rightIndex];\n };$h‍_once.getIndexCover(getIndexCover);\nharden(getIndexCover);\n\n/** @type {RankCover} */\nconst        FullRankCover=harden(['','{']);\n\n/**\n * @param {Passable[]} sorted\n * @param {IndexCover} indexCover\n * @returns {Iterable<[number, Passable]>}\n */$h‍_once.FullRankCover(FullRankCover);\nconst        coveredEntries=(sorted,[leftIndex,rightIndex])=>{\n/** @type {Iterable<[number, Passable]>} */\nconst iterable=harden({\n[Symbol.iterator]:()=>{\nlet i=leftIndex;\nreturn harden({\nnext:()=>{\nif(i<=rightIndex){\nconst element=sorted[i];\ni+=1;\nreturn harden({value:[i,element],done:false});\n }else{\nreturn harden({value:undefined,done:true});\n }\n }});\n\n }});\n\nreturn iterable;\n };$h‍_once.coveredEntries(coveredEntries);\nharden(coveredEntries);\n\n/**\n * @param {RankCompare} compare\n * @param {Passable} a\n * @param {Passable} b\n * @returns {Passable}\n */\nconst maxRank=(compare,a,b)=>compare(a,b)>=0?a:b;\n\n/**\n * @param {RankCompare} compare\n * @param {Passable} a\n * @param {Passable} b\n * @returns {Passable}\n */\nconst minRank=(compare,a,b)=>compare(a,b)<=0?a:b;\n\n/**\n * @param {RankCompare} compare\n * @param {RankCover[]} covers\n * @returns {RankCover}\n */\nconst        unionRankCovers=(compare,covers)=>{\n/**\n * @param {RankCover} a\n * @param {RankCover} b\n * @returns {RankCover}\n */\nconst unionRankCoverPair=([leftA,rightA],[leftB,rightB])=>[\nminRank(compare,leftA,leftB),\nmaxRank(compare,rightA,rightB)];\n\nreturn covers.reduce(unionRankCoverPair,['{','']);\n };$h‍_once.unionRankCovers(unionRankCovers);\nharden(unionRankCovers);\n\n/**\n * @param {RankCompare} compare\n * @param {RankCover[]} covers\n * @returns {RankCover}\n */\nconst        intersectRankCovers=(compare,covers)=>{\n/**\n * @param {RankCover} a\n * @param {RankCover} b\n * @returns {RankCover}\n */\nconst intersectRankCoverPair=([leftA,rightA],[leftB,rightB])=>[\nmaxRank(compare,leftA,leftB),\nminRank(compare,rightA,rightB)];\n\nreturn covers.reduce(intersectRankCoverPair,['','{']);\n };$h‍_once.intersectRankCovers(intersectRankCovers);\n\nconst       {comparator:compareRank,antiComparator:compareAntiRank}=\nmakeComparatorKit();\n\n/**\n * Create a comparator kit in which remotables are fully ordered\n * by the order in which they are first seen by *this* comparator kit.\n * BEWARE: This is observable mutable state, so such a comparator kit\n * should never be shared among subsystems that should not be able\n * to communicate.\n *\n * Note that this order does not meet the requirements for store\n * ordering, since it has no memory of deleted keys.\n *\n * These full order comparator kit is strictly more precise that the\n * rank order comparator kits above. As a result, any array which is\n * sorted by such a full order will pass the isRankSorted test with\n * a corresponding rank order.\n *\n * An array which is sorted by a *fresh* full order comparator, i.e.,\n * one that has not yet seen any remotables, will of course remain\n * sorted by according to *that* full order comparator. An array *of\n * scalars* sorted by a fresh full order will remain sorted even\n * according to a new fresh full order comparator, since it will see\n * the remotables in the same order again. Unfortunately, this is\n * not true of arrays of passables in general.\n *\n * @param {boolean=} longLived\n * @returns {FullComparatorKit}\n */$h‍_once.compareRank(compareRank);$h‍_once.compareAntiRank(compareAntiRank);\nconst        makeFullOrderComparatorKit=(longLived=false)=>{\nlet numSeen=0;\n/* When dynamically created with short lifetimes (the default) a WeakMap*/\n/* would perform poorly, and the leak created by a Map only lasts as long*/\n/* as the Map.*/\nconst MapConstructor=longLived?WeakMap:Map;\nconst seen=new MapConstructor();\nconst tag=(r)=>{\nif(seen.has(r)){\nreturn seen.get(r);\n }\nnumSeen+=1;\nseen.set(r,numSeen);\nreturn numSeen;\n };\nconst compareRemotables=(x,y)=>compareRank(tag(x),tag(y));\nreturn makeComparatorKit(compareRemotables);\n };$h‍_once.makeFullOrderComparatorKit(makeFullOrderComparatorKit);\nharden(makeFullOrderComparatorKit);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"trivialComparator":["trivialComparator"],"getPassStyleCover":["getPassStyleCover"],"makeComparatorKit":["makeComparatorKit"],"comparatorMirrorImage":["comparatorMirrorImage"],"isRankSorted":["isRankSorted"],"assertRankSorted":["assertRankSorted"],"sortByRank":["sortByRank"],"getIndexCover":["getIndexCover"],"FullRankCover":["FullRankCover"],"coveredEntries":["coveredEntries"],"unionRankCovers":["unionRankCovers"],"intersectRankCovers":["intersectRankCovers"],"compareRank":["compareRank"],"compareAntiRank":["compareAntiRank"],"makeFullOrderComparatorKit":["makeFullOrderComparatorKit"]},"__needsImportMeta__":false}