{"imports":[],"exports":["Nat","isNat"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   $h‍_imports([]);Object.defineProperty(isNat, 'name', {value: \"isNat\"});$h‍_once.isNat(isNat);Object.defineProperty(Nat, 'name', {value: \"Nat\"});$h‍_once.Nat(Nat);   /* Copyright (C) 2011 Google Inc.*/\n/* Copyright (C) 2018 Agoric*/\n/**/\n/* Licensed under the Apache License, Version 2.0 (the \"License\");*/\n/* you may not use this file except in compliance with the License.*/\n/* You may obtain a copy of the License at*/\n/**/\n/* http://www.apache.org/licenses/LICENSE-2.0*/\n/**/\n/* Unless required by applicable law or agreed to in writing, software*/\n/* distributed under the License is distributed on an \"AS IS\" BASIS,*/\n/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*/\n/* See the License for the specific language governing permissions and*/\n/* limitations under the License.*/\n\n/* @ts-check*/\n\n/**\n * Is `allegedNum` a number in the [contiguous range of exactly and\n * unambiguously\n * representable](https://esdiscuss.org/topic/more-numeric-constants-please-especially-epsilon#content-14)\n *  natural numbers (non-negative integers)?\n *\n * To qualify `allegedNum` must either be a\n * non-negative `bigint`, or a non-negative `number` representing an integer\n * within range of [integers safely representable in\n * floating point](https://tc39.es/ecma262/#sec-number.issafeinteger).\n *\n * @param {unknown} allegedNum\n * @returns {boolean}\n */\nfunction isNat(allegedNum){\nif(typeof allegedNum==='bigint'){\nreturn allegedNum>=0;\n }\nif(typeof allegedNum!=='number'){\nreturn false;\n }\n\nreturn Number.isSafeInteger(allegedNum)&&allegedNum>=0;\n }\n\n/**\n * If `allegedNumber` passes the `isNat` test, then return it as a bigint.\n * Otherwise throw an appropriate error.\n *\n * If `allegedNum` is neither a bigint nor a number, `Nat` throws a `TypeError`.\n * Otherwise, if it is not a [safely\n * representable](https://esdiscuss.org/topic/more-numeric-constants-please-especially-epsilon#content-14)\n * non-negative integer, `Nat` throws a `RangeError`.\n * Otherwise, it is converted to a bigint if necessary and returned.\n *\n * @param {unknown} allegedNum\n * @returns {bigint}\n */\nfunction Nat(allegedNum){\nif(typeof allegedNum==='bigint'){\nif(allegedNum<0){\nthrow RangeError( `${allegedNum} is negative`);\n }\nreturn allegedNum;\n }\n\nif(typeof allegedNum==='number'){\nif(!Number.isSafeInteger(allegedNum)){\nthrow RangeError( `${allegedNum} not a safe integer`);\n }\nif(allegedNum<0){\nthrow RangeError( `${allegedNum} is negative`);\n }\nreturn BigInt(allegedNum);\n }\n\nthrow TypeError(\n `${allegedNum} is a ${typeof allegedNum} but must be a bigint or a number`);\n\n }\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"isNat":["isNat"],"Nat":["Nat"]},"__needsImportMeta__":false}