{"imports":["@endo/promise-kit","./passStyle-helpers.js","./copyArray.js","./copyRecord.js","./tagged.js","./error.js","./remotable.js","./symbol.js","./safe-promise.js"],"exports":["assertPassable","passStyleOf"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let isPromise,isObject,isTypedArray,PASS_STYLE,CopyArrayHelper,CopyRecordHelper,TaggedHelper,ErrorHelper,RemotableHelper,assertPassableSymbol,assertSafePromise;$h‍_imports([[\"@endo/promise-kit\", [[\"isPromise\", [$h‍_a => (isPromise = $h‍_a)]]]],[\"./passStyle-helpers.js\", [[\"isObject\", [$h‍_a => (isObject = $h‍_a)]],[\"isTypedArray\", [$h‍_a => (isTypedArray = $h‍_a)]],[\"PASS_STYLE\", [$h‍_a => (PASS_STYLE = $h‍_a)]]]],[\"./copyArray.js\", [[\"CopyArrayHelper\", [$h‍_a => (CopyArrayHelper = $h‍_a)]]]],[\"./copyRecord.js\", [[\"CopyRecordHelper\", [$h‍_a => (CopyRecordHelper = $h‍_a)]]]],[\"./tagged.js\", [[\"TaggedHelper\", [$h‍_a => (TaggedHelper = $h‍_a)]]]],[\"./error.js\", [[\"ErrorHelper\", [$h‍_a => (ErrorHelper = $h‍_a)]]]],[\"./remotable.js\", [[\"RemotableHelper\", [$h‍_a => (RemotableHelper = $h‍_a)]]]],[\"./symbol.js\", [[\"assertPassableSymbol\", [$h‍_a => (assertPassableSymbol = $h‍_a)]]]],[\"./safe-promise.js\", [[\"assertSafePromise\", [$h‍_a => (assertSafePromise = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\n\n\n\n\n\n\n/** @typedef {Ximport('./internal-types.js').PassStyleHelper} PassStyleHelper */\n/** @typedef {Ximport('./types.js').Passable} Passable */\n/** @typedef {Ximport('./types.js').PassStyle} PassStyle */\n/** @typedef {Ximport('./types.js').PassStyleOf} PassStyleOf */\n/** @typedef {Ximport('./types.js').PrimitiveStyle} PrimitiveStyle */\n\n/** @typedef {Exclude<PassStyle, PrimitiveStyle | \"promise\">} HelperPassStyle */\n\nconst{details:X,Fail,quote:q}=assert;\nconst{ownKeys}=Reflect;\nconst{isFrozen}=Object;\n\n/**\n * @param {PassStyleHelper[]} passStyleHelpers\n * @returns {Record<HelperPassStyle, PassStyleHelper> }\n */\n\nconst makeHelperTable=(passStyleHelpers)=>{\n/** @type {Record<HelperPassStyle, any> & {__proto__: null}} */\nconst HelperTable={\n__proto__:null,\ncopyArray:undefined,\ncopyRecord:undefined,\ntagged:undefined,\nerror:undefined,\nremotable:undefined};\n\nfor(const helper of passStyleHelpers){\nconst{styleName}=helper;\nstyleName in HelperTable||Fail `Unrecognized helper: ${q(styleName)}`;\nHelperTable[styleName]===undefined||\nFail `conflicting helpers for ${q(styleName)}`;\nHelperTable[styleName]=helper;\n }\nfor(const styleName of ownKeys(HelperTable)){\nHelperTable[styleName]!==undefined||\nFail `missing helper for ${q(styleName)}`;\n }\n\nreturn harden(HelperTable);\n };\n\n/**\n * @param {PassStyleHelper[]} passStyleHelpers The passStyleHelpers to register,\n * in priority order.\n * NOTE These must all be \"trusted\",\n * complete, and non-colliding. `makePassStyleOf` may *assume* that each helper\n * does what it is supposed to do. `makePassStyleOf` is not trying to defend\n * itself against malicious helpers, though it does defend against some\n * accidents.\n * @returns {PassStyleOf}\n */\nconst makePassStyleOf=(passStyleHelpers)=>{\nconst HelperTable=makeHelperTable(passStyleHelpers);\nconst remotableHelper=HelperTable.remotable;\n\n/**\n * Purely for performance. However it is mutable static state, and\n * it does have some observability on proxies. TODO need to assess\n * whether this creates a static communications channel.\n *\n * passStyleOf does a full recursive walk of pass-by-copy\n * structures, in order to validate that they are acyclic. In addition\n * it is used by other algorithms to recursively walk these pass-by-copy\n * structures, so without this cache, these algorithms could be\n * O(N**2) or worse.\n *\n * @type {WeakMap<Passable, PassStyle>}\n */\nconst passStyleMemo=new WeakMap();\n\n/**\n * @type {PassStyleOf}\n */\nconst passStyleOf=(passable)=>{\n/* Even when a WeakSet is correct, when the set has a shorter lifetime*/\n/* than its keys, we prefer a Set due to expected implementation*/\n/* tradeoffs.*/\nconst inProgress=new Set();\n\n/**\n * @type {PassStyleOf}\n */\nconst passStyleOfRecur=(inner)=>{\nconst innerIsObject=isObject(inner);\nif(innerIsObject){\nif(passStyleMemo.has(inner)){\n/* @ts-ignore TypeScript doesn't know that `get` after `has` is safe*/\nreturn passStyleMemo.get(inner);\n }\n!inProgress.has(inner)||\nFail `Pass-by-copy data cannot be cyclic ${inner}`;\ninProgress.add(inner);\n }\n/* eslint-disable-next-line no-use-before-define*/\nconst passStyle=passStyleOfInternal(inner);\nif(innerIsObject){\npassStyleMemo.set(inner,passStyle);\ninProgress.delete(inner);\n }\nreturn passStyle;\n };\n\n/**\n * @type {PassStyleOf}\n */\nconst passStyleOfInternal=(inner)=>{\nconst typestr=typeof inner;\nswitch(typestr){\ncase'undefined':\ncase'string':\ncase'boolean':\ncase'number':\ncase'bigint':{\nreturn typestr;\n }\ncase'symbol':{\nassertPassableSymbol(inner);\nreturn'symbol';\n }\ncase'object':{\nif(inner===null){\nreturn'null';\n }\nif(!isFrozen(inner)){\nassert.fail(\n/* TypedArrays get special treatment in harden()*/\n/* and a corresponding special error message here.*/\nisTypedArray(inner)?\nX `Cannot pass mutable typed arrays like ${inner}.`:\nX `Cannot pass non-frozen objects like ${inner}. Use harden()`);\n\n }\nif(isPromise(inner)){\nassertSafePromise(inner);\nreturn'promise';\n }\ntypeof inner.then!=='function'||\nFail `Cannot pass non-promise thenables`;\nconst passStyleTag=inner[PASS_STYLE];\nif(passStyleTag!==undefined){\nassert.typeof(passStyleTag,'string');\nconst helper=HelperTable[passStyleTag];\nhelper!==undefined||\nFail `Unrecognized PassStyle: ${q(passStyleTag)}`;\nhelper.assertValid(inner,passStyleOfRecur);\nreturn (/** @type {PassStyle} */passStyleTag);\n }\nfor(const helper of passStyleHelpers){\nif(helper.canBeValid(inner)){\nhelper.assertValid(inner,passStyleOfRecur);\nreturn helper.styleName;\n }\n }\nremotableHelper.assertValid(inner,passStyleOfRecur);\nreturn'remotable';\n }\ncase'function':{\nisFrozen(inner)||\nFail `Cannot pass non-frozen objects like ${inner}. Use harden()`;\ntypeof inner.then!=='function'||\nFail `Cannot pass non-promise thenables`;\nremotableHelper.assertValid(inner,passStyleOfRecur);\nreturn'remotable';\n }\ndefault:{\nassert.fail(X `Unrecognized typeof ${q(typestr)}`,TypeError);\n }}\n\n };\n\nreturn passStyleOfRecur(passable);\n };\nreturn harden(passStyleOf);\n };\n\nconst        passStyleOf=makePassStyleOf([\nCopyArrayHelper,\nCopyRecordHelper,\nTaggedHelper,\nErrorHelper,\nRemotableHelper]);$h‍_once.passStyleOf(passStyleOf);\n\n\nconst        assertPassable=(val)=>{\npassStyleOf(val);/* throws if val is not a passable*/\n };$h‍_once.assertPassable(assertPassable);\nharden(assertPassable);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"passStyleOf":["passStyleOf"],"assertPassable":["assertPassable"]},"__needsImportMeta__":false}