{"imports":["./passStyle-helpers.js"],"exports":["RemotableHelper","assertIface","getInterfaceOf"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let assertChecker,canBeMethod,hasOwnPropertyOf,PASS_STYLE,checkTagRecord,checkFunctionTagRecord,isObject,getTag;$h‍_imports([[\"./passStyle-helpers.js\", [[\"assertChecker\", [$h‍_a => (assertChecker = $h‍_a)]],[\"canBeMethod\", [$h‍_a => (canBeMethod = $h‍_a)]],[\"hasOwnPropertyOf\", [$h‍_a => (hasOwnPropertyOf = $h‍_a)]],[\"PASS_STYLE\", [$h‍_a => (PASS_STYLE = $h‍_a)]],[\"checkTagRecord\", [$h‍_a => (checkTagRecord = $h‍_a)]],[\"checkFunctionTagRecord\", [$h‍_a => (checkFunctionTagRecord = $h‍_a)]],[\"isObject\", [$h‍_a => (isObject = $h‍_a)]],[\"getTag\", [$h‍_a => (getTag = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\n\n\n\n\n\n/** @typedef {Ximport('./types.js').Checker} Checker */\n/** @typedef {Ximport('./types.js').InterfaceSpec} InterfaceSpec */\n/** @typedef {Ximport('./types.js').MarshalGetInterfaceOf} MarshalGetInterfaceOf */\n/** @typedef {Ximport('./internal-types.js').PassStyleHelper} PassStyleHelper */\n/** @typedef {Ximport('./types.js').RemotableObject} Remotable */\n\nconst{details:X,Fail,quote:q}=assert;\nconst{ownKeys}=Reflect;\nconst{isArray}=Array;\nconst{\ngetPrototypeOf,\nisFrozen,\nprototype:objectPrototype,\ngetOwnPropertyDescriptors}=\nObject;\n\n/**\n * @param {InterfaceSpec} iface\n * @param {Checker} [check]\n */\nconst checkIface=(iface,check)=>{\nconst reject=!!check&&((details)=>check(false,details));\nreturn(\n/* TODO other possible ifaces, once we have third party veracity*/\n(typeof iface==='string'||\nreject&&\nreject(\nX `For now, interface ${iface} must be a string; unimplemented`))&&(\n\niface==='Remotable'||\niface.startsWith('Alleged: ')||\niface.startsWith('DebugName: ')||\nreject&&\nreject(\nX `For now, iface ${q(\niface)\n } must be \"Remotable\" or begin with \"Alleged: \" or \"DebugName: \"; unimplemented`)));\n\n\n };\n\n/**\n * An `iface` must be pure. Right now it must be a string, which is pure.\n * Later we expect to include some other values that qualify as `PureData`,\n * which is a pass-by-copy superstructure ending only in primitives or\n * empty pass-by-copy composites. No remotables, promises, or errors.\n * We *assume* for now that the pass-by-copy superstructure contains no\n * proxies.\n *\n * @param {InterfaceSpec} iface\n */\nconst        assertIface=(iface)=>checkIface(iface,assertChecker);$h‍_once.assertIface(assertIface);\nharden(assertIface);\n\n/**\n * @param {object | Function} original\n * @param {Checker} [check]\n * @returns {boolean}\n */\nconst checkRemotableProtoOf=(original,check)=>{\nconst reject=!!check&&((details)=>check(false,details));\nisObject(original)||\nFail `Remotables must be objects or functions: ${original}`;\n\n/* A valid remotable object must inherit from a \"tag record\" -- a*/\n/* plain-object prototype consisting of only*/\n/* a `PASS_STYLE` property with value \"remotable\" and a suitable `Symbol.toStringTag`*/\n/* property. The remotable could inherit directly from such a tag record, or*/\n/* it could inherit from another valid remotable, that therefore itself*/\n/* inherits directly or indirectly from such a tag record.*/\n/**/\n/* TODO: It would be nice to typedef this shape, but we can't declare a type*/\n/* with PASS_STYLE from JSDoc.*/\n/**/\n/* @type {{ [PASS_STYLE]: string,*/\n/* [Symbol.toStringTag]: string,*/\n/* }}*/\n/**/\nconst proto=getPrototypeOf(original);\nif(proto===objectPrototype||proto===null){\nreturn(\nreject&&\nreject(X `Remotables must be explicitly declared: ${q(original)}`));\n\n }\n\nif(typeof original==='object'){\nconst protoProto=getPrototypeOf(proto);\nif(protoProto!==objectPrototype&&protoProto!==null){\n/* eslint-disable-next-line no-use-before-define*/\nreturn checkRemotable(proto,check);\n }\nif(!checkTagRecord(proto,'remotable',check)){\nreturn false;\n }\n }else if(typeof original==='function'){\nif(!checkFunctionTagRecord(proto,'remotable',check)){\nreturn false;\n }\n }\n\n/* Typecasts needed due to https://github.com/microsoft/TypeScript/issues/1863*/\nconst passStyleKey=/** @type {unknown} */PASS_STYLE;\nconst tagKey=/** @type {unknown} */Symbol.toStringTag;\nconst{\n/* checkTagRecord already verified PASS_STYLE and Symbol.toStringTag own data properties.*/\n[/** @type {string} */passStyleKey]:_passStyleDesc,\n[/** @type {string} */tagKey]:{value:iface},\n...restDescs}=\ngetOwnPropertyDescriptors(proto);\n\nreturn(\n(ownKeys(restDescs).length===0||\nreject&&\nreject(\nX `Unexpected properties on Remotable Proto ${ownKeys(restDescs)}`))&&\n\ncheckIface(iface,check));\n\n };\n\n/**\n * Keep a weak set of confirmed remotables for marshal performance\n * (without which we would incur a redundant verification in\n * getInterfaceOf).\n * We don't remember rejections because they are possible to correct\n * with e.g. `harden`.\n *\n * @type {WeakSet<Remotable>}\n */\nconst confirmedRemotables=new WeakSet();\n\n/**\n * @param {Remotable} val\n * @param {Checker} [check]\n * @returns {boolean}\n */\nconst checkRemotable=(val,check)=>{\nif(confirmedRemotables.has(val)){\nreturn true;\n }\nconst reject=!!check&&((details)=>check(false,details));\nif(!isFrozen(val)){\nreturn reject&&reject(X `cannot serialize non-frozen objects like ${val}`);\n }\n/* eslint-disable-next-line no-use-before-define*/\nif(!RemotableHelper.canBeValid(val,check)){\nreturn false;\n }\nconst result=checkRemotableProtoOf(val,check);\nif(result){\nconfirmedRemotables.add(val);\n }\nreturn result;\n };\n\n/** @type {MarshalGetInterfaceOf} */\nconst        getInterfaceOf=(val)=>{\nif(\n!isObject(val)||\nval[PASS_STYLE]!=='remotable'||\n!checkRemotable(val))\n{\nreturn undefined;\n }\nreturn getTag(val);\n };$h‍_once.getInterfaceOf(getInterfaceOf);\nharden(getInterfaceOf);\n\n/**\n *\n * @type {PassStyleHelper}\n */\nconst        RemotableHelper=harden({\nstyleName:'remotable',\n\ncanBeValid:(candidate,check=undefined)=>{\nconst reject=!!check&&((details)=>check(false,details));\nconst validType=\n(isObject(candidate)||\nreject&&\nreject(X `cannot serialize non-objects as Remotable ${candidate}`))&&(\n!isArray(candidate)||\nreject&&\nreject(X `cannot serialize arrays as Remotable ${candidate}`));\nif(!validType){\nreturn false;\n }\n\nconst descs=getOwnPropertyDescriptors(candidate);\nif(typeof candidate==='object'){\n/* Every own property (regardless of enumerability)*/\n/* must have a function value.*/\nreturn ownKeys(descs).every((key)=>{\nreturn(\n/* Typecast needed due to https://github.com/microsoft/TypeScript/issues/1863*/\n(hasOwnPropertyOf(descs[/** @type {string} */key],'value')||\nreject&&\nreject(\nX `cannot serialize Remotables with accessors like ${q(\nString(key))\n } in ${candidate}`))&&(\n\nkey===Symbol.toStringTag&&checkIface(candidate[key],check)||\n(canBeMethod(candidate[key])||\nreject&&\nreject(\nX `cannot serialize Remotables with non-methods like ${q(\nString(key))\n } in ${candidate}`))&&(\n\nkey!==PASS_STYLE||\nreject&&\nreject(X `A pass-by-remote cannot shadow ${q(PASS_STYLE)}`))));\n\n });\n }else if(typeof candidate==='function'){\n/* Far functions cannot be methods, and cannot have methods.*/\n/* They must have exactly expected `.name` and `.length` properties*/\nconst{\nname:nameDesc,\nlength:lengthDesc,\n/* @ts-ignore TS doesn't like symbols as computed indexes??*/\n[Symbol.toStringTag]:toStringTagDesc,\n...restDescs}=\ndescs;\nconst restKeys=ownKeys(restDescs);\nreturn(\n(nameDesc&&typeof nameDesc.value==='string'||\nreject&&\nreject(X `Far function name must be a string, in ${candidate}`))&&(\nlengthDesc&&typeof lengthDesc.value==='number'||\nreject&&\nreject(\nX `Far function length must be a number, in ${candidate}`))&&(\n\ntoStringTagDesc===undefined||\n(typeof toStringTagDesc.value==='string'||\nreject&&\nreject(\nX `Far function @@toStringTag must be a string, in ${candidate}`))&&\n\ncheckIface(toStringTagDesc.value,check))&&(\nrestKeys.length===0||\nreject&&\nreject(\nX `Far functions unexpected properties besides .name and .length ${restKeys}`)));\n\n\n }\nreturn reject&&reject(X `unrecognized typeof ${candidate}`);\n },\n\nassertValid:(candidate)=>checkRemotable(candidate,assertChecker),\n\nevery:(_passable,_fn)=>true});$h‍_once.RemotableHelper(RemotableHelper);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"assertIface":["assertIface"],"getInterfaceOf":["getInterfaceOf"],"RemotableHelper":["RemotableHelper"]},"__needsImportMeta__":false}