{"imports":["./passStyle-helpers.js"],"exports":["ErrorHelper","getErrorConstructor","isErrorLike","toPassableError"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let assertChecker;$h‍_imports([[\"./passStyle-helpers.js\", [[\"assertChecker\", [$h‍_a => (assertChecker = $h‍_a)]]]]]);   \n\n\n\n/** @typedef {Ximport('./internal-types.js').PassStyleHelper} PassStyleHelper */\n/** @typedef {Ximport('./types.js').Checker} Checker */\n\nconst{details:X,Fail}=assert;\nconst{getPrototypeOf,getOwnPropertyDescriptors}=Object;\nconst{ownKeys}=Reflect;\n\n/* TODO: Maintenance hazard: Coordinate with the list of errors in the SES*/\n/* whilelist. Currently, both omit AggregateError, which is now standard. Both*/\n/* must eventually include it.*/\nconst errorConstructors=new Map([\n['Error',Error],\n['EvalError',EvalError],\n['RangeError',RangeError],\n['ReferenceError',ReferenceError],\n['SyntaxError',SyntaxError],\n['TypeError',TypeError],\n['URIError',URIError]]);\n\n\nconst        getErrorConstructor=(name)=>errorConstructors.get(name);$h‍_once.getErrorConstructor(getErrorConstructor);\nharden(getErrorConstructor);\n\n/**\n * @param {unknown} candidate\n * @param {Checker} [check]\n * @returns {boolean}\n */\nconst checkErrorLike=(candidate,check=undefined)=>{\nconst reject=!!check&&((details)=>check(false,details));\n/* TODO: Need a better test than instanceof*/\nreturn(\ncandidate instanceof Error||\nreject&&reject(X `Error expected: ${candidate}`));\n\n };\nharden(checkErrorLike);\n\n/**\n * Validating error objects are passable raises a tension between security\n * vs preserving diagnostic information. For errors, we need to remember\n * the error itself exists to help us diagnose a bug that's likely more\n * pressing than a validity bug in the error itself. Thus, whenever it is safe\n * to do so, we prefer to let the error-like test succeed and to couch these\n * complaints as notes on the error.\n *\n * To resolve this, such a malformed error object will still pass\n * `isErrorLike` so marshal can use this for top level error to report from,\n * even if it would not actually validate.\n * Instead, the diagnostics that `assertError` would have reported are\n * attached as notes to the malformed error. Thus, a malformed\n * error is passable by itself, but not as part of a passable structure.\n *\n * @param {unknown} candidate\n * @returns {boolean}\n */\nconst        isErrorLike=(candidate)=>checkErrorLike(candidate);$h‍_once.isErrorLike(isErrorLike);\nharden(isErrorLike);\n\n/**\n * @type {PassStyleHelper}\n */\nconst        ErrorHelper=harden({\nstyleName:'error',\n\ncanBeValid:checkErrorLike,\n\nassertValid:(candidate)=>{\nErrorHelper.canBeValid(candidate,assertChecker);\nconst proto=getPrototypeOf(candidate);\nconst{name}=proto;\nconst EC=getErrorConstructor(name);\nEC&&EC.prototype===proto||\nFail `Errors must inherit from an error class .prototype ${candidate}`;\n\nconst{\n/* Must allow `cause`, `errors`*/\nmessage:mDesc,\n/* Allow but ignore only extraneous own `stack` property.*/\nstack:_optStackDesc,\n...restDescs}=\ngetOwnPropertyDescriptors(candidate);\nownKeys(restDescs).length<1||\nFail `Passed Error has extra unpassed properties ${restDescs}`;\nif(mDesc){\ntypeof mDesc.value==='string'||\nFail `Passed Error \"message\" ${mDesc} must be a string-valued data property.`;\n!mDesc.enumerable||\nFail `Passed Error \"message\" ${mDesc} must not be enumerable`;\n }\nreturn true;\n }});\n\n\n/**\n * Return a new passable error that propagates the diagnostic info of the\n * original, and is linked to the original as a note.\n *\n * @param {Error} err\n * @returns {Error}\n */$h‍_once.ErrorHelper(ErrorHelper);\nconst        toPassableError=(err)=>{\nconst{name,message}=err;\n\nconst EC=getErrorConstructor( `${name}`)||Error;\nconst newError=harden(new EC( `${message}`));\n/* Even the cleaned up error copy, if sent to the console, should*/\n/* cause hidden diagnostic information of the original error*/\n/* to be logged.*/\nassert.note(newError,X `copied from error ${err}`);\nreturn newError;\n };$h‍_once.toPassableError(toPassableError);\nharden(toPassableError);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"getErrorConstructor":["getErrorConstructor"],"isErrorLike":["isErrorLike"],"ErrorHelper":["ErrorHelper"],"toPassableError":["toPassableError"]},"__needsImportMeta__":false}