{"imports":["./passStyle-helpers.js","./remotable.js"],"exports":["Far","Remotable","ToFarFunction"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let assertChecker,PASS_STYLE,assertIface,getInterfaceOf,RemotableHelper;$h‍_imports([[\"./passStyle-helpers.js\", [[\"assertChecker\", [$h‍_a => (assertChecker = $h‍_a)]],[\"PASS_STYLE\", [$h‍_a => (PASS_STYLE = $h‍_a)]]]],[\"./remotable.js\", [[\"assertIface\", [$h‍_a => (assertIface = $h‍_a)]],[\"getInterfaceOf\", [$h‍_a => (getInterfaceOf = $h‍_a)]],[\"RemotableHelper\", [$h‍_a => (RemotableHelper = $h‍_a)]]]]]);   \n\n\n\n\n/** @typedef {Ximport('./types.js').InterfaceSpec} InterfaceSpec */\n/** @template L,R @typedef {Ximport('@endo/eventual-send').RemotableBrand<L, R>} RemotableBrand */\n\nconst{quote:q,Fail}=assert;\n\nconst{prototype:functionPrototype}=Function;\nconst{\ngetPrototypeOf,\nsetPrototypeOf,\ncreate,\nisFrozen,\nprototype:objectPrototype}=\nObject;\n\n/**\n * Now that the remotableProto does not provide its own `toString` method,\n * ensure it always inherits from something. The original prototype of\n * `remotable` if there was one, or `Object.prototype` otherwise.\n *\n * @param {object} remotable\n * @param {InterfaceSpec} iface\n * @returns {object}\n */\nconst makeRemotableProto=(remotable,iface)=>{\nlet oldProto=getPrototypeOf(remotable);\nif(typeof remotable==='object'){\nif(oldProto===null){\noldProto=objectPrototype;\n }\noldProto===objectPrototype||\nFail `For now, remotables cannot inherit from anything unusual, in ${remotable}`;\n }else if(typeof remotable==='function'){\noldProto!==null||\nFail `Original function must not inherit from null: ${remotable}`;\noldProto===functionPrototype||\ngetPrototypeOf(oldProto)===functionPrototype||\nFail `Far functions must originally inherit from Function.prototype, in ${remotable}`;\n }else{\nFail `unrecognized typeof ${remotable}`;\n }\nreturn harden(\ncreate(oldProto,{\n[PASS_STYLE]:{value:'remotable'},\n[Symbol.toStringTag]:{value:iface}}));\n\n\n };\n\nconst assertCanBeRemotable=(candidate)=>\nRemotableHelper.canBeValid(candidate,assertChecker);\n\n/**\n * Create and register a Remotable.  After this, getInterfaceOf(remotable)\n * returns iface.\n *\n * // https://github.com/Agoric/agoric-sdk/issues/804\n *\n * @template {{}} T\n * @param {InterfaceSpec} [iface] The interface specification for\n * the remotable. For now, a string iface must be \"Remotable\" or begin with\n * \"Alleged: \" or \"DebugName: \", to serve as the alleged name. More\n * general ifaces are not yet implemented. This is temporary. We include the\n * \"Alleged\" or \"DebugName\" as a reminder that we do not yet have SwingSet\n * or Comms Vat\n * support for ensuring this is according to the vat hosting the object.\n * Currently, Alice can tell Bob about Carol, where VatA (on Alice's behalf)\n * misrepresents Carol's `iface`. VatB and therefore Bob will then see\n * Carol's `iface` as misrepresented by VatA.\n * @param {undefined} [props] Currently may only be undefined.\n * That plan is that own-properties are copied to the remotable\n * @param {T} [remotable] The object used as the remotable\n * @returns {T & RemotableBrand<{}, T>} remotable, modified for debuggability\n */\nconst        Remotable=(\niface='Remotable',\nprops=undefined,\nremotable=/** @type {T} */{})=>\n{\nassertIface(iface);\nassert(iface);\n/* TODO: When iface is richer than just string, we need to get the allegedName*/\n/* in a different way.*/\nprops===undefined||Fail `Remotable props not yet implemented ${props}`;\n\n/* Fail fast: check that the unmodified object is able to become a Remotable.*/\nassertCanBeRemotable(remotable);\n\n/* Ensure that the remotable isn't already marked.*/\n!(PASS_STYLE in remotable)||\nFail `Remotable ${remotable} is already marked as a ${q(\nremotable[PASS_STYLE])\n }`;\n/* `isFrozen` always returns true with a fake `harden`, but we want that case*/\n/* to succeed anyway. Faking `harden` is only correctness preserving*/\n/* if the code in question contains no bugs that the real `harden` would*/\n/* have caught.*/\n/* @ts-ignore `isFake` purposely not in the type*/\nharden.isFake||\n/* Ensure that the remotable isn't already frozen.*/\n!isFrozen(remotable)||\nFail `Remotable ${remotable} is already frozen`;\nconst remotableProto=makeRemotableProto(remotable,iface);\n\n/* Take a static copy of the enumerable own properties as data properties.*/\n/* const propDescs = getOwnPropertyDescriptors({ ...props });*/\nconst mutateHardenAndCheck=(target)=>{\n/* defineProperties(target, propDescs);*/\nsetPrototypeOf(target,remotableProto);\nharden(target);\nassertCanBeRemotable(target);\n };\n\n/* Fail fast: check a fresh remotable to see if our rules fit.*/\nmutateHardenAndCheck({});\n\n/* Actually finish the new remotable.*/\nmutateHardenAndCheck(remotable);\n\n/* COMMITTED!*/\n/* We're committed, so keep the interface for future reference.*/\nassert(iface!==undefined);/* To make TypeScript happy*/\nreturn (/** @type {T & RemotableBrand<{}, T>} */remotable);\n };$h‍_once.Remotable(Remotable);\nharden(Remotable);\n\n/**\n * A concise convenience for the most common `Remotable` use.\n *\n * @template {{}} T\n * @param {string} farName This name will be prepended with `Alleged: `\n * for now to form the `Remotable` `iface` argument.\n * @param {T} [remotable] The object used as the remotable\n */\nconst        Far=(farName,remotable=undefined)=>{\nconst r=remotable===undefined?/** @type {T} */{}:remotable;\nreturn Remotable( `Alleged: ${farName}`,undefined,r);\n };$h‍_once.Far(Far);\nharden(Far);\n\n/**\n * Coerce `func` to a far function that preserves its call behavior.\n * If it is already a far function, return it. Otherwise make and return a\n * new far function that wraps `func` and forwards calls to it. This\n * works even if `func` is already frozen. `ToFarFunction` is to be used\n * when the function comes from elsewhere under less control. For functions\n * you author in place, better to use `Far` on their function literal directly.\n *\n * @param {string} farName to be used only if `func` is not already a\n * far function.\n * @param {(...args: any[]) => any} func\n */\nconst        ToFarFunction=(farName,func)=>{\nif(getInterfaceOf(func)!==undefined){\nreturn func;\n }\nreturn Far(farName,(...args)=>func(...args));\n };$h‍_once.ToFarFunction(ToFarFunction);\nharden(ToFarFunction);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"Remotable":["Remotable"],"Far":["Far"],"ToFarFunction":["ToFarFunction"]},"__needsImportMeta__":false}