{"imports":[],"exports":["assertPassableSymbol","isPassableSymbol","nameForPassableSymbol","passableSymbolForName"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   $h‍_imports([]);   const{Fail,quote:q}=assert;\nconst{ownKeys}=Reflect;\n\n/**\n * The well known symbols are static symbol values on the `Symbol` constructor.\n */\nconst wellKnownSymbolNames=new Map(\nownKeys(Symbol).\nfilter(\n(name)=>typeof name==='string'&&typeof Symbol[name]==='symbol').\n\nfilter((name)=>{\n/* @ts-expect-error It doesn't know name cannot be a symbol*/\n!name.startsWith('@@')||\nFail `Did not expect Symbol to have a symbol-valued property name starting with \"@@\" ${q(\nname)\n }`;\nreturn true;\n })\n/* @ts-ignore It doesn't know name cannot be a symbol*/.\nmap((name)=>[Symbol[name], `@@${name}`]));\n\n\n/**\n * The passable symbols are the well known symbols (the symbol values\n * of static properties of the `Symbol` constructor) and the registered\n * symbols.\n *\n * @param {any} sym\n * @returns {boolean}\n */\nconst        isPassableSymbol=(sym)=>\ntypeof sym==='symbol'&&(\ntypeof Symbol.keyFor(sym)==='string'||wellKnownSymbolNames.has(sym));$h‍_once.isPassableSymbol(isPassableSymbol);\nharden(isPassableSymbol);\n\nconst        assertPassableSymbol=(sym)=>\nisPassableSymbol(sym)||\nFail `Only registered symbols or well-known symbols are passable: ${q(sym)}`;$h‍_once.assertPassableSymbol(assertPassableSymbol);\nharden(assertPassableSymbol);\n\n/**\n * If `sym` is a passable symbol, return a string that uniquely identifies this\n * symbol. If `sym` is a non-passable symbol, return `undefined`.\n *\n * The passable symbols are the well known symbols (the symbol values\n * of static properties of the `Symbol` constructor) and the registered\n * symbols. Since the registration string of a registered symbol can be any\n * string, if we simply used that to identify those symbols, there would not\n * be any remaining strings left over to identify the well-known symbols.\n * Instead, we reserve strings beginning with `\"@@\"` for purposes of this\n * encoding. We identify a well known symbol such as `Symbol.iterator`\n * by prefixing the property name with `\"@@\"`, such as `\"@@iterator\"`.\n * For registered symbols whose name happens to begin with `\"@@\"`, such\n * as `Symbol.for('@@iterator')` or `Symbol.for('@@foo')`, we identify\n * them by prefixing them with an extra `\"@@\"`, such as\n * `\"@@@@iterator\"` or `\"@@@@foo\"`. (This is the Hilbert Hotel encoding\n * technique.)\n *\n * @param {symbol} sym\n * @returns {string=}\n */\nconst        nameForPassableSymbol=(sym)=>{\nconst name=Symbol.keyFor(sym);\nif(name===undefined){\nreturn wellKnownSymbolNames.get(sym);\n }\nif(name.startsWith('@@')){\nreturn `@@${name}`;\n }\nreturn name;\n };$h‍_once.nameForPassableSymbol(nameForPassableSymbol);\nharden(nameForPassableSymbol);\n\nconst AtAtPrefixPattern=/^@@(.*)$/;\nharden(AtAtPrefixPattern);\n\n/**\n * If `name` is a string that could have been produced by\n * `nameForPassableSymbol`, return the symbol argument it was produced to\n * represent.\n *\n *    If `name` does not begin with `\"@@\"`, then just the corresponding\n *      registered symbol, `Symbol.for(name)`.\n *    If `name` is `\"@@\"` followed by a well known symbol's property name on\n *      `Symbol` such `\"@@iterator\", return that well known symbol such as\n *      `Symbol.iterator`\n *    If `name` begins with `\"@@@@\"` it encodes the registered symbol whose\n *      name begins with `\"@@\"` instead.\n *    Otherwise, if name begins with `\"@@\"` it may encode a registered symbol\n *      from a future version of JavaScript, but it is not one we can decode\n *      yet, so throw.\n *\n * @param {string} name\n * @returns {symbol=}\n */\nconst        passableSymbolForName=(name)=>{\nif(typeof name!=='string'){\nreturn undefined;\n }\nconst match=AtAtPrefixPattern.exec(name);\nif(match){\nconst suffix=match[1];\nif(suffix.startsWith('@@')){\nreturn Symbol.for(suffix);\n }else{\nconst sym=Symbol[suffix];\nif(typeof sym==='symbol'){\nreturn sym;\n }\nFail `Reserved for well known symbol ${q(suffix)}: ${q(name)}`;\n }\n }\nreturn Symbol.for(name);\n };$h‍_once.passableSymbolForName(passableSymbolForName);\nharden(passableSymbolForName);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"isPassableSymbol":["isPassableSymbol"],"assertPassableSymbol":["assertPassableSymbol"],"nameForPassableSymbol":["nameForPassableSymbol"],"passableSymbolForName":["passableSymbolForName"]},"__needsImportMeta__":false}