{"imports":["./passStyleOf.js"],"exports":["assertCopyArray","assertRecord","assertRemotable","isCopyArray","isRecord","isRemotable"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let passStyleOf;$h‍_imports([[\"./passStyleOf.js\", [[\"passStyleOf\", [$h‍_a => (passStyleOf = $h‍_a)]]]]]);   \n\n/** @typedef {Ximport('./types.js').Passable} Passable */\n/** @template T @typedef {Ximport('./types.js').CopyArray<T>} CopyArray */\n/** @template T @typedef {Ximport('./types.js').CopyRecord<T>} CopyRecord */\n/** @typedef {Ximport('./types.js').RemotableObject} Remotable */\n\nconst{Fail,quote:q}=assert;\n\n/**\n * Check whether the argument is a pass-by-copy array, AKA a \"copyArray\"\n * in @endo/marshal terms\n *\n * @param {Passable} arr\n * @returns {arr is CopyArray<any>}\n */\nconst isCopyArray=(arr)=>passStyleOf(arr)==='copyArray';$h‍_once.isCopyArray(isCopyArray);\nharden(isCopyArray);\n\n/**\n * Check whether the argument is a pass-by-copy record, AKA a\n * \"copyRecord\" in @endo/marshal terms\n *\n * @param {Passable} record\n * @returns {record is CopyRecord<any>}\n */\nconst isRecord=(record)=>passStyleOf(record)==='copyRecord';$h‍_once.isRecord(isRecord);\nharden(isRecord);\n\n/**\n * Check whether the argument is a remotable.\n *\n * @param {Passable} remotable\n * @returns {remotable is Remotable}\n */\nconst isRemotable=(remotable)=>passStyleOf(remotable)==='remotable';$h‍_once.isRemotable(isRemotable);\nharden(isRemotable);\n\n/**\n * @callback AssertArray\n * @param {Passable} array\n * @param {string=} optNameOfArray\n * @returns {asserts array is CopyArray<any>}\n */\n\n/** @type {AssertArray} */\nconst assertCopyArray=(array,optNameOfArray='Alleged array')=>{\nconst passStyle=passStyleOf(array);\npassStyle==='copyArray'||\nFail `${q(optNameOfArray)} ${array} must be a pass-by-copy array, not ${q(\npassStyle)\n }`;\n };$h‍_once.assertCopyArray(assertCopyArray);\nharden(assertCopyArray);\n\n/**\n * @callback AssertRecord\n * @param {Passable} record\n * @param {string=} optNameOfRecord\n * @returns {asserts record is CopyRecord<any>}\n */\n\n/** @type {AssertRecord} */\nconst assertRecord=(record,optNameOfRecord='Alleged record')=>{\nconst passStyle=passStyleOf(record);\npassStyle==='copyRecord'||\nFail `${q(optNameOfRecord)} ${record} must be a pass-by-copy record, not ${q(\npassStyle)\n }`;\n };$h‍_once.assertRecord(assertRecord);\nharden(assertRecord);\n\n/**\n * @callback AssertRemotable\n * @param {Passable} remotable\n * @param {string=} optNameOfRemotable\n * @returns {asserts remotable is Remotable}\n */\n\n/** @type {AssertRemotable} */\nconst assertRemotable=(\nremotable,\noptNameOfRemotable='Alleged remotable')=>\n{\nconst passStyle=passStyleOf(remotable);\npassStyle==='remotable'||\nFail `${q(optNameOfRemotable)} ${remotable} must be a remotable, not ${q(\npassStyle)\n }`;\n };$h‍_once.assertRemotable(assertRemotable);\nharden(assertRemotable);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"isCopyArray":["isCopyArray"],"isRecord":["isRecord"],"isRemotable":["isRemotable"],"assertCopyArray":["assertCopyArray"],"assertRecord":["assertRecord"],"assertRemotable":["assertRemotable"]},"__needsImportMeta__":false}