{"imports":["@endo/eventual-send","@endo/promise-kit"],"exports":["applyLabelingError","fromUniqueEntries","identChecker","listDifference","objectMap","throwLabeled"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let E,isPromise;$h‍_imports([[\"@endo/eventual-send\", [[\"E\", [$h‍_a => (E = $h‍_a)]]]],[\"@endo/promise-kit\", [[\"isPromise\", [$h‍_a => (isPromise = $h‍_a)]]]]]);   \n\n\n\n/** @typedef {Ximport('@endo/marshal').Checker} Checker */\n\nconst{fromEntries,entries}=Object;\nconst{ownKeys}=Reflect;\n\nconst{details:X,quote:q,Fail}=assert;\n\n/* TODO migrate to proper home*/\n/* From the `agoric-sdk` monorepo. Moved here temporarily because the pattern*/\n/* code is migrated from `@agoric/store` to `@endo/patterns`, and depends on*/\n/* the functionality in this file, which is otherwise available only*/\n/* within the `agoric-sdk` monorepo.*/\n\n/**\n * TODO as long as `@endo/pass-style` remains the proper home of the\n * `Checker` type, it probably makes most sense to move `identChecker`\n * into `@endo/pass-style` as well.\n *\n * In the `assertFoo`/`isFoo`/`checkFoo` pattern, `checkFoo` has a `check`\n * parameter of type `Checker`. `assertFoo` calls `checkFoo` passes\n * `assertChecker` as the `check` argument. `isFoo` passes `identChecker`\n * as the `check` argument. `identChecker` acts precisely like an\n * identity function, but is typed as a `Checker` to indicate its\n * intended use.\n *\n * @type {Checker}\n */\nconst        identChecker=(cond,_details)=>cond;$h‍_once.identChecker(identChecker);\nharden(identChecker);\n\n/**\n * Throws if multiple entries use the same property name. Otherwise acts\n * like `Object.fromEntries` but hardens the result.\n * Use it to protect from property names computed from user-provided data.\n *\n * @template K,V\n * @param {Iterable<[K,V]>} allEntries\n * @returns {{[k: K]: V}}\n */\nconst        fromUniqueEntries=(allEntries)=>{\nconst entriesArray=[...allEntries];\nconst result=harden(fromEntries(entriesArray));\nif(ownKeys(result).length===entriesArray.length){\nreturn result;\n }\nconst names=new Set();\nfor(const[name,_]of entriesArray){\nif(names.has(name)){\nFail `collision on property name ${q(name)}: ${entriesArray}`;\n }\nnames.add(name);\n }\nthrow Fail `internal: failed to create object from unique entries`;\n };$h‍_once.fromUniqueEntries(fromUniqueEntries);\nharden(fromUniqueEntries);\n\n/**\n * By analogy with how `Array.prototype.map` will map the elements of\n * an array to transformed elements of an array of the same shape,\n * `objectMap` will do likewise for the string-named own enumerable\n * properties of an object.\n *\n * Typical usage applies `objectMap` to a CopyRecord, i.e.,\n * an object for which `passStyleOf(original) === 'copyRecord'`. For these,\n * none of the following edge cases arise. The result will be a CopyRecord\n * with exactly the same property names, whose values are the mapped form of\n * the original's values.\n *\n * When the original is not a CopyRecord, some edge cases to be aware of\n *    * No matter how mutable the original object, the returned object is\n *      hardened.\n *    * Only the string-named enumerable own properties of the original\n *      are mapped. All other properties are ignored.\n *    * If any of the original properties were accessors, `Object.entries`\n *      will cause its `getter` to be called and will use the resulting\n *      value.\n *    * No matter whether the original property was an accessor, writable,\n *      or configurable, all the properties of the returned object will be\n *      non-writable, non-configurable, data properties.\n *    * No matter what the original object may have inherited from, and\n *      no matter whether it was a special kind of object such as an array,\n *      the returned object will always be a plain object inheriting directly\n *      from `Object.prototype` and whose state is only these new mapped\n *      own properties.\n *\n * With these differences, even if the original object was not a CopyRecord,\n * if all the mapped values are Passable, then the returned object will be\n * a CopyRecord.\n *\n * @template {Record<string, any>} O\n * @param {O} original\n * @template R map result\n * @param {(value: O[keyof O], key: keyof O) => R} mapFn\n * @returns {{ [P in keyof O]: R}}\n */\nconst        objectMap=(original,mapFn)=>{\nconst ents=entries(original);\nconst mapEnts=ents.map(([k,v])=>[k,mapFn(v,k)]);\nreturn harden(fromEntries(mapEnts));\n };$h‍_once.objectMap(objectMap);\nharden(objectMap);\n\n/**\n *\n * @param {Array<string | symbol>} leftNames\n * @param {Array<string | symbol>} rightNames\n */\nconst        listDifference=(leftNames,rightNames)=>{\nconst rightSet=new Set(rightNames);\nreturn leftNames.filter((name)=>!rightSet.has(name));\n };$h‍_once.listDifference(listDifference);\nharden(listDifference);\n\n/**\n * @param {Error} innerErr\n * @param {string|number} label\n * @param {ErrorConstructor=} ErrorConstructor\n * @returns {never}\n */\n\n/* Evade https://github.com/endojs/endo/issues/1450 using blank line*/\nconst        throwLabeled=(innerErr,label,ErrorConstructor=undefined)=>{\nif(typeof label==='number'){\nlabel= `[${label}]`;\n }\nconst outerErr=assert.error(\n `${label}: ${innerErr.message}`,\nErrorConstructor);\n\nassert.note(outerErr,X `Caused by ${innerErr}`);\nthrow outerErr;\n };$h‍_once.throwLabeled(throwLabeled);\nharden(throwLabeled);\n\n/**\n * @template A,R\n * @param {(...args: A[]) => R} func\n * @param {A[]} args\n * @param {string|number} [label]\n * @returns {R}\n */\nconst        applyLabelingError=(func,args,label=undefined)=>{\nif(label===undefined){\nreturn func(...args);\n }\nlet result;\ntry{\nresult=func(...args);\n }catch(err){\nthrowLabeled(err,label);\n }\nif(isPromise(result)){\n/* @ts-expect-error If result is a rejected promise, this will*/\n/* return a promise with a different rejection reason. But this*/\n/* confuses TypeScript because it types that case as `Promise<never>`*/\n/* which is cool for a promise that will never fulfll.*/\n/* But TypeScript doesn't understand that this will only happen*/\n/* when `result` was a rejected promise. In only this case `R`*/\n/* should already allow `Promise<never>` as a subtype.*/\nreturn E.when(result,undefined,(reason)=>throwLabeled(reason,label));\n }else{\nreturn result;\n }\n };$h‍_once.applyLabelingError(applyLabelingError);\nharden(applyLabelingError);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"identChecker":["identChecker"],"fromUniqueEntries":["fromUniqueEntries"],"objectMap":["objectMap"],"listDifference":["listDifference"],"throwLabeled":["throwLabeled"],"applyLabelingError":["applyLabelingError"]},"__needsImportMeta__":false}