{"imports":["@endo/marshal","./copyBag.js"],"exports":["bagCompare","bagDisjointSubtract","bagIntersection","bagIsDisjoint","bagIsSuperbag","bagUnion"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let assertRankSorted,compareAntiRank,makeFullOrderComparatorKit,sortByRank,assertNoDuplicateKeys,makeBagOfEntries;$h‍_imports([[\"@endo/marshal\", [[\"assertRankSorted\", [$h‍_a => (assertRankSorted = $h‍_a)]],[\"compareAntiRank\", [$h‍_a => (compareAntiRank = $h‍_a)]],[\"makeFullOrderComparatorKit\", [$h‍_a => (makeFullOrderComparatorKit = $h‍_a)]],[\"sortByRank\", [$h‍_a => (sortByRank = $h‍_a)]]]],[\"./copyBag.js\", [[\"assertNoDuplicateKeys\", [$h‍_a => (assertNoDuplicateKeys = $h‍_a)]],[\"makeBagOfEntries\", [$h‍_a => (makeBagOfEntries = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\nconst{quote:q,Fail}=assert;\n\n/** @typedef {Ximport('../types').KeyComparison} KeyComparison */\n/** @typedef {Ximport('../types').FullCompare} FullCompare */\n/** @typedef {Ximport('@endo/marshal').RankCompare} RankCompare */\n\n/* Based on merge-set-operators.js, but altered for the bag representation.*/\n/* TODO share more code with merge-set-operators.js, rather than*/\n/* duplicating with changes.*/\n\n/**\n * Asserts that `bagEntries` is already rank sorted by `rankCompare`, where\n * there\n * may be contiguous regions of bagEntries whose keys are tied for the same\n * rank.\n * Returns an iterable that will enumerate all the bagEntries in order\n * according to `fullOrder`, which should differ from `rankOrder` only\n * by being more precise.\n *\n * This should be equivalent to resorting the entire `bagEntries` array\n * according\n * to `fullOrder`. However, it optimizes for the case where these contiguous\n * runs that need to be resorted are either absent or small.\n *\n * @template T\n * @param {[T,bigint][]} bagEntries\n * @param {RankCompare} rankCompare\n * @param {FullCompare} fullCompare\n * @returns {Iterable<[T,bigint]>}\n */\nconst bagWindowResort=(bagEntries,rankCompare,fullCompare)=>{\nassertRankSorted(bagEntries,rankCompare);\nconst{length}=bagEntries;\nlet i=0;\nlet optInnerIterator;\nreturn harden({\n[Symbol.iterator]:()=>\nharden({\nnext:()=>{\nif(optInnerIterator){\nconst result=optInnerIterator.next();\nif(result.done){\noptInnerIterator=undefined;\n/* fall through*/\n }else{\nreturn result;\n }\n }\nif(i<length){\nconst entry=bagEntries[i];\nlet j=i+1;\nwhile(\nj<length&&\nrankCompare(entry[0],bagEntries[j][0])===0)\n{\nj+=1;\n }\nif(j===i+1){\ni=j;\nreturn harden({done:false,value:entry});\n }\nconst similarRun=bagEntries.slice(i,j);\ni=j;\nconst resorted=sortByRank(similarRun,fullCompare);\n/* Providing the same `fullCompare` should cause a memo hit*/\n/* within `assertNoDuplicates` enabling it to avoid a*/\n/* redundant resorting.*/\nassertNoDuplicateKeys(resorted,fullCompare);\n/* This is the raw JS array iterator whose `.next()` method*/\n/* does not harden the IteratorResult, in violation of our*/\n/* conventions. Fixing this is expensive and I'm confident the*/\n/* unfrozen value does not escape this file, so I'm leaving this*/\n/* as is.*/\noptInnerIterator=resorted[Symbol.iterator]();\nreturn optInnerIterator.next();\n }else{\nreturn harden({done:true,value:[null,0n]});\n }\n }})});\n\n\n };\n\n/**\n * Returns an iterable whose iteration results are [key, xCount, yCount] tuples\n * representing the next key in the local full order, as well as how many\n * times it occurred in the x input iterator and the y input iterator.\n *\n * For sets, these counts are always 0 or 1, but this representation\n * generalizes nicely for bags.\n *\n * @template T\n * @param {[T,bigint][]} xbagEntries\n * @param {[T,bigint][]} ybagEntries\n * @returns {Iterable<[T,bigint,bigint]>}\n */\nconst merge=(xbagEntries,ybagEntries)=>{\n/* This fullOrder contains history dependent state. It is specific*/\n/* to this one `merge` call and does not survive it.*/\nconst fullCompare=makeFullOrderComparatorKit().antiComparator;\n\nconst xs=bagWindowResort(xbagEntries,compareAntiRank,fullCompare);\nconst ys=bagWindowResort(ybagEntries,compareAntiRank,fullCompare);\nreturn harden({\n[Symbol.iterator]:()=>{\n/* These six `let` variables are buffering one ahead from the underlying*/\n/* iterators. Each iteration reports one or the other or both, and*/\n/* then refills the buffers of those it advanced.*/\n/** @type {T} */\nlet x;\nlet xc;\nlet xDone;\n/** @type {T} */\nlet y;\nlet yc;\nlet yDone;\n\nconst xi=xs[Symbol.iterator]();\nconst nextX=()=>{\n!xDone||Fail `Internal: nextX should not be called once done`;\n({\ndone:xDone,\nvalue:[x,xc]}=\nxi.next());\n };\nnextX();\n\nconst yi=ys[Symbol.iterator]();\nconst nextY=()=>{\n!yDone||Fail `Internal: nextY should not be called once done`;\n({\ndone:yDone,\nvalue:[y,yc]}=\nyi.next());\n };\nnextY();\n\nreturn harden({\nnext:()=>{\n/** @type {boolean} */\nlet done=false;\n/** @type {[T,bigint,bigint]} */\nlet value;\nif(xDone&&yDone){\ndone=true;\n/* @ts-expect-error Because the terminating value does not matter*/\nvalue=[null,0n,0n];\n }else if(xDone){\n/* only ys are left*/\nvalue=[y,0n,yc];\nnextY();\n }else if(yDone){\n/* only xs are left*/\nvalue=[x,xc,0n];\nnextX();\n }else{\nconst comp=fullCompare(x,y);\nif(comp===0){\n/* x and y are equivalent, so report both*/\nvalue=[x,xc,yc];\nnextX();\nnextY();\n }else if(comp<0){\n/* x is earlier, so report it*/\nvalue=[x,xc,0n];\nnextX();\n }else{\n/* y is earlier, so report it*/\ncomp>0||Fail `Internal: Unexpected comp ${q(comp)}`;\nvalue=[y,0n,yc];\nnextY();\n }\n }\nreturn harden({done,value});\n }});\n\n }});\n\n };\nharden(merge);\n\n/* We should be able to use this for iterIsSuperset as well.*/\n/* The generalization is free.*/\n/**\n * @template T\n * @param {Iterable<[T,bigint,bigint]>} xyi\n * @returns {boolean}\n */\nconst bagIterIsSuperbag=(xyi)=>{\nfor(const[_m,xc,yc]of xyi){\nif(xc<yc){\n/* something in y is not in x, so x is not a superbag of y*/\nreturn false;\n }\n }\nreturn true;\n };\n\n/* We should be able to use this for iterIsDisjoint as well.*/\n/* The code is identical.*/\n/**\n * @template T\n * @param {Iterable<[T,bigint,bigint]>} xyi\n * @returns {boolean}\n */\nconst bagIterIsDisjoint=(xyi)=>{\nfor(const[_m,xc,yc]of xyi){\nif(xc>=1n&&yc>=1n){\n/* Something in both, so not disjoint*/\nreturn false;\n }\n }\nreturn true;\n };\n\n/* We should be able to use this for iterCompare as well.*/\n/* The generalization is free.*/\n/**\n * @template T\n * @param {Iterable<[T,bigint,bigint]>} xyi\n * @returns {KeyComparison}\n */\nconst bagIterCompare=(xyi)=>{\nlet loneY=false;\nlet loneX=false;\nfor(const[_m,xc,yc]of xyi){\nif(xc<yc){\n/* something in y is not in x, so x is not a superbag of y*/\nloneY=true;\n }\nif(xc>yc){\n/* something in x is not in y, so y is not a superbag of x*/\nloneX=true;\n }\nif(loneX&&loneY){\nreturn NaN;\n }\n }\nif(loneX){\nreturn 1;\n }else if(loneY){\nreturn-1;\n }else{\n!loneX&&!loneY||\nFail `Internal: Unexpected lone pair ${q([loneX,loneY])}`;\nreturn 0;\n }\n };\n\n/**\n * @template T\n * @param {[T,bigint,bigint][]} xyi\n * @returns {[T,bigint][]}\n */\nconst bagIterUnion=(xyi)=>{\n/** @type {[T,bigint][]} */\nconst result=[];\nfor(const[m,xc,yc]of xyi){\nresult.push([m,xc+yc]);\n }\nreturn result;\n };\n\n/**\n * @template T\n * @param {Iterable<[T,bigint,bigint]>} xyi\n * @returns {[T,bigint][]}\n */\nconst bagIterIntersection=(xyi)=>{\n/** @type {[T,bigint][]} */\nconst result=[];\nfor(const[m,xc,yc]of xyi){\nconst mc=xc<=yc?xc:yc;\nresult.push([m,mc]);\n }\nreturn result;\n };\n\n/**\n * @template T\n * @param {Iterable<[T,bigint,bigint]>} xyi\n * @returns {[T,bigint][]}\n */\nconst bagIterDisjointSubtract=(xyi)=>{\n/** @type {[T,bigint][]} */\nconst result=[];\nfor(const[m,xc,yc]of xyi){\nconst mc=xc-yc;\nmc>=0n||Fail `right element ${m} was not in left`;\nif(mc>=1n){\n/* the x was not in y*/\nresult.push([m,mc]);\n }\n }\nreturn result;\n };\n\nconst mergeify=(bagIterOp)=>(xbagEntries,ybagEntries)=>\nbagIterOp(merge(xbagEntries,ybagEntries));\n\nconst bagEntriesIsSuperbag=mergeify(bagIterIsSuperbag);\nconst bagEntriesIsDisjoint=mergeify(bagIterIsDisjoint);\nconst bagEntriesCompare=mergeify(bagIterCompare);\nconst bagEntriesUnion=mergeify(bagIterUnion);\nconst bagEntriesIntersection=mergeify(bagIterIntersection);\nconst bagEntriesDisjointSubtract=mergeify(bagIterDisjointSubtract);\n\nconst rawBagify=(bagEntriesOp)=>(xbag,ybag)=>\nbagEntriesOp(xbag.payload,ybag.payload);\n\nconst bagify=(bagEntriesOp)=>(xbag,ybag)=>\nmakeBagOfEntries(bagEntriesOp(xbag.payload,ybag.payload));\n\nconst        bagIsSuperbag=rawBagify(bagEntriesIsSuperbag);$h‍_once.bagIsSuperbag(bagIsSuperbag);\nconst        bagIsDisjoint=rawBagify(bagEntriesIsDisjoint);$h‍_once.bagIsDisjoint(bagIsDisjoint);\nconst        bagCompare=rawBagify(bagEntriesCompare);$h‍_once.bagCompare(bagCompare);\nconst        bagUnion=bagify(bagEntriesUnion);$h‍_once.bagUnion(bagUnion);\nconst        bagIntersection=bagify(bagEntriesIntersection);$h‍_once.bagIntersection(bagIntersection);\nconst        bagDisjointSubtract=bagify(bagEntriesDisjointSubtract);$h‍_once.bagDisjointSubtract(bagDisjointSubtract);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"bagIsSuperbag":["bagIsSuperbag"],"bagIsDisjoint":["bagIsDisjoint"],"bagCompare":["bagCompare"],"bagUnion":["bagUnion"],"bagIntersection":["bagIntersection"],"bagDisjointSubtract":["bagDisjointSubtract"]},"__needsImportMeta__":false}