{"imports":["@endo/marshal","../utils.js"],"exports":["generateCollectionPairEntries","makeCompareCollection"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let assertRankSorted,compareAntiRank,makeFullOrderComparatorKit,sortByRank,makeIterator,makeArrayIterator;$h‍_imports([[\"@endo/marshal\", [[\"assertRankSorted\", [$h‍_a => (assertRankSorted = $h‍_a)]],[\"compareAntiRank\", [$h‍_a => (compareAntiRank = $h‍_a)]],[\"makeFullOrderComparatorKit\", [$h‍_a => (makeFullOrderComparatorKit = $h‍_a)]],[\"sortByRank\", [$h‍_a => (sortByRank = $h‍_a)]]]],[\"../utils.js\", [[\"makeIterator\", [$h‍_a => (makeIterator = $h‍_a)]],[\"makeArrayIterator\", [$h‍_a => (makeArrayIterator = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\n\n/** @typedef {Ximport('@endo/marshal').RankCompare} RankCompare */\n/** @typedef {Ximport('../types').KeyComparison} KeyComparison */\n/** @typedef {Ximport('../types').KeyCompare} KeyCompare */\n/** @typedef {Ximport('../types').FullCompare} FullCompare */\n/** @typedef {Ximport('../types').KeyCollection} KeyCollection */\n\nconst{quote:q,Fail}=assert;\n\n/**\n * Refines a sequence of entries that is already sorted over its keys by the\n * `rankCompare` preorder, where there may be internal runs tied for the same\n * rank, into an iterable that resolves those ties using `fullCompare`.\n *\n * @template [V=unknown]\n * @param {Array<[Key, V]>} entries\n * @param {RankCompare} rankCompare\n * @param {FullCompare} fullCompare\n * @returns {IterableIterator<[Key, V]>}\n */\nconst generateFullSortedEntries=(entries,rankCompare,fullCompare)=>{\nassertRankSorted(entries,rankCompare);\nconst{length}=entries;\nlet i=0;\nlet sameRankIterator;\nreturn makeIterator(()=>{\nif(sameRankIterator){\nconst result=sameRankIterator.next();\nif(!result.done){\nreturn result;\n }\nsameRankIterator=undefined;\n }\nif(i<length){\nconst entry=entries[i];\n/* Look ahead for same-rank ties.*/\nlet j=i+1;\nwhile(j<length&&rankCompare(entry[0],entries[j][0])===0){\nj+=1;\n }\nif(j===i+1){\n/* No ties found.*/\ni=j;\nreturn harden({done:false,value:entry});\n }\nconst ties=entries.slice(i,j);\ni=j;\n\n/* Sort the ties by `fullCompare`, enforce key uniqueness, and delegate to*/\n/* a sub-iterator.*/\nconst sortedTies=sortByRank(ties,fullCompare);\nfor(let k=1;k<sortedTies.length;k+=1){\nconst[key0]=sortedTies[k-1];\nconst[key1]=sortedTies[k];\nMath.sign(fullCompare(key0,key1))||\nFail `Duplicate entry key: ${key0}`;\n }\nsameRankIterator=makeArrayIterator(sortedTies);\nreturn sameRankIterator.next();\n }\nreturn harden({done:true,value:undefined});\n });\n };\nharden(generateFullSortedEntries);\n\n/**\n * Returns an iterator that merges reverse-rank-sorted [key, value] entries of\n * two KeyCollections into a reverse-full-sorted [key, value1, value2] entries\n * by the key they have in common, representing the value for an absent entry in\n * either collection as `absentValue`.\n *\n * @template [C=KeyCollection]\n * @template [V=unknown]\n * @param {C} c1\n * @param {C} c2\n * @param {(collection: C) => Array<[Key, V]>} getEntries\n * @param {any} absentValue\n * @returns {IterableIterator<[Key, V | absentValue, V | absentValue]>}\n */\nconst        generateCollectionPairEntries=(\nc1,\nc2,\ngetEntries,\nabsentValue)=>\n{\nconst e1=getEntries(c1);\nconst e2=getEntries(c2);\n\n/* Establish a history-dependent comparison scoped to the active invocation*/\n/* and use it to map reverse-preordered entries into an iterator with a*/\n/* narrower total order.*/\nconst fullCompare=makeFullOrderComparatorKit().antiComparator;\nconst x=generateFullSortedEntries(e1,compareAntiRank,fullCompare);\nconst y=generateFullSortedEntries(e2,compareAntiRank,fullCompare);\n\n/* Maintain a single-result { done, key, value } buffer for each iterator*/\n/* so they can be merged.*/\nlet xDone;\nlet xKey;\nlet xValue;\nlet yDone;\nlet yKey;\nlet yValue;\nconst nonEntry=[undefined,undefined];\nconst nextX=()=>{\n!xDone||Fail `Internal: nextX must not be called once done`;\nconst result=xValue;\n({done:xDone,value:[xKey,xValue]=nonEntry}=x.next());\nreturn result;\n };\nnextX();\nconst nextY=()=>{\n!yDone||Fail `Internal: nextY must not be called once done`;\nconst result=yValue;\n({done:yDone,value:[yKey,yValue]=nonEntry}=y.next());\nreturn result;\n };\nnextY();\nreturn makeIterator(()=>{\nlet done=false;\n/** @type {[Key, V | absentValue, V | absentValue]} */\nlet value;\nif(xDone&&yDone){\ndone=true;\nvalue=[undefined,absentValue,absentValue];\n }else if(xDone){\nvalue=[yKey,absentValue,nextY()];\n }else if(yDone){\nvalue=[xKey,nextX(),absentValue];\n }else{\n/* Compare the keys to determine if we should return a merged result*/\n/* or a one-sided result.*/\nconst comp=fullCompare(xKey,yKey);\nif(comp===0){\nvalue=[xKey,nextX(),nextY()];\n }else if(comp<0){\nvalue=[xKey,nextX(),absentValue];\n }else if(comp>0){\nvalue=[yKey,absentValue,nextY()];\n }else{\nthrow Fail `Unexpected key comparison ${q(comp)} for ${xKey} vs ${yKey}`;\n }\n }\nreturn harden({done,value});\n });\n };$h‍_once.generateCollectionPairEntries(generateCollectionPairEntries);\nharden(generateCollectionPairEntries);\n\n/**\n * Returns a function for comparing two KeyCollections of the same type using\n * the provided entries factory and same-key entry value comparator (where the\n * value for an absent entry in one collection is `absentValue`).\n *\n * If the corresponding entries for any single key are incomparable or the\n * comparison result has the opposite sign of the result for a different key,\n * then the KeyCollections are incomparable. Otherwise, the collections compare\n * by the result of any non-equal entry comparison, or compare equal if there is\n * no non-equal entry comparison result.\n * For example, given CopyBags X and Y and a value comparator that goes by count\n * (defaulting absent keys to a count of 0), X is smaller than Y (`result < 0`)\n * iff there are no keys in X that are either absent from Y\n * (`compareValues(xCount, absentValue) > 0`) or present in Y with a lower count\n * (`compareValues(xCount, yCount) > 0`) AND there is at least one key in Y that\n * is either absent from X (`compareValues(absentValue, yCount) < 0`) or present\n * with a lower count (`compareValues(xCount, yCount) < 0`).\n *\n * This can be generalized to virtual collections in the future by replacing\n * `getEntries => Array` with `generateEntries => IterableIterator`.\n *\n * @template [C=KeyCollection]\n * @template [V=unknown]\n * @param {(collection: C) => Array<[Key, V]>} getEntries\n * @param {any} absentValue\n * @param {KeyCompare} compareValues\n * @returns {(left: C, right: C) => KeyComparison}\n */\nconst        makeCompareCollection=(getEntries,absentValue,compareValues)=>\nharden((left,right)=>{\nconst merged=generateCollectionPairEntries(\nleft,\nright,\ngetEntries,\nabsentValue);\n\nlet leftIsBigger=false;\nlet rightIsBigger=false;\nfor(const[_key,leftValue,rightValue]of merged){\nconst comp=compareValues(leftValue,rightValue);\nif(comp===0){\n/* eslint-disable-next-line no-continue*/\ncontinue;\n }else if(comp<0){\n/* Based on this key, left < right.*/\nrightIsBigger=true;\n }else if(comp>0){\n/* Based on this key, left > right.*/\nleftIsBigger=true;\n }else{\nNumber.isNaN(comp)||\n/* prettier-ignore*/\nFail `Unexpected value comparison ${q(comp)} for ${leftValue} vs ${rightValue}`;\nreturn NaN;\n }\nif(leftIsBigger&&rightIsBigger){\nreturn NaN;\n }\n }\n/* eslint-disable-next-line no-nested-ternary*/\nreturn leftIsBigger?1:rightIsBigger?-1:0;\n });$h‍_once.makeCompareCollection(makeCompareCollection);\nharden(makeCompareCollection);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"generateCollectionPairEntries":["generateCollectionPairEntries"],"makeCompareCollection":["makeCompareCollection"]},"__needsImportMeta__":false}