{"imports":[],"exports":["makeReleasingExecutorKit"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   $h‍_imports([]);   /*/ <reference types=\"ses\"/>*/\n\n/**\n * @template T\n * @callback PromiseExecutor The promise executor\n * @param {(value: Ximport('./types.js').ERef<T>) => void} resolve\n * @param {(reason: any) => void} reject\n */\n\n/**\n * makeReleasingExecutorKit() builds resolve/reject functions which drop references\n * to the resolve/reject functions gathered from an executor to be used with a\n * promise constructor.\n *\n * @template T\n * @returns {Pick<Ximport('./types.js').PromiseKit<T>, 'resolve' | 'reject'> & { executor: PromiseExecutor<T>}}\n */\nconst        makeReleasingExecutorKit=()=>{\n/** @type {null | undefined | ((value: Ximport('./types.js').ERef<T>) => void)} */\nlet internalResolve;\n/** @type {null | undefined | ((reason: unknown) => void)} */\nlet internalReject;\n\n/** @param {Ximport('./types.js').ERef<T>} value */\nconst resolve=(value)=>{\nif(internalResolve){\ninternalResolve(value);\ninternalResolve=null;\ninternalReject=null;\n }else{\nassert(internalResolve===null);\n }\n };\n\n/** @param {unknown} reason */\nconst reject=(reason)=>{\nif(internalReject){\ninternalReject(reason);\ninternalResolve=null;\ninternalReject=null;\n }else{\nassert(internalReject===null);\n }\n };\n\nconst executor=(res,rej)=>{\nassert(internalResolve===undefined&&internalReject===undefined);\ninternalResolve=res;\ninternalReject=rej;\n };\n\nreturn harden({resolve,reject,executor});\n };$h‍_once.makeReleasingExecutorKit(makeReleasingExecutorKit);\nharden(makeReleasingExecutorKit);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"makeReleasingExecutorKit":["makeReleasingExecutorKit"]},"__needsImportMeta__":false}