{"imports":[],"exports":["memoRace"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   $h‍_imports([]);   /* Initial version authored by Brian Kim:\nhttps://github.com/nodejs/node/issues/17469#issuecomment-685216777\n This is free and unencumbered software released into the public domain.\n Anyone is free to copy, modify, publish, use, compile, sell, or\ndistribute this software, either in source code form or as a compiled\nbinary, for any purpose, commercial or non-commercial, and by any\nmeans.\n In jurisdictions that recognize copyright laws, the author or authors\nof this software dedicate any and all copyright interest in the\nsoftware to the public domain. We make this dedication for the benefit\nof the public at large and to the detriment of our heirs and\nsuccessors. We intend this dedication to be an overt act of\nrelinquishment in perpetuity of all present and future rights to this\nsoftware under copyright law.\n THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\nIN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR\nOTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,\nARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR\nOTHER DEALINGS IN THE SOFTWARE.\n For more information, please refer to <http://unlicense.org/>\n*/\n\n\n\n\n\n\n\nconst isObject=(value)=>Object(value)===value;\n\n/**\n * @template [T=any]\n * @typedef {object} Deferred\n * @property {(value?: Ximport(\"./types.js\").ERef<T> ) => void} resolve\n * @property {(err?: any ) => void} reject\n */\n\n/**\n * @typedef { never\n *  | {settled: false, deferreds: Set<Deferred>}\n *  | {settled: true, deferreds?: undefined}\n * } PromiseMemoRecord\n */\n\n/* Keys are the values passed to race, values are a record of data containing a*/\n/* set of deferreds and whether the value has settled.*/\n/** @type {WeakMap<object, PromiseMemoRecord>} */\nconst knownPromises=new WeakMap();\n\n/**\n * @param {PromiseMemoRecord | undefined} record\n * @returns {Set<Deferred>}\n */\nconst markSettled=(record)=>{\nif(!record||record.settled){\nreturn new Set();\n }\n\nconst{deferreds}=record;\nObject.assign(record,{\ndeferreds:undefined,\nsettled:true});\n\nObject.freeze(record);\nreturn deferreds;\n };\n\n/**\n *\n * @param {any} value\n * @returns {PromiseMemoRecord}\n */\nconst getMemoRecord=(value)=>{\nif(!isObject(value)){\n/* If the contender is a primitive, attempting to use it as a key in the*/\n/* weakmap would throw an error. Luckily, it is safe to call*/\n/* `Promise.resolve(contender).then` on a primitive value multiple times*/\n/* because the promise fulfills immediately. So we fake a settled record.*/\nreturn harden({settled:true});\n }\n\nlet record=knownPromises.get(value);\n\nif(!record){\nrecord={deferreds:new Set(),settled:false};\nknownPromises.set(value,record);\n/* This call to `then` happens once for the lifetime of the value.*/\nPromise.resolve(value).then(\n(val)=>{\nfor(const{resolve}of markSettled(record)){\nresolve(val);\n }\n },\n(err)=>{\nfor(const{reject}of markSettled(record)){\nreject(err);\n }\n });\n\n }\nreturn record;\n };\n\nconst{race}={\n/**\n * Creates a Promise that is resolved or rejected when any of the provided Promises are resolved\n * or rejected.\n *\n * Unlike `Promise.race` it cleans up after itself so a non-resolved value doesn't hold onto\n * the result promise.\n *\n * @template T\n * @template {PromiseConstructor} [P=PromiseConstructor]\n * @this {P}\n * @param {Iterable<T>} values An iterable of Promises.\n * @returns {Promise<Awaited<T>>} A new Promise.\n */\nrace(values){\nlet deferred;\n/** @type {T[]} */\nconst cachedValues=[];\nconst C=this;\nconst result=new C((resolve,reject)=>{\ndeferred={resolve,reject};\nfor(const value of values){\ncachedValues.push(value);\nconst{settled,deferreds}=getMemoRecord(value);\nif(settled){\n/* If the contender is settled (including primitives), it is safe*/\n/* to call `Promise.resolve(value).then` on it.*/\nC.resolve(value).then(resolve,reject);\n }else{\ndeferreds.add(deferred);\n }\n }\n });\n\n/* The finally callback executes when any value settles, preventing any of*/\n/* the unresolved values from retaining a reference to the resolved value.*/\nreturn result.finally(()=>{\nfor(const value of cachedValues){\nconst{deferreds}=getMemoRecord(value);\nif(deferreds){\ndeferreds.delete(deferred);\n }\n }\n });\n }};$h‍_once.race(race);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"memoRace":["race"]},"__needsImportMeta__":false}