{"imports":["@endo/eventual-send","@endo/promise-kit"],"exports":["makePipe","makeQueue","makeStream","mapReader","mapWriter","prime","pump"],"reexports":[],"__syncModuleProgram__":"(({   imports: $h‍_imports,   liveVar: $h‍_live,   onceVar: $h‍_once,   importMeta: $h‍____meta,  }) => {   let E,makePromiseKit;$h‍_imports([[\"@endo/eventual-send\", [[\"E\", [$h‍_a => (E = $h‍_a)]]]],[\"@endo/promise-kit\", [[\"makePromiseKit\", [$h‍_a => (makePromiseKit = $h‍_a)]]]]]);   \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n/**\n * @template T\n * @typedef {{\n *   resolve(value?: T | Promise<T>): void,\n *   reject(error: Error): void,\n *   promise: Promise<T>\n * }} PromiseKit\n */\n\n/* TypeScript ReadOnly semantics are not sufficiently expressive to distinguish*/\n/* a value one promises not to alter from a value one must not alter,*/\n/* making it useless.*/\nconst freeze=/** @type {<T>(v: T | Readonly<T>) => T} */Object.freeze;\n\n/**\n * @template T\n * @returns {Ximport('./types.js').AsyncQueue<T>}\n */\nconst        makeQueue=()=>{\nlet{promise:tailPromise,resolve:tailResolve}=makePromiseKit();\nreturn{\nput(value){\nconst{resolve,promise}=makePromiseKit();\ntailResolve(freeze({value,promise}));\ntailResolve=resolve;\n },\nget(){\nconst promise=tailPromise.then((next)=>next.value);\ntailPromise=tailPromise.then((next)=>next.promise);\nreturn harden(promise);\n }};\n\n };$h‍_once.makeQueue(makeQueue);\nharden(makeQueue);\n\n/**\n * @template TRead\n * @template TWrite\n * @template TReadReturn\n * @template TWriteReturn\n * @param {Ximport('./types.js').AsyncQueue<IteratorResult<TRead, TReadReturn>>} acks\n * @param {Ximport('./types.js').AsyncQueue<IteratorResult<TWrite, TWriteReturn>>} data\n */\nconst        makeStream=(acks,data)=>{\nconst stream=harden({\n/**\n * @param {TWrite} value\n */\nnext(value){\n/* Note the shallow freeze since value is not guaranteed to be freezable*/\n/* (typed arrays are not).*/\ndata.put(freeze({value,done:false}));\nreturn acks.get();\n },\n/**\n * @param {TWriteReturn} value\n */\nreturn(value){\ndata.put(freeze({value,done:true}));\nreturn acks.get();\n },\n/**\n * @param {Error} error\n */\nthrow(error){\ndata.put(harden(Promise.reject(error)));\nreturn acks.get();\n },\n[Symbol.asyncIterator](){\nreturn stream;\n }});\n\nreturn stream;\n };$h‍_once.makeStream(makeStream);\nharden(makeStream);\n\n/* JSDoc TypeScript seems unable to express this particular function's*/\n/* entanglement of queues, but the definition in types.d.ts works for the end*/\n/* user.*/\nconst        makePipe=()=>{\nconst data=makeQueue();\nconst acks=makeQueue();\nconst reader=makeStream(acks,data);\nconst writer=makeStream(data,acks);\nreturn harden([writer,reader]);\n };$h‍_once.makePipe(makePipe);\nharden(makePipe);\n\n/**\n * @template TRead\n * @template TWrite\n * @template TReadReturn\n * @template TWriteReturn\n * @param {Ximport('./types.js').Stream<TWrite, TRead, TWriteReturn, TReadReturn>} writer\n * @param {Ximport('./types.js').Stream<TRead, TWrite, TReadReturn, TWriteReturn>} reader\n * @param {TWrite} primer\n */\nconst        pump=async(writer,reader,primer)=>{\n/** @param {Promise<IteratorResult<TRead, TReadReturn>>} promise */\nconst tick=(promise)=>\nE.when(\npromise,\n(result)=>{\nif(result.done){\nreturn writer.return(result.value);\n }else{\n/* Behold: mutual recursion.*/\n/* eslint-disable-next-line no-use-before-define*/\nreturn tock(writer.next(result.value));\n }\n },\n(/** @type {Error} */error)=>{\nreturn writer.throw(error);\n });\n\n/** @param {Promise<IteratorResult<TWrite, TWriteReturn>>} promise */\nconst tock=(promise)=>\nE.when(\npromise,\n(result)=>{\nif(result.done){\nreturn reader.return(result.value);\n }else{\nreturn tick(reader.next(result.value));\n }\n },\n(/** @type {Error} */error)=>{\nreturn reader.throw(error);\n });\n\nawait tick(reader.next(primer));\nreturn undefined;\n };$h‍_once.pump(pump);\nharden(pump);\n\n/**\n * @template TRead\n * @template TWrite\n * @template TReturn\n * @param {AsyncGenerator<TRead, TReturn, TWrite>} generator\n * @param {TWrite} primer\n */\nconst        prime=(generator,primer)=>{\n/* We capture the first returned promise.*/\nconst first=generator.next(primer);\n/** @type {IteratorResult<TRead, TReturn>=} */\nlet result;\nconst primed=harden({\n/** @param {TWrite} value */\n      async next(value){\nif(result===undefined){\nresult=await first;\nif(result.done){\nreturn result;\n }\n }\nreturn generator.next(value);\n },\n/** @param {TReturn} value */\n      async return(value){\nif(result===undefined){\nresult=await first;\nif(result.done){\nreturn result;\n }\n }\nreturn generator.return(value);\n },\n/** @param {Error} error */\n      async throw(error){\nif(result===undefined){\nresult=await first;\nif(result.done){\nthrow error;\n }\n }\nreturn generator.throw(error);\n }});\n\nreturn primed;\n };$h‍_once.prime(prime);\nharden(prime);\n\n/**\n * @template TIn\n * @template TOut\n * @param {Ximport('./types.js').Reader<TIn>} reader\n * @param {(value: TIn) => TOut} transform\n * @returns {Ximport('./types.js').Reader<TOut>}\n */\nconst        mapReader=(reader,transform)=>{\nasync function*transformGenerator(){\nfor await(const value of reader){\nyield transform(value);\n }\nreturn undefined;\n }\nreturn harden(transformGenerator());\n };$h‍_once.mapReader(mapReader);\nharden(mapReader);\n\n/**\n * @template TIn\n * @template TOut\n * @param {Ximport('./types.js').Writer<TOut>} writer\n * @param {(value: TIn) => TOut} transform\n * @returns {Ximport('./types.js').Writer<TIn>}\n */\nconst        mapWriter=(writer,transform)=>{\nconst transformedWriter=harden({\n/**\n * @param {TIn} value\n */\n      async next(value){\nreturn writer.next(transform(value));\n },\n/**\n * @param {Error} error\n */\n      async throw(error){\nreturn writer.throw(error);\n },\n/**\n * @param {undefined} value\n */\n      async return(value){\nreturn writer.return(value);\n },\n[Symbol.asyncIterator](){\nreturn transformedWriter;\n }});\n\nreturn transformedWriter;\n };$h‍_once.mapWriter(mapWriter);\nharden(mapWriter);\n})\n","__liveExportMap__":{},"__reexportMap__":{},"__fixedExportMap__":{"makeQueue":["makeQueue"],"makeStream":["makeStream"],"makePipe":["makePipe"],"pump":["pump"],"prime":["prime"],"mapReader":["mapReader"],"mapWriter":["mapWriter"]},"__needsImportMeta__":false}